<h1 align="center">Renderlesskit React</h1>

<p align="center">
  Collection of headless components/hooks that are accessible, composable, customizable from low level to build your own UI & Design System powered by <a href="https://reakit.io/">Reakit</a>
System.
<a href="https://renderlesskit-react.vercel.app/"><strong>Explore all components »</strong></a>
</p>

<p align="center">
  <a href="https://npmjs.org/package/@renderlesskit/react"><img alt="NPM version" src="https://img.shields.io/npm/v/@renderlesskit/react.svg" /></a>
  <a href="https://npmjs.org/package/@renderlesskit/react"><img alt="NPM downloads" src="https://img.shields.io/npm/dm/@renderlesskit/react.svg"></a>
  <a href="https://github.com/timelessco/renderlesskit-react/actions"><img alt="Build Status" src="https://github.com/timelessco/renderlesskit-react/workflows/Test/badge.svg?event=push&branch=master" /></a><br/>
  <a href="https://github.com/timelessco/renderlesskit-react/blob/main/LICENSE"><img src="https://img.shields.io/badge/License-MIT-yellow.svg" alt="License">
  </a>
  <a target="_blank" href="https://octo-repo-visualization.vercel.app/?repo=timelessco%2Frenderlesskit-react"><img src="https://img.shields.io/badge/Repo-Visualization-orange" alt="Repo Visualization">
  </a>
</p>

## :rocket: Features

- Accessible :wheelchair:
- Composable :toolbox:
- WAI-ARIA Compatible :spiral_notepad:
- React Hooks Based :anchor:
- Easy To Customize, Style & Extend :nail_care:

## ⚓ Installation

```sh
# npm
npm install @renderlesskit/react reakit

# Yarn
yarn add @renderlesskit/react reakit
```

> Make sure `react react-dom` is installed.

## :beginner: Getting started

Check out our [getting started docs](/docs/getting-started.md)

## 📑 Component Docs

- [Accordion](docs/accordion.md)
- [Breadcrumbs](docs/breadcrumb.md)
- [Calendar](docs/calendar.md)
- [Checkbox](docs/checkbox.md)
- [Date Picker](docs/datepicker.md)
- [Disclosure](docs/disclosure.md)
- [Drawer](docs/drawer.md)
- [Link](docs/link.md)
- [Meter](docs/meter.md)
- [Number Input](docs/number-input.md)
- [Pagination](docs/pagination.md)
- [Picker Base](docs/picker-base.md)
- [Progress](docs/progress.md)
- [Radio](docs/radio.md)
- [Segment](docs/segment.md)
- [Select](docs/select.md)
- [Slider](docs/slider.md)
- [Time Picker](docs/timepicker.md)
- [Toast](docs/toast.md)

> **Note:** As the 0.#.# version number suggests that we are still very much
> work in progress, so semantic versioning will not be followed until a v1
> release. Expect breaking changes to occur on minor version jumps.

## ✨ Contributors

Thanks goes to these wonderful people
([emoji key](https://allcontributors.org/docs/en/emoji-key)):

<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->
<!-- prettier-ignore-start -->
<!-- markdownlint-disable -->
<table>
  <tr>
    <td align="center"><a href="https://navinmoorthy.me/"><img src="https://avatars0.githubusercontent.com/u/39694575?v=4?s=100" width="100px;" alt=""/><br /><sub><b>Navin Moorthy</b></sub></a><br /><a href="https://github.com/timelessco/renderlesskit-react/commits?author=navin-moorthy" title="Code">💻</a></td>
    <td align="center"><a href="http://anuraghazra.github.io/"><img src="https://avatars3.githubusercontent.com/u/35374649?v=4?s=100" width="100px;" alt=""/><br /><sub><b>Anurag Hazra</b></sub></a><br /><a href="https://github.com/timelessco/renderlesskit-react/commits?author=anuraghazra" title="Code">💻</a></td>
    <td align="center"><a href="http://timeless.co/"><img src="https://avatars2.githubusercontent.com/u/6380293?v=4?s=100" width="100px;" alt=""/><br /><sub><b>Sandeep Prabhakaran</b></sub></a><br /><a href="#ideas-sandeepprabhakaran" title="Ideas, Planning, & Feedback">🤔</a></td>
  </tr>
</table>

<!-- markdownlint-restore -->
<!-- prettier-ignore-end -->

<!-- ALL-CONTRIBUTORS-LIST:END -->

This project follows the
[all-contributors](https://github.com/all-contributors/all-contributors)
specification. Contributions of any kind welcome!

## 📋 License

MIT © [Timeless](https://timeless.co/)
