"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useAccordion = exports.Accordion = void 0;

var _reakit = require("reakit");

var _system = require("../system");

var _keys = require("./__keys");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useAccordion = (0, _system.createHook)({
  name: "Accordion",
  compose: _reakit.useComposite,
  keys: _keys.ACCORDION_KEYS,
  useComposeProps: function useComposeProps(options, htmlProps) {
    var compositeHtmlProp = (0, _reakit.useComposite)(options, htmlProps);
    return _objectSpread(_objectSpread({}, compositeHtmlProp), {}, {
      // When none selected i.e, selectedId={null}
      // as per composite https://github.com/reakit/reakit/blob/master/packages/reakit/src/Composite/Composite.ts#L372
      // it applies tabindex={0} which we need to remove it.
      tabIndex: undefined
    });
  }
});
exports.useAccordion = useAccordion;
var Accordion = (0, _system.createComponent)({
  as: "div",
  memo: true,
  useHook: useAccordion
});
exports.Accordion = Accordion;
//# sourceMappingURL=Accordion.js.map