"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useAccordionTrigger = exports.AccordionTrigger = void 0;

var React = _interopRequireWildcard(require("react"));

var _reakit = require("reakit");

var _utils = require("@chakra-ui/utils");

var _system = require("../system");

var _utils2 = require("../utils");

var _keys = require("./__keys");

var _helpers = require("./helpers");

var _excluded = ["onClick", "onKeyDown", "onFocus"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var useAccordionTrigger = (0, _system.createHook)({
  name: "Accordion",
  compose: [_reakit.useButton, _reakit.useCompositeItem],
  keys: _keys.ACCORDION_TRIGGER_KEYS,
  // * Do not add `focusable: true` in useOptions or else the disabled button
  // * will receive the focus & considered as an element in composite navigation
  useProps: function useProps(options, _ref) {
    var htmlOnClick = _ref.onClick,
        htmlOnKeyDown = _ref.onKeyDown,
        htmlOnFocus = _ref.onFocus,
        htmlProps = _objectWithoutProperties(_ref, _excluded);

    var manual = options.manual,
        id = options.id,
        allowToggle = options.allowToggle,
        select = options.select,
        first = options.first,
        last = options.last;
    var selected = (0, _helpers.isAccordionSelected)(options);
    var accordionPanelId = (0, _helpers.useAccordionPanelId)(options);
    var onKeyDown = React.useCallback(function (event) {
      var _first = first && function () {
        return setTimeout(first);
      };

      var _last = last && function () {
        return setTimeout(last);
      };

      var keyMap = {
        Home: _first,
        End: _last
      };
      var action = keyMap[event.key];

      if (action) {
        event.preventDefault();
        event.stopPropagation();
        action();
      }
    }, [first, last]);
    var handleSelection = React.useCallback(function () {
      if (!id) return;
      select === null || select === void 0 ? void 0 : select(id);
    }, [id, select]);
    var onClick = React.useCallback(function () {
      return handleSelection();
    }, [handleSelection]);
    var onFocus = React.useCallback(function () {
      if (manual) return;
      handleSelection();
    }, [manual, handleSelection]);
    return _objectSpread({
      "aria-expanded": selected,
      "aria-controls": accordionPanelId,
      "aria-disabled": (0, _utils2.ariaAttr)(!allowToggle && selected),
      onKeyDown: (0, _utils.callAllHandlers)(htmlOnKeyDown, onKeyDown),
      onClick: (0, _utils.callAllHandlers)(htmlOnClick, onClick),
      onFocus: (0, _utils.callAllHandlers)(htmlOnFocus, onFocus)
    }, htmlProps);
  },
  useComposeProps: function useComposeProps(options, htmlProps) {
    var buttonHtmlProps = (0, _reakit.useButton)(options, htmlProps);
    var compositeHtmlProps = (0, _reakit.useCompositeItem)(options, buttonHtmlProps);
    return _objectSpread(_objectSpread({}, compositeHtmlProps), {}, {
      // *Add the tabIndex = 0 to button to make it tabbable in composite
      tabIndex: 0
    });
  }
});
exports.useAccordionTrigger = useAccordionTrigger;
var AccordionTrigger = (0, _system.createComponent)({
  as: "button",
  memo: true,
  useHook: useAccordionTrigger
});
exports.AccordionTrigger = AccordionTrigger;
//# sourceMappingURL=AccordionTrigger.js.map