"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useBreadcrumbLink = exports.BreadcrumbLink = void 0;

var _link = require("../link");

var _system = require("../system");

var _keys = require("./__keys");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useBreadcrumbLink = (0, _system.createHook)({
  name: "BreadcrumbLink",
  compose: _link.useLink,
  keys: _keys.BREADCRUMB_LINK_KEYS,
  useProps: function useProps(_ref, htmlProps) {
    var isCurrent = _ref.isCurrent;
    return _objectSpread({
      "aria-current": isCurrent && "page"
    }, htmlProps);
  }
});
exports.useBreadcrumbLink = useBreadcrumbLink;
var BreadcrumbLink = (0, _system.createComponent)({
  as: "a",
  memo: true,
  useHook: useBreadcrumbLink
});
exports.BreadcrumbLink = BreadcrumbLink;
//# sourceMappingURL=BreadcrumbLink.js.map