"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useBreadcrumbs = exports.Breadcrumbs = void 0;

var _reakitSystem = require("reakit-system");

var _reakit = require("reakit");

var _reakitWarning = require("reakit-warning");

var useBreadcrumbs = (0, _reakitSystem.createHook)({
  name: "Breadcrumb",
  compose: _reakit.useRole
});
exports.useBreadcrumbs = useBreadcrumbs;
var Breadcrumbs = (0, _reakitSystem.createComponent)({
  as: "nav",
  memo: true,
  useHook: useBreadcrumbs,
  useCreateElement: function useCreateElement(type, props, children) {
    (0, _reakitWarning.useWarning)(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.", "See https://www.w3.org/TR/wai-aria-practices-1.1/#wai-aria-roles-states-and-properties-2");
    return (0, _reakitSystem.useCreateElement)(type, props, children);
  }
});
exports.Breadcrumbs = Breadcrumbs;
//# sourceMappingURL=Breadcrumbs.js.map