"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useCalendar = exports.Calendar = void 0;

var _reakit = require("reakit");

var _system = require("../system");

var _keys = require("./__keys");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useCalendar = (0, _system.createHook)({
  name: "Calendar",
  compose: _reakit.useRole,
  keys: _keys.CALENDAR_KEYS,
  useProps: function useProps(_ref, htmlProps) {
    var calendarId = _ref.calendarId;
    return _objectSpread({
      role: "group",
      "aria-labelledby": calendarId
    }, htmlProps);
  }
});
exports.useCalendar = useCalendar;
var Calendar = (0, _system.createComponent)({
  as: "div",
  memo: true,
  useHook: useCalendar
});
exports.Calendar = Calendar;
//# sourceMappingURL=Calendar.js.map