"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useRangeCalendarState = useRangeCalendarState;

var React = _interopRequireWildcard(require("react"));

var _i18n = require("@react-aria/i18n");

var _utils = require("../utils");

var _LiveAnnouncer = require("../utils/LiveAnnouncer");

var _CalendarState = require("./CalendarState");

var _helpers = require("./helpers");

var _excluded = ["value", "defaultValue", "onChange"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function useRangeCalendarState() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var initialValue = props.value,
      _props$defaultValue = props.defaultValue,
      defaultValue = _props$defaultValue === void 0 ? {
    start: (0, _utils.toUTCString)(new Date()),
    end: (0, _utils.toUTCString)((0, _utils.addDays)(new Date(), 1))
  } : _props$defaultValue,
      onChange = props.onChange,
      calendarProps = _objectWithoutProperties(props, _excluded);

  var _useControllableState = (0, _utils.useControllableState)({
    value: initialValue,
    defaultValue: defaultValue,
    onChange: onChange
  }),
      _useControllableState2 = _slicedToArray(_useControllableState, 2),
      value = _useControllableState2[0],
      setValue = _useControllableState2[1];

  var dateRange = React.useMemo(function () {
    return {
      start: new Date(value.start),
      end: new Date(value.end)
    };
  }, [value.end, value.start]);

  var _React$useState = React.useState(null),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      anchorDate = _React$useState2[0],
      setAnchorDate = _React$useState2[1];

  var _React$useState3 = React.useState(dateRange.end),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      lastSelectedDate = _React$useState4[0],
      setLastSelectedDate = _React$useState4[1];

  var calendar = (0, _CalendarState.useCalendarState)(_objectSpread(_objectSpread({}, calendarProps), {}, {
    value: (0, _utils.toUTCString)(lastSelectedDate)
  }));
  var highlightedRange = anchorDate ? (0, _helpers.makeRange)(anchorDate, calendar.focusedDate) : value && dateRange && (0, _helpers.makeRange)(dateRange.start, dateRange.end);
  var dateFormatter = (0, _i18n.useDateFormatter)({
    dateStyle: "full"
  });
  var announceRange = React.useCallback(function () {
    if (!highlightedRange) return;

    if ((0, _utils.isSameDay)(highlightedRange.start, highlightedRange.end)) {
      (0, _LiveAnnouncer.announce)("Selected range, from ".concat(dateFormatter.format(highlightedRange.start), " to ").concat(dateFormatter.format(highlightedRange.start)));
    } else {
      (0, _LiveAnnouncer.announce)("Selected range from ".concat(dateFormatter.format(highlightedRange.start), " to ").concat(dateFormatter.format(highlightedRange.start)));
    }
  }, [dateFormatter, highlightedRange]);
  var selectDate = React.useCallback(function (date) {
    if (props.isReadOnly) return;
    setLastSelectedDate(date);

    if (!anchorDate) {
      setAnchorDate(date);
      (0, _LiveAnnouncer.announce)("Starting range from ".concat(dateFormatter.format(date)));
    } else {
      setValue((0, _utils.toUTCRangeString)((0, _helpers.makeRange)(anchorDate, date)));
      announceRange();
      setAnchorDate(null);
    }
  }, [anchorDate, announceRange, dateFormatter, props.isReadOnly, setValue]);
  var setDateValue = React.useCallback(function (value) {
    setValue((0, _utils.toUTCRangeString)(value));
  }, [setValue]);
  return _objectSpread(_objectSpread({}, calendar), {}, {
    dateRangeValue: dateRange,
    setDateRangeValue: setDateValue,
    anchorDate: anchorDate,
    setAnchorDate: setAnchorDate,
    highlightedRange: highlightedRange,
    selectDate: selectDate,
    selectFocusedDate: function selectFocusedDate() {
      selectDate(calendar.focusedDate);
    },
    highlightDate: function highlightDate(date) {
      if (!anchorDate) return;
      calendar.setFocusedDate(date);
    },
    isRangeCalendar: true
  });
}
//# sourceMappingURL=RangeCalendarState.js.map