"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useCheckbox = exports.Checkbox = void 0;

var React = _interopRequireWildcard(require("react"));

var _reakit = require("reakit");

var _reakitUtils = require("reakit-utils");

var _reakitWarning = require("reakit-warning");

var _system = require("../system");

var _keys = require("./__keys");

var _helpers = require("./helpers");

var _excluded = ["unstable_clickOnEnter"],
    _excluded2 = ["ref", "onChange", "onClick"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var useCheckbox = (0, _system.createHook)({
  name: "Checkbox",
  compose: _reakit.useClickable,
  keys: _keys.CHECKBOX_KEYS,
  useOptions: function useOptions(options, htmlProps) {
    var _options$unstable_cli = options.unstable_clickOnEnter,
        unstable_clickOnEnter = _options$unstable_cli === void 0 ? false : _options$unstable_cli,
        restOptions = _objectWithoutProperties(options, _excluded);

    var value = htmlProps.value,
        checked = htmlProps.checked;
    return _objectSpread({
      unstable_clickOnEnter: unstable_clickOnEnter,
      value: value,
      checked: (0, _helpers.getChecked)(_objectSpread({
        checked: checked
      }, options))
    }, restOptions);
  },
  useProps: function useProps(options, htmlProps) {
    var state = options.state,
        setState = options.setState,
        value = options.value,
        checked = options.checked,
        disabled = options.disabled;

    var htmlRef = htmlProps.ref,
        htmlOnChange = htmlProps.onChange,
        htmlOnClick = htmlProps.onClick,
        restHtmlProps = _objectWithoutProperties(htmlProps, _excluded2);

    var ref = React.useRef(null);

    var _React$useState = React.useState(true),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        isNativeCheckbox = _React$useState2[0],
        setIsNativeCheckbox = _React$useState2[1];

    var onChangeRef = (0, _reakitUtils.useLiveRef)(htmlOnChange);
    var onClickRef = (0, _reakitUtils.useLiveRef)(htmlOnClick);
    React.useEffect(function () {
      var element = ref.current;

      if (!element) {
        (0, _reakitWarning.warning)(true, "Can't determine whether the element is a native checkbox because `ref` wasn't passed to the component");
        return;
      }

      if (element.tagName !== "INPUT" || element.type !== "checkbox") {
        setIsNativeCheckbox(false);
      }
    }, []);
    (0, _helpers.useIndeterminateState)(ref, options);
    var onChange = React.useCallback(function (event) {
      var element = event.currentTarget;

      if (disabled) {
        event.stopPropagation();
        event.preventDefault();
        return;
      }

      if (onChangeRef.current) {
        // If component is NOT rendered as a native input, it will not have
        // the `checked` property. So we assign it for consistency.
        if (!isNativeCheckbox) {
          element.checked = !element.checked;
        }

        onChangeRef.current(event);
      }

      if (!setState) return;

      if (typeof value === "undefined") {
        setState(!checked);
      } else {
        var stateProp = Array.isArray(state) ? state : [];
        var index = stateProp.indexOf(value);

        if (index === -1) {
          setState([].concat(_toConsumableArray(stateProp), [value]));
        } else {
          setState((0, _reakitUtils.removeIndexFromArray)(stateProp, index));
        }
      }
    }, [disabled, onChangeRef, setState, value, isNativeCheckbox, checked, state]);
    var onClick = React.useCallback(function (event) {
      var _onClickRef$current;

      (_onClickRef$current = onClickRef.current) === null || _onClickRef$current === void 0 ? void 0 : _onClickRef$current.call(onClickRef, event);
      if (event.defaultPrevented) return;
      if (isNativeCheckbox) return;
      (0, _helpers.fireChange)(event.currentTarget, onChange);
    }, [isNativeCheckbox, onChange, onClickRef]);
    return _objectSpread({
      ref: (0, _reakitUtils.useForkRef)(ref, htmlRef),
      role: !isNativeCheckbox ? "checkbox" : undefined,
      type: isNativeCheckbox ? "checkbox" : undefined,
      value: isNativeCheckbox ? value : undefined,
      checked: checked,
      "aria-checked": state === "indeterminate" ? "mixed" : checked,
      onChange: onChange,
      onClick: onClick
    }, restHtmlProps);
  }
});
exports.useCheckbox = useCheckbox;
var Checkbox = (0, _system.createComponent)({
  as: "input",
  memo: true,
  useHook: useCheckbox
});
exports.Checkbox = Checkbox;
//# sourceMappingURL=Checkbox.js.map