"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fireChange = fireChange;
exports.getChecked = getChecked;
exports.useIndeterminateState = useIndeterminateState;

var React = _interopRequireWildcard(require("react"));

var _reakitUtils = require("reakit-utils");

var _reakitWarning = require("reakit-warning");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function getChecked(options) {
  var checked = options.checked,
      value = options.value,
      state = options.state;
  if (typeof checked !== "undefined") return checked;
  if (typeof value === "undefined") return !!state;
  var stateProp = Array.isArray(state) ? state : [];
  return stateProp.indexOf(value) !== -1;
}

function fireChange(element, onChange) {
  var event = (0, _reakitUtils.createEvent)(element, "change");
  Object.defineProperties(event, {
    type: {
      value: "change"
    },
    target: {
      value: element
    },
    currentTarget: {
      value: element
    }
  });
  onChange === null || onChange === void 0 ? void 0 : onChange(event);
}

function useIndeterminateState(ref, options) {
  var state = options.state;
  React.useEffect(function () {
    var element = ref.current;

    if (!element) {
      (0, _reakitWarning.warning)(state === "indeterminate", "Can't set indeterminate state because `ref` wasn't passed to component.");
      return;
    }

    if (state === "indeterminate") {
      element.indeterminate = true;
    } else if (element.indeterminate) {
      element.indeterminate = false;
    }
  }, [state, ref]);
}
//# sourceMappingURL=helpers.js.map