"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useDatePickerState = void 0;

var React = _interopRequireWildcard(require("react"));

var _calendar = require("../calendar");

var _pickerBase = require("../picker-base");

var _segment = require("../segment");

var _utils = require("../utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useDatePickerState = function useDatePickerState() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var initialValue = props.value,
      _props$defaultValue = props.defaultValue,
      defaultValue = _props$defaultValue === void 0 ? (0, _utils.toUTCString)(new Date()) : _props$defaultValue,
      onChange = props.onChange,
      minValue = props.minValue,
      maxValue = props.maxValue,
      isRequired = props.isRequired,
      autoFocus = props.autoFocus,
      formatOptions = props.formatOptions,
      placeholderDate = props.placeholderDate;

  var _useControllableState = (0, _utils.useControllableState)({
    value: initialValue,
    defaultValue: defaultValue,
    onChange: onChange
  }),
      _useControllableState2 = _slicedToArray(_useControllableState, 2),
      value = _useControllableState2[0],
      setValue = _useControllableState2[1];

  var date = new Date(value);

  var setDate = function setDate(date) {
    return setValue((0, _utils.toUTCString)(date));
  };

  var minDateValue = minValue ? new Date(minValue) : new Date(-864e13);
  var maxDateValue = maxValue ? new Date(maxValue) : new Date(864e13);
  var segmentState = (0, _segment.useSegmentState)({
    value: date,
    onChange: setDate,
    formatOptions: formatOptions,
    placeholderDate: placeholderDate
  });
  var popover = (0, _pickerBase.usePickerBaseState)(_objectSpread({
    segmentFocus: segmentState.first
  }, props));

  var selectDate = function selectDate(newValue) {
    setValue(newValue);
    popover.hide();
  };

  var calendar = (0, _calendar.useCalendarState)({
    value: value,
    onChange: selectDate,
    minValue: minValue,
    maxValue: maxValue
  });
  var validationState = props.validationState || (isInvalidDateRange(date) ? "invalid" : "valid");
  React.useEffect(function () {
    if (popover.visible) {
      calendar.setFocused(true);
      calendar.focusCell(date);
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [popover.visible]);
  React.useEffect(function () {
    if (autoFocus) {
      segmentState.first();
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [autoFocus, segmentState.first]);

  function isInvalidDateRange(value) {
    var min = new Date(minDateValue);
    var max = new Date(maxDateValue);
    return value < min || value > max;
  }

  return _objectSpread(_objectSpread(_objectSpread({
    dateValue: value,
    setDateValue: setValue,
    selectDate: selectDate,
    validationState: validationState,
    minValue: minValue,
    maxValue: maxValue,
    isRequired: isRequired
  }, popover), segmentState), {}, {
    calendar: calendar,
    isDateRangePicker: false
  });
};

exports.useDatePickerState = useDatePickerState;
//# sourceMappingURL=DatePickerState.js.map