"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useDialog = exports.Dialog = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactRemoveScroll = require("react-remove-scroll");

var _reakitSystem = require("reakit-system");

var _reakit = require("reakit");

var _reakitUtils = require("reakit-utils");

var _reakitWarning = require("reakit-warning");

var _disclosure = require("../disclosure");

var _keys = require("./__keys");

var _helpers = require("./helpers");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["modal", "hideOnEsc", "hideOnClickOutside", "preventBodyScroll", "unstable_autoFocusOnShow", "unstable_autoFocusOnHide", "unstable_orphan"],
    _excluded2 = ["ref", "onKeyDown", "onBlur", "wrapElement", "tabIndex"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var useDialog = (0, _reakitSystem.createHook)({
  name: "Dialog",
  compose: _disclosure.useDisclosureContent,
  keys: _keys.DIALOG_KEYS,
  useOptions: function useOptions(options) {
    var _options$modal = options.modal,
        modal = _options$modal === void 0 ? true : _options$modal,
        _options$hideOnEsc = options.hideOnEsc,
        hideOnEsc = _options$hideOnEsc === void 0 ? true : _options$hideOnEsc,
        _options$hideOnClickO = options.hideOnClickOutside,
        hideOnClickOutside = _options$hideOnClickO === void 0 ? true : _options$hideOnClickO,
        _options$preventBodyS = options.preventBodyScroll,
        preventBodyScroll = _options$preventBodyS === void 0 ? modal : _options$preventBodyS,
        _options$unstable_aut = options.unstable_autoFocusOnShow,
        unstable_autoFocusOnShow = _options$unstable_aut === void 0 ? true : _options$unstable_aut,
        _options$unstable_aut2 = options.unstable_autoFocusOnHide,
        unstable_autoFocusOnHide = _options$unstable_aut2 === void 0 ? true : _options$unstable_aut2,
        unstable_orphan = options.unstable_orphan,
        restOptions = _objectWithoutProperties(options, _excluded);

    return _objectSpread({
      modal: modal,
      hideOnEsc: hideOnEsc,
      hideOnClickOutside: hideOnClickOutside,
      preventBodyScroll: modal && preventBodyScroll,
      unstable_autoFocusOnShow: unstable_autoFocusOnShow,
      unstable_autoFocusOnHide: unstable_autoFocusOnHide,
      unstable_orphan: modal && unstable_orphan
    }, restOptions);
  },
  useProps: function useProps(options, htmlProps) {
    var preventBodyScroll = options.preventBodyScroll,
        baseId = options.baseId,
        hideOnEsc = options.hideOnEsc,
        hide = options.hide,
        optionsModal = options.modal;

    var htmlRef = htmlProps.ref,
        htmlOnKeyDown = htmlProps.onKeyDown,
        htmlOnBlur = htmlProps.onBlur,
        htmlWrapElement = htmlProps.wrapElement,
        tabIndex = htmlProps.tabIndex,
        restHtmlProps = _objectWithoutProperties(htmlProps, _excluded2);

    var dialog = React.useRef(null);
    var backdrop = React.useContext(_helpers.DialogBackdropContext);
    var hasBackdrop = backdrop && backdrop === baseId;
    var disclosure = (0, _helpers.useDisclosureRef)(dialog, options);
    var onKeyDownRef = (0, _reakitUtils.useLiveRef)(htmlOnKeyDown);
    var onBlurRef = (0, _reakitUtils.useLiveRef)(htmlOnBlur);
    var focusOnBlur = (0, _helpers.useFocusOnBlur)(dialog, options);

    var _useNestedDialogs = (0, _helpers.useNestedDialogs)(dialog, options),
        dialogs = _useNestedDialogs.dialogs,
        visibleModals = _useNestedDialogs.visibleModals,
        wrap = _useNestedDialogs.wrap; // VoiceOver/Safari accepts only one `aria-modal` container, so if there
    // are visible child modals, then we don't want to set aria-modal on the
    // parent modal (this component).


    var modal = optionsModal && !visibleModals.length ? true : undefined;
    (0, _helpers.useFocusTrap)(dialog, visibleModals, options);
    (0, _helpers.useFocusOnChildUnmount)(dialog, options);
    (0, _helpers.useFocusOnShow)(dialog, dialogs, options);
    (0, _helpers.useFocusOnHide)(dialog, disclosure, options);
    (0, _helpers.useHideOnClickOutside)(dialog, disclosure, dialogs, options);
    (0, _helpers.useDisableHoverOutside)(dialog, dialogs, options);
    var onKeyDown = React.useCallback(function (event) {
      var _onKeyDownRef$current;

      (_onKeyDownRef$current = onKeyDownRef.current) === null || _onKeyDownRef$current === void 0 ? void 0 : _onKeyDownRef$current.call(onKeyDownRef, event);
      if (event.defaultPrevented) return;
      if (event.key !== "Escape") return;
      if (!hideOnEsc) return;

      if (!hide) {
        (0, _reakitWarning.warning)(true, "`hideOnEsc` prop is truthy, but `hide` prop wasn't provided.", dialog.current);
        return;
      }

      event.stopPropagation();
      hide();
    }, [onKeyDownRef, hideOnEsc, hide]);
    var onBlur = React.useCallback(function (event) {
      var _onBlurRef$current;

      (_onBlurRef$current = onBlurRef.current) === null || _onBlurRef$current === void 0 ? void 0 : _onBlurRef$current.call(onBlurRef, event);
      focusOnBlur(event);
    }, [focusOnBlur, onBlurRef]);
    var wrapElement = React.useCallback(function (element) {
      element = wrap(element);

      if (optionsModal && !hasBackdrop) {
        if (preventBodyScroll) {
          element = /*#__PURE__*/(0, _jsxRuntime.jsx)(_reakit.Portal, {
            children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactRemoveScroll.RemoveScroll, {
              children: element
            })
          });
        } else {
          element = /*#__PURE__*/(0, _jsxRuntime.jsx)(_reakit.Portal, {
            children: element
          });
        }
      }

      if (htmlWrapElement) {
        element = htmlWrapElement(element);
      } // return (
      //   // Prevents Menu > Dialog > Menu to behave as a sub menu
      //   <MenuContext.Provider value={null}>{element}</MenuContext.Provider>
      // );


      return element;
    }, [wrap, optionsModal, hasBackdrop, htmlWrapElement, preventBodyScroll]);
    return _objectSpread({
      ref: (0, _reakitUtils.useForkRef)(dialog, htmlRef),
      role: "dialog",
      tabIndex: tabIndex !== null && tabIndex !== void 0 ? tabIndex : -1,
      "aria-modal": modal,
      "data-dialog": true,
      onKeyDown: onKeyDown,
      onBlur: onBlur,
      wrapElement: wrapElement
    }, restHtmlProps);
  }
});
exports.useDialog = useDialog;
var Dialog = (0, _reakitSystem.createComponent)({
  as: "div",
  useHook: useDialog,
  useCreateElement: function useCreateElement(type, props, children) {
    (0, _reakitWarning.useWarning)(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.");
    return (0, _reakitSystem.useCreateElement)(type, props, children);
  }
});
exports.Dialog = Dialog;
//# sourceMappingURL=Dialog.js.map