"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useDialogBackdrop = exports.DialogBackdrop = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactRemoveScroll = require("react-remove-scroll");

var _reakit = require("reakit");

var _DisclosureContent = require("../disclosure/DisclosureContent");

var _system = require("../system");

var _keys = require("./__keys");

var _helpers = require("./helpers");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["modal", "preventBodyScroll"],
    _excluded2 = ["wrapElement"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var useDialogBackdrop = (0, _system.createHook)({
  name: "DialogBackdrop",
  compose: _DisclosureContent.useDisclosureContent,
  keys: _keys.DIALOG_BACKDROP_KEYS,
  useOptions: function useOptions(_ref) {
    var _ref$modal = _ref.modal,
        modal = _ref$modal === void 0 ? true : _ref$modal,
        _ref$preventBodyScrol = _ref.preventBodyScroll,
        preventBodyScroll = _ref$preventBodyScrol === void 0 ? modal : _ref$preventBodyScrol,
        options = _objectWithoutProperties(_ref, _excluded);

    return _objectSpread({
      modal: modal,
      preventBodyScroll: modal && preventBodyScroll
    }, options);
  },
  useProps: function useProps(options, htmlProps) {
    var modal = options.modal,
        baseId = options.baseId,
        preventBodyScroll = options.preventBodyScroll;

    var htmlWrapElement = htmlProps.wrapElement,
        restHtmlProps = _objectWithoutProperties(htmlProps, _excluded2);

    var wrapElement = React.useCallback(function (element) {
      if (modal) {
        if (preventBodyScroll) {
          element = /*#__PURE__*/(0, _jsxRuntime.jsx)(_reakit.Portal, {
            children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_helpers.DialogBackdropContext.Provider, {
              value: baseId,
              children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactRemoveScroll.RemoveScroll, {
                children: element
              })
            })
          });
        } else {
          element = /*#__PURE__*/(0, _jsxRuntime.jsx)(_reakit.Portal, {
            children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_helpers.DialogBackdropContext.Provider, {
              value: baseId,
              children: element
            })
          });
        }
      }

      if (htmlWrapElement) {
        return htmlWrapElement(element);
      }

      return element;
    }, [modal, htmlWrapElement, preventBodyScroll, baseId]);
    return _objectSpread({
      id: undefined,
      "data-dialog-ref": baseId,
      wrapElement: wrapElement
    }, restHtmlProps);
  }
});
exports.useDialogBackdrop = useDialogBackdrop;
var DialogBackdrop = (0, _system.createComponent)({
  as: "div",
  memo: true,
  useHook: useDialogBackdrop
});
exports.DialogBackdrop = DialogBackdrop;
//# sourceMappingURL=DialogBackdrop.js.map