"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useDisclosure = exports.disclosureComposableButton = exports.Disclosure = void 0;

var _react = _interopRequireDefault(require("react"));

var _reakitSystem = require("reakit-system");

var _reakit = require("reakit");

var _reakitUtils = require("reakit-utils");

var _system = require("../system");

var _keys = require("./__keys");

var _excluded = ["onClick", "aria-controls"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var disclosureComposableButton = (0, _system.createComposableHook)({
  name: "Disclosure",
  compose: _reakit.useButton,
  keys: _keys.DISCLOSURE_KEYS,
  useProps: function useProps(options, htmlProps) {
    var toggle = options.toggle,
        visible = options.visible,
        baseId = options.baseId;

    var htmlOnClick = htmlProps.onClick,
        ariaControls = htmlProps["aria-controls"],
        restHtmlProps = _objectWithoutProperties(htmlProps, _excluded);

    var controls = ariaControls ? "".concat(ariaControls, " ").concat(baseId) : baseId;
    var onClickRef = (0, _reakitUtils.useLiveRef)(htmlOnClick);

    var onClick = _react.default.useCallback(function (event) {
      var _onClickRef$current;

      (_onClickRef$current = onClickRef.current) === null || _onClickRef$current === void 0 ? void 0 : _onClickRef$current.call(onClickRef, event);
      if (event.defaultPrevented) return;
      toggle === null || toggle === void 0 ? void 0 : toggle();
    }, [onClickRef, toggle]);

    return _objectSpread({
      "aria-controls": controls,
      "aria-expanded": visible,
      "data-enter": visible ? "" : undefined,
      "data-leave": !visible ? "" : undefined,
      onClick: onClick
    }, restHtmlProps);
  }
});
exports.disclosureComposableButton = disclosureComposableButton;
var useDisclosure = disclosureComposableButton();
exports.useDisclosure = useDisclosure;
var Disclosure = (0, _reakitSystem.createComponent)({
  as: "button",
  memo: true,
  useHook: useDisclosure
});
exports.Disclosure = Disclosure;
//# sourceMappingURL=Disclosure.js.map