"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useDisclosureCollapseContent = exports.disclosureCollapseComposableContent = exports.DisclosureCollapseContent = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _reakitSystem = require("reakit-system");

var _reakit = require("reakit");

var _reakitUtils = require("reakit-utils");

var _raf = _interopRequireDefault(require("raf"));

var _system = require("../system");

var _keys = require("./__keys");

var _helpers = require("./helpers");

var _excluded = ["direction", "contentSize", "easing"],
    _excluded2 = ["ref", "style", "onTransitionEnd"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var disclosureCollapseComposableContent = (0, _system.createComposableHook)({
  name: "DisclosureCollapseContent",
  compose: _reakit.useBox,
  keys: _keys.DISCLOSURE_COLLAPSE_CONTENT_KEYS,
  useOptions: function useOptions(options, htmlProps) {
    var _options$direction = options.direction,
        direction = _options$direction === void 0 ? "vertical" : _options$direction,
        _options$contentSize = options.contentSize,
        contentSize = _options$contentSize === void 0 ? 0 : _options$contentSize,
        _options$easing = options.easing,
        easing = _options$easing === void 0 ? "cubic-bezier(0.4, 0, 0.2, 1)" : _options$easing,
        restOptions = _objectWithoutProperties(options, _excluded);

    return _objectSpread({
      direction: direction,
      contentSize: contentSize,
      easing: easing
    }, restOptions);
  },
  useProps: function useProps(options, htmlProps) {
    var contentSize = options.contentSize,
        visible = options.visible,
        direction = options.direction,
        duration = options.duration,
        easing = options.easing,
        onCollapseEnd = options.onCollapseEnd,
        onCollapseStart = options.onCollapseStart,
        onExpandEnd = options.onExpandEnd,
        onExpandStart = options.onExpandStart;

    var htmlRef = htmlProps.ref,
        htmlStyle = htmlProps.style,
        htmlOnTransitionEnd = htmlProps.onTransitionEnd,
        restHtmlProps = _objectWithoutProperties(htmlProps, _excluded2);

    var ref = React.useRef(null);
    var onTransitionEndRef = (0, _reakitUtils.useLiveRef)(htmlOnTransitionEnd);
    var isVertical = direction === "vertical";
    var currentSize = isVertical ? "height" : "width";
    var getCurrentSizeStyle = React.useCallback(function (size) {
      return _defineProperty({}, currentSize, "".concat(size, "px"));
    }, [currentSize]);
    var collapsedStyles = React.useMemo(function () {
      return _objectSpread(_objectSpread({}, getCurrentSizeStyle(contentSize)), {}, {
        overflow: "hidden"
      });
    }, [contentSize, getCurrentSizeStyle]);

    var _React$useState = React.useState(visible ? {} : collapsedStyles),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        styles = _React$useState2[0],
        setStylesRaw = _React$useState2[1];

    var setStyles = function setStyles(newStyles) {
      // We rely on reading information from layout
      // at arbitrary times, so ensure all style changes
      // happen before we might attempt to read them.
      (0, _reactDom.flushSync)(function () {
        setStylesRaw(newStyles);
      });
    };

    var mergeStyles = React.useCallback(function (newStyles) {
      setStyles(function (oldStyles) {
        return _objectSpread(_objectSpread({}, oldStyles), newStyles);
      });
    }, []);

    function getTransitionStyles(size) {
      var _duration = duration || (0, _helpers.getAutoSizeDuration)(size);

      return {
        transition: "".concat(currentSize, " ").concat(_duration, "ms ").concat(easing)
      };
    }

    (0, _reakitUtils.useUpdateEffect)(function () {
      if (visible) {
        (0, _raf.default)(function () {
          onExpandStart === null || onExpandStart === void 0 ? void 0 : onExpandStart();
          mergeStyles({
            willChange: "".concat(currentSize),
            overflow: "hidden"
          });
          (0, _raf.default)(function () {
            var size = isVertical ? (0, _helpers.getElementHeight)(ref) : (0, _helpers.getElementWidth)(ref);
            mergeStyles(_objectSpread(_objectSpread({}, getTransitionStyles(size)), isVertical ? {
              height: size
            } : {
              width: size
            }));
          });
        });
      } else {
        (0, _raf.default)(function () {
          onCollapseStart === null || onCollapseStart === void 0 ? void 0 : onCollapseStart();
          var size = isVertical ? (0, _helpers.getElementHeight)(ref) : (0, _helpers.getElementWidth)(ref);
          mergeStyles(_objectSpread(_objectSpread({
            willChange: "".concat(currentSize)
          }, isVertical ? {
            height: size
          } : {
            width: size
          }), getTransitionStyles(size)));
          (0, _raf.default)(function () {
            mergeStyles(_objectSpread(_objectSpread({}, getCurrentSizeStyle(contentSize)), {}, {
              overflow: "hidden"
            }));
          });
        });
      }
    }, [visible]);
    var onTransitionEnd = React.useCallback(function (event) {
      var _onTransitionEndRef$c;

      (_onTransitionEndRef$c = onTransitionEndRef.current) === null || _onTransitionEndRef$c === void 0 ? void 0 : _onTransitionEndRef$c.call(onTransitionEndRef, event);
      if (event.defaultPrevented) return; // Sometimes onTransitionEnd is triggered by another transition,
      // such as a nested collapse panel transitioning. But we only
      // want to handle this if this component's element is transitioning

      if (event.target !== ref.current || event.propertyName !== currentSize) {
        return;
      } // The height comparisons below are a final check before
      // completing the transition
      // Sometimes this callback is run even though we've already begun
      // transitioning the other direction
      // The conditions give us the opportunity to bail out,
      // which will prevent the collapsed content from flashing on the screen


      var stylesSize = isVertical ? styles.height : styles.width;

      if (visible) {
        var size = isVertical ? (0, _helpers.getElementHeight)(ref) : (0, _helpers.getElementWidth)(ref); // If the height at the end of the transition
        // matches the height we're animating to,

        if (size === stylesSize) {
          setStyles({});
        } else {
          // If the heights don't match, this could be due the height
          // of the content changing mid-transition
          mergeStyles(_objectSpread({}, getCurrentSizeStyle(contentSize)));
        }

        onExpandEnd === null || onExpandEnd === void 0 ? void 0 : onExpandEnd(); // If the height we should be animating to matches the collapsed height,
        // it's safe to apply the collapsed overrides
      } else if (stylesSize === "".concat(contentSize, "px")) {
        setStyles(collapsedStyles);
        onCollapseEnd === null || onCollapseEnd === void 0 ? void 0 : onCollapseEnd();
      }
    }, [onTransitionEndRef, currentSize, isVertical, styles.height, styles.width, visible, contentSize, onExpandEnd, mergeStyles, getCurrentSizeStyle, collapsedStyles, onCollapseEnd]);

    var style = _objectSpread(_objectSpread({}, styles), htmlStyle);

    return _objectSpread({
      ref: (0, _reakitUtils.useForkRef)(ref, htmlRef),
      id: options.baseId,
      "aria-hidden": !visible,
      style: style,
      onTransitionEnd: onTransitionEnd
    }, restHtmlProps);
  }
});
exports.disclosureCollapseComposableContent = disclosureCollapseComposableContent;
var useDisclosureCollapseContent = disclosureCollapseComposableContent();
exports.useDisclosureCollapseContent = useDisclosureCollapseContent;
var DisclosureCollapseContent = (0, _reakitSystem.createComponent)({
  as: "div",
  memo: true,
  useHook: useDisclosureCollapseContent
});
exports.DisclosureCollapseContent = DisclosureCollapseContent;
//# sourceMappingURL=DisclosureCollapseContent.js.map