"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useDisclosureContent = exports.disclosureComposableContent = exports.DisclosureContent = void 0;

var React = _interopRequireWildcard(require("react"));

var _reakitSystem = require("reakit-system");

var _reakit = require("reakit");

var _reakitUtils = require("reakit-utils");

var _system = require("../system");

var _keys = require("./__keys");

var _helpers = require("./helpers");

var _excluded = ["visible", "animationPresent"],
    _excluded2 = ["style", "onTransitionEnd", "onAnimationEnd"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var disclosureComposableContent = (0, _system.createComposableHook)({
  name: "DisclosureContent",
  compose: _reakit.useBox,
  keys: _keys.DISCLOSURE_CONTENT_KEYS,
  useOptions: function useOptions(options, htmlProps) {
    var visible = options.visible,
        _options$animationPre = options.animationPresent,
        animationPresent = _options$animationPre === void 0 ? false : _options$animationPre,
        restOptions = _objectWithoutProperties(options, _excluded);

    var _useAnimation = (0, _helpers.useAnimation)({
      visible: visible
    }),
        state = _useAnimation.state,
        animating = _useAnimation.animating,
        onEnd = _useAnimation.onEnd;

    var isVisible = visible && animating;
    var isHidden = !visible && !animating;
    return _objectSpread(_objectSpread({
      animationPresent: animationPresent,
      visible: visible
    }, restOptions), {}, {
      isVisible: isVisible,
      isHidden: isHidden,
      state: state,
      animating: animating,
      onEnd: onEnd
    });
  },
  useProps: function useProps(options, htmlProps) {
    var baseId = options.baseId,
        onEnd = options.onEnd,
        isHidden = options.isHidden,
        isVisible = options.isVisible,
        state = options.state,
        animationPresent = options.animationPresent;

    var htmlStyle = htmlProps.style,
        htmlOnTransitionEnd = htmlProps.onTransitionEnd,
        htmlOnAnimationEnd = htmlProps.onAnimationEnd,
        restHtmlProps = _objectWithoutProperties(htmlProps, _excluded2);

    var onTransitionEndRef = (0, _reakitUtils.useLiveRef)(htmlOnTransitionEnd);
    var onAnimationEndRef = (0, _reakitUtils.useLiveRef)(htmlOnAnimationEnd);
    var onTransitionEnd = React.useCallback(function (event) {
      var _onTransitionEndRef$c;

      (_onTransitionEndRef$c = onTransitionEndRef.current) === null || _onTransitionEndRef$c === void 0 ? void 0 : _onTransitionEndRef$c.call(onTransitionEndRef, event);
      onEnd === null || onEnd === void 0 ? void 0 : onEnd(event);
    }, [onEnd, onTransitionEndRef]);
    var onAnimationEnd = React.useCallback(function (event) {
      var _onAnimationEndRef$cu;

      (_onAnimationEndRef$cu = onAnimationEndRef.current) === null || _onAnimationEndRef$cu === void 0 ? void 0 : _onAnimationEndRef$cu.call(onAnimationEndRef, event);
      onEnd === null || onEnd === void 0 ? void 0 : onEnd(event);
    }, [onAnimationEndRef, onEnd]);

    var style = _objectSpread({
      display: isHidden ? "none" : undefined
    }, htmlStyle);

    return _objectSpread({
      id: baseId,
      hidden: isHidden,
      "data-enter": animationPresent ? isVisible ? "" : undefined : state === "enter" ? "" : undefined,
      "data-leave": state === "leave" ? "" : undefined,
      onTransitionEnd: onTransitionEnd,
      onAnimationEnd: onAnimationEnd,
      style: style
    }, restHtmlProps);
  }
});
exports.disclosureComposableContent = disclosureComposableContent;
var useDisclosureContent = disclosureComposableContent();
exports.useDisclosureContent = useDisclosureContent;
var DisclosureContent = (0, _reakitSystem.createComponent)({
  as: "div",
  memo: true,
  useHook: useDisclosureContent
});
exports.DisclosureContent = DisclosureContent;
//# sourceMappingURL=DisclosureContent.js.map