"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useDrawer = exports.Drawer = void 0;

var _dialog = require("../dialog");

var _system = require("../system");

var _keys = require("./__keys");

var _excluded = ["style"];

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useDrawer = (0, _system.createHook)({
  name: "Drawer",
  compose: _dialog.useDialog,
  keys: _keys.DRAWER_KEYS,
  useOptions: function useOptions(options, htmlProps) {
    var _options$placement = options.placement,
        placement = _options$placement === void 0 ? "left" : _options$placement;
    return _objectSpread(_objectSpread({}, options), {}, {
      placement: placement
    });
  },
  useProps: function useProps(options, htmlProps) {
    var placement = options.placement;

    var htmlStyles = htmlProps.style,
        restHtmlProps = _objectWithoutProperties(htmlProps, _excluded);

    return _objectSpread({
      style: _objectSpread(_objectSpread({}, PLACEMENTS[placement]), {}, {
        position: "fixed"
      }, htmlStyles)
    }, restHtmlProps);
  }
});
exports.useDrawer = useDrawer;
var Drawer = (0, _system.createComponent)({
  as: "div",
  useHook: useDrawer
});
exports.Drawer = Drawer;
var PLACEMENTS = {
  left: {
    left: 0,
    top: 0,
    bottom: 0,
    height: "100vh"
  },
  right: {
    right: 0,
    top: 0,
    bottom: 0,
    height: "100vh"
  },
  top: {
    right: 0,
    left: 0,
    top: 0,
    width: "100vw"
  },
  bottom: {
    right: 0,
    left: 0,
    bottom: 0,
    width: "100vw"
  }
};
//# sourceMappingURL=Drawer.js.map