"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useNumberInputIncrementButton = exports.NumberInputIncrementButton = void 0;

var React = _interopRequireWildcard(require("react"));

var _reakit = require("reakit");

var _utils = require("@chakra-ui/utils");

var _system = require("../system");

var _keys = require("./__keys");

var _excluded = ["onMouseDown", "onMouseUp", "onMouseLeave", "onTouchStart", "onTouchEnd"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useNumberInputIncrementButton = (0, _system.createHook)({
  name: "NumberInput",
  compose: _reakit.useButton,
  keys: _keys.NUMBER_INPUT_INCREMENT_BUTTON_KEYS,
  useOptions: function useOptions(options) {
    var keepWithinRange = options.keepWithinRange,
        isAtMax = options.isAtMax;
    var disabled = options.disabled || keepWithinRange && isAtMax || options.isDisabled;
    return _objectSpread(_objectSpread({}, options), {}, {
      disabled: disabled
    });
  },
  useProps: function useProps(options, _ref) {
    var onMouseDown = _ref.onMouseDown,
        onMouseUp = _ref.onMouseUp,
        onMouseLeave = _ref.onMouseLeave,
        onTouchStart = _ref.onTouchStart,
        onTouchEnd = _ref.onTouchEnd,
        htmlProps = _objectWithoutProperties(_ref, _excluded);

    var spinUpProp = options.spinUp,
        spinStopProp = options.spinStop,
        focusInput = options.focusInput;
    var spinUp = React.useCallback(function (event) {
      event.preventDefault();
      spinUpProp();
      focusInput();
    }, [focusInput, spinUpProp]);
    var spinStop = React.useCallback(function (event) {
      event.preventDefault();
      spinStopProp();
    }, [spinStopProp]);
    React.useEffect(function () {
      // Need to stop the spinner when isAtMax
      if (options.disabled) spinStopProp();
    }, [options.disabled, spinStopProp]);
    return _objectSpread({
      "aria-hidden": true,
      tabIndex: -1,
      onMouseDown: (0, _utils.callAllHandlers)(onMouseDown, spinUp),
      onTouchStart: (0, _utils.callAllHandlers)(onTouchStart, spinUp),
      onMouseUp: (0, _utils.callAllHandlers)(onMouseUp, spinStop),
      onMouseLeave: (0, _utils.callAllHandlers)(onMouseLeave, spinStop),
      onTouchEnd: (0, _utils.callAllHandlers)(onTouchEnd, spinStop)
    }, htmlProps);
  }
});
exports.useNumberInputIncrementButton = useNumberInputIncrementButton;
var NumberInputIncrementButton = (0, _system.createComponent)({
  as: "button",
  memo: true,
  useHook: useNumberInputIncrementButton
});
exports.NumberInputIncrementButton = NumberInputIncrementButton;
//# sourceMappingURL=NumberInputIncrementButton.js.map