"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.usePaginationButton = exports.PaginationButton = void 0;

var React = _interopRequireWildcard(require("react"));

var _reakit = require("reakit");

var _utils = require("@chakra-ui/utils");

var _system = require("../system");

var _keys = require("./__keys");

var _excluded = ["onClick"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var usePaginationButton = (0, _system.createHook)({
  name: "PaginationButton",
  compose: _reakit.useButton,
  keys: _keys.PAGINATION_BUTTON_KEYS,
  useOptions: function useOptions(options, _ref) {
    var htmlDisabled = _ref.disabled;
    var goto = options.goto,
        isAtLastPage = options.isAtLastPage,
        isAtFirstPage = options.isAtFirstPage;
    var disabled = false;

    if (goto === "nextPage" || goto === "lastPage") {
      disabled = isAtLastPage;
    }

    if (goto === "prevPage" || goto === "firstPage") {
      disabled = isAtFirstPage;
    }

    return _objectSpread({
      disabled: htmlDisabled || disabled
    }, options);
  },
  useProps: function useProps(options, _ref2) {
    var htmlOnClick = _ref2.onClick,
        htmlProps = _objectWithoutProperties(_ref2, _excluded);

    var currentPage = options.currentPage,
        goto = options.goto;
    var isCurrent = currentPage === goto;
    var onClick = React.useCallback(function () {
      if (options.disabled) return;

      if ((0, _utils.isNumber)(goto)) {
        var _options$movePage;

        (_options$movePage = options.movePage) === null || _options$movePage === void 0 ? void 0 : _options$movePage.call(options, goto);
        return;
      }

      if (["nextPage", "prevPage", "lastPage", "firstPage"].includes(goto)) {
        var _options$goto;

        (_options$goto = options[goto]) === null || _options$goto === void 0 ? void 0 : _options$goto.call(options);
        return;
      }
    }, [goto, options]);
    var ariaLabel = isCurrent ? "Page ".concat(goto) : "Go to ".concat(goto === "prevPage" ? "previous" : goto, " Page");
    return _objectSpread({
      "aria-label": ariaLabel,
      "aria-current": isCurrent ? true : undefined,
      onClick: (0, _utils.callAllHandlers)(onClick, htmlOnClick)
    }, htmlProps);
  }
});
exports.usePaginationButton = usePaginationButton;
var PaginationButton = (0, _system.createComponent)({
  as: "button",
  memo: true,
  useHook: usePaginationButton
});
exports.PaginationButton = PaginationButton;
//# sourceMappingURL=PaginationButton.js.map