"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.usePickerBase = exports.PickerBase = void 0;

var React = _interopRequireWildcard(require("react"));

var _reakit = require("reakit");

var _reakitUtils = require("reakit-utils");

var _utils = require("@chakra-ui/utils");

var _system = require("../system");

var _utils2 = require("../utils");

var _keys = require("./__keys");

var _excluded = ["onKeyDown", "onClick", "onMouseDown"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var usePickerBase = (0, _system.createHook)({
  name: "PickerBase",
  compose: _reakit.useRole,
  keys: _keys.PICKER_BASE_KEYS,
  useProps: function useProps(options, _ref) {
    var htmlOnKeyDown = _ref.onKeyDown,
        htmlOnClick = _ref.onClick,
        htmlOnMouseDown = _ref.onMouseDown,
        htmlProps = _objectWithoutProperties(_ref, _excluded);

    var visible = options.visible,
        isDisabled = options.isDisabled,
        isReadOnly = options.isReadOnly,
        show = options.show,
        pickerId = options.pickerId,
        dialogId = options.dialogId,
        segmentFocus = options.segmentFocus;
    var onClick = React.useCallback(function () {
      if ((0, _utils2.isTouch)()) show();
    }, [show]); // Open the popover on alt + arrow down

    var onKeyDown = (0, _reakitUtils.createOnKeyDown)({
      onKey: htmlOnKeyDown,
      preventDefault: true,
      keyMap: function keyMap(event) {
        var isAlt = event.altKey;
        return {
          ArrowDown: function ArrowDown() {
            isAlt && show();
          }
        };
      }
    });
    var onMouseDown = React.useCallback(function (e) {
      e.stopPropagation();
      segmentFocus === null || segmentFocus === void 0 ? void 0 : segmentFocus();
    }, [segmentFocus]);
    return _objectSpread({
      id: pickerId,
      role: "button",
      "aria-haspopup": "dialog",
      "aria-expanded": visible,
      "aria-owns": visible ? dialogId : undefined,
      "aria-disabled": (0, _utils2.ariaAttr)(isDisabled),
      "aria-readonly": (0, _utils2.ariaAttr)(isReadOnly),
      onKeyDown: (0, _utils.callAllHandlers)(htmlOnKeyDown, onKeyDown),
      onClick: (0, _utils.callAllHandlers)(htmlOnClick, onClick),
      onMouseDown: (0, _utils.callAllHandlers)(htmlOnMouseDown, onMouseDown)
    }, htmlProps);
  }
});
exports.usePickerBase = usePickerBase;
var PickerBase = (0, _system.createComponent)({
  as: "div",
  memo: true,
  useHook: usePickerBase
});
exports.PickerBase = PickerBase;
//# sourceMappingURL=PickerBase.js.map