"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.usePickerBaseState = void 0;

var _reakit = require("reakit");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var usePickerBaseState = function usePickerBaseState() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var pickerIdProp = props.pickerId,
      dialogIdProp = props.dialogId,
      isDisabled = props.isDisabled,
      isReadOnly = props.isReadOnly,
      segmentFocus = props.segmentFocus;

  var _useId = (0, _reakit.unstable_useId)({
    id: pickerIdProp,
    baseId: "picker"
  }),
      pickerId = _useId.id;

  var _useId2 = (0, _reakit.unstable_useId)({
    id: dialogIdProp,
    baseId: "dialog"
  }),
      dialogId = _useId2.id;

  var popover = (0, _reakit.usePopoverState)(_objectSpread({
    modal: true
  }, props));
  return _objectSpread({
    pickerId: pickerId,
    dialogId: dialogId,
    isDisabled: isDisabled,
    isReadOnly: isReadOnly,
    segmentFocus: segmentFocus
  }, popover);
};

exports.usePickerBaseState = usePickerBaseState;
//# sourceMappingURL=PickerBaseState.js.map