"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.usePickerBaseTrigger = exports.PickerBaseTrigger = void 0;

var _reakit = require("reakit");

var _utils = require("@chakra-ui/utils");

var _system = require("../system");

var _keys = require("./__keys");

var _excluded = ["onMouseDown"];

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var usePickerBaseTrigger = (0, _system.createHook)({
  name: "PickerBaseTrigger",
  compose: _reakit.usePopoverDisclosure,
  keys: _keys.PICKER_BASE_TRIGGER_KEYS,
  useOptions: function useOptions(options, _) {
    return _objectSpread({
      disabled: options.isDisabled || options.isReadOnly
    }, options);
  },
  useProps: function useProps(_, _ref) {
    var htmlOnMouseDown = _ref.onMouseDown,
        htmlProps = _objectWithoutProperties(_ref, _excluded);

    var onMouseDown = function onMouseDown(e) {
      e.stopPropagation();
    };

    return _objectSpread({
      tabIndex: -1,
      onMouseDown: (0, _utils.callAllHandlers)(htmlOnMouseDown, onMouseDown)
    }, htmlProps);
  }
});
exports.usePickerBaseTrigger = usePickerBaseTrigger;
var PickerBaseTrigger = (0, _system.createComponent)({
  as: "button",
  memo: true,
  useHook: usePickerBaseTrigger
});
exports.PickerBaseTrigger = PickerBaseTrigger;
//# sourceMappingURL=PickerBaseTrigger.js.map