"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.usePopoverArrow = exports.PopoverArrow = void 0;

var _reakit = require("reakit");

var _system = require("../system");

var _keys = require("./__keys");

var _excluded = ["style"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var usePopoverArrow = (0, _system.createHook)({
  name: "PopoverArrow",
  compose: _reakit.useRole,
  keys: _keys.POPOVER_ARROW_KEYS,
  useOptions: function useOptions(options, htmlProps) {
    return options;
  },
  useProps: function useProps(options, htmlProps) {
    var arrowStyles = options.arrowStyles;

    var htmlStyle = htmlProps.style,
        restHtmlProps = _objectWithoutProperties(htmlProps, _excluded);

    return _objectSpread({
      style: _objectSpread(_objectSpread({}, arrowStyles), {}, {
        pointerEvents: "none"
      }, htmlStyle)
    }, restHtmlProps);
  }
});
exports.usePopoverArrow = usePopoverArrow;
var PopoverArrow = (0, _system.createComponent)({
  as: "span",
  memo: true,
  useHook: usePopoverArrow
});
exports.PopoverArrow = PopoverArrow;
//# sourceMappingURL=PopoverArrow.js.map