"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.usePopoverContent = exports.PopoverContent = void 0;

var _reakitUtils = require("reakit-utils");

var _dialog = require("../dialog");

var _system = require("../system");

var _keys = require("./__keys");

var _excluded = ["modal"],
    _excluded2 = ["ref"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var usePopoverContent = (0, _system.createHook)({
  name: "PopoverContent",
  compose: _dialog.useDialog,
  keys: _keys.POPOVER_DISCLOSURE_KEYS,
  useOptions: function useOptions(_ref) {
    var _ref$modal = _ref.modal,
        modal = _ref$modal === void 0 ? false : _ref$modal,
        options = _objectWithoutProperties(_ref, _excluded);

    return _objectSpread({
      modal: modal
    }, options);
  },
  useProps: function useProps(options, htmlProps) {
    var setPopper = options.setPopper;

    var htmlRef = htmlProps.ref,
        restHtmlProps = _objectWithoutProperties(htmlProps, _excluded2);

    return _objectSpread({
      ref: (0, _reakitUtils.useForkRef)(setPopper, htmlRef)
    }, restHtmlProps);
  }
});
exports.usePopoverContent = usePopoverContent;
var PopoverContent = (0, _system.createComponent)({
  as: "div",
  memo: true,
  useHook: usePopoverContent
});
exports.PopoverContent = PopoverContent;
//# sourceMappingURL=PopoverContent.js.map