"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.usePopoverDisclosure = exports.PopoverDisclosure = void 0;

var _reakitUtils = require("reakit-utils");

var _dialog = require("../dialog");

var _system = require("../system");

var _keys = require("./__keys");

var _excluded = ["ref"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var usePopoverDisclosure = (0, _system.createHook)({
  name: "PopoverDisclosure",
  compose: _dialog.useDialogDisclosure,
  keys: _keys.POPOVER_DISCLOSURE_KEYS,
  useOptions: function useOptions(options, htmlProps) {
    return options;
  },
  useProps: function useProps(options, htmlProps) {
    var setAnchor = options.setAnchor;

    var htmlRef = htmlProps.ref,
        restHtmlProps = _objectWithoutProperties(htmlProps, _excluded);

    return _objectSpread({
      ref: (0, _reakitUtils.useForkRef)(setAnchor, htmlRef)
    }, restHtmlProps);
  }
});
exports.usePopoverDisclosure = usePopoverDisclosure;
var PopoverDisclosure = (0, _system.createComponent)({
  as: "button",
  memo: true,
  useHook: usePopoverDisclosure
});
exports.PopoverDisclosure = PopoverDisclosure;
//# sourceMappingURL=PopoverDisclosure.js.map