"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.usePopoverState = void 0;

var React = _interopRequireWildcard(require("react"));

var _popper = require("@radix-ui/popper");

var _reactUseRect = require("@radix-ui/react-use-rect");

var _reactUseSize = require("@radix-ui/react-use-size");

var _dialog = require("../dialog");

var _excluded = ["enableCollisionsDetection", "side", "align", "sideOffset", "alignOffset", "arrowOffset", "collisionTolerance", "modal"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var usePopoverState = function usePopoverState() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var enableCollisionsDetection = props.enableCollisionsDetection,
      _props$side = props.side,
      initialSide = _props$side === void 0 ? "bottom" : _props$side,
      _props$align = props.align,
      initialAlign = _props$align === void 0 ? "center" : _props$align,
      _props$sideOffset = props.sideOffset,
      initialSideOffset = _props$sideOffset === void 0 ? 5 : _props$sideOffset,
      _props$alignOffset = props.alignOffset,
      initialAlignOffset = _props$alignOffset === void 0 ? 0 : _props$alignOffset,
      _props$arrowOffset = props.arrowOffset,
      initialArrowOffset = _props$arrowOffset === void 0 ? 20 : _props$arrowOffset,
      _props$collisionToler = props.collisionTolerance,
      initialCollisionTolerance = _props$collisionToler === void 0 ? 0 : _props$collisionToler,
      _props$modal = props.modal,
      modal = _props$modal === void 0 ? false : _props$modal,
      restProps = _objectWithoutProperties(props, _excluded);

  var dialog = (0, _dialog.useDialogState)(_objectSpread({
    modal: modal
  }, restProps));

  var _React$useState = React.useState(initialSide),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      side = _React$useState2[0],
      setSide = _React$useState2[1];

  var _React$useState3 = React.useState(initialAlign),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      align = _React$useState4[0],
      setAlign = _React$useState4[1];

  var _React$useState5 = React.useState(initialSideOffset),
      _React$useState6 = _slicedToArray(_React$useState5, 2),
      sideOffset = _React$useState6[0],
      setSideOffset = _React$useState6[1];

  var _React$useState7 = React.useState(initialAlignOffset),
      _React$useState8 = _slicedToArray(_React$useState7, 2),
      alignOffset = _React$useState8[0],
      setAlignOffset = _React$useState8[1];

  var _React$useState9 = React.useState(initialArrowOffset),
      _React$useState10 = _slicedToArray(_React$useState9, 2),
      arrowOffset = _React$useState10[0],
      setArrowOffset = _React$useState10[1];

  var _React$useState11 = React.useState(initialCollisionTolerance),
      _React$useState12 = _slicedToArray(_React$useState11, 2),
      collisionTolerance = _React$useState12[0],
      setCollisionTolerance = _React$useState12[1];

  var _React$useState13 = React.useState(null),
      _React$useState14 = _slicedToArray(_React$useState13, 2),
      anchor = _React$useState14[0],
      setAnchor = _React$useState14[1];

  var anchorRect = (0, _reactUseRect.useRect)(anchor);

  var _React$useState15 = React.useState(null),
      _React$useState16 = _slicedToArray(_React$useState15, 2),
      popper = _React$useState16[0],
      setPopper = _React$useState16[1];

  var popperSize = (0, _reactUseSize.useSize)(popper);

  var _React$useState17 = React.useState(null),
      _React$useState18 = _slicedToArray(_React$useState17, 2),
      arrow = _React$useState18[0],
      setArrow = _React$useState18[1];

  var arrowSize = (0, _reactUseSize.useSize)(arrow);
  var windowSize = useWindowSize();
  var collisionBoundariesRect = windowSize ? DOMRect.fromRect(_objectSpread(_objectSpread({}, windowSize), {}, {
    x: 0,
    y: 0
  })) : undefined;
  var placementData = (0, _popper.getPlacementData)({
    popperSize: popperSize,
    anchorRect: anchorRect,
    arrowSize: arrowSize,
    arrowOffset: arrowOffset,
    side: side,
    sideOffset: sideOffset,
    align: align,
    alignOffset: alignOffset,
    shouldAvoidCollisions: enableCollisionsDetection,
    collisionBoundariesRect: collisionBoundariesRect,
    collisionTolerance: collisionTolerance
  });
  return _objectSpread(_objectSpread(_objectSpread({}, placementData), dialog), {}, {
    side: side,
    align: align,
    sideOffset: sideOffset,
    alignOffset: alignOffset,
    arrowOffset: arrowOffset,
    collisionTolerance: collisionTolerance,
    anchor: anchor,
    popper: popper,
    arrow: arrow,
    setSide: setSide,
    setAlign: setAlign,
    setSideOffset: setSideOffset,
    setAlignOffset: setAlignOffset,
    setArrowOffset: setArrowOffset,
    setCollisionTolerance: setCollisionTolerance,
    setAnchor: setAnchor,
    setPopper: setPopper,
    setArrow: setArrow
  });
};

exports.usePopoverState = usePopoverState;
var WINDOW_RESIZE_DEBOUNCE_WAIT_IN_MS = 100;

function useWindowSize() {
  var _React$useState19 = React.useState(undefined),
      _React$useState20 = _slicedToArray(_React$useState19, 2),
      windowSize = _React$useState20[0],
      setWindowSize = _React$useState20[1];

  React.useEffect(function () {
    var debounceTimerId;

    function updateWindowSize() {
      setWindowSize({
        width: window.innerWidth,
        height: window.innerHeight
      });
    }

    function handleResize() {
      window.clearTimeout(debounceTimerId);
      debounceTimerId = window.setTimeout(updateWindowSize, WINDOW_RESIZE_DEBOUNCE_WAIT_IN_MS);
    }

    updateWindowSize();
    window.addEventListener("resize", handleResize);
    return function () {
      return window.removeEventListener("resize", handleResize);
    };
  }, []);
  return windowSize;
}
//# sourceMappingURL=PopoverState.js.map