"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useProgress = exports.Progress = void 0;

var _reakitSystem = require("reakit-system");

var _reakit = require("reakit");

var _reakitWarning = require("reakit-warning");

var _utils = require("../utils");

var _keys = require("./__keys");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useProgress = (0, _reakitSystem.createHook)({
  name: "Progress",
  compose: _reakit.useRole,
  keys: _keys.PROGRESS_KEYS,
  useProps: function useProps(options, htmlProps) {
    var isIndeterminate = options.isIndeterminate,
        value = options.value,
        max = options.max,
        min = options.min;
    return _objectSpread({
      role: "progressbar",
      "data-indeterminate": (0, _utils.dataAttr)(isIndeterminate),
      "aria-valuemax": max,
      "aria-valuemin": min,
      "aria-valuenow": (0, _utils.isNull)(value) ? undefined : value,
      "aria-valuetext": !(value !== null && value !== void 0 && value.toString()) ? "intermediate" : value.toString()
    }, htmlProps);
  }
});
exports.useProgress = useProgress;
var Progress = (0, _reakitSystem.createComponent)({
  as: "div",
  memo: true,
  useHook: useProgress,
  useCreateElement: function useCreateElement(type, props, children) {
    (0, _reakitWarning.useWarning)(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.", "See https://www.w3.org/TR/wai-aria-1.2/#progressbar");
    return (0, _reakitSystem.useCreateElement)(type, props, children);
  }
});
exports.Progress = Progress;
//# sourceMappingURL=Progress.js.map