"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useRadioGroup = exports.RadioGroup = void 0;

var _reakitSystem = require("reakit-system");

var _reakit = require("reakit");

var _reakitWarning = require("reakit-warning");

var _keys = require("./__keys");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useRadioGroup = (0, _reakitSystem.createHook)({
  name: "RadioGroup",
  compose: _reakit.useComposite,
  keys: _keys.RADIO_GROUP_KEYS,
  useProps: function useProps(options, htmlProps) {
    return _objectSpread({
      role: "radiogroup"
    }, htmlProps);
  }
});
exports.useRadioGroup = useRadioGroup;
var RadioGroup = (0, _reakitSystem.createComponent)({
  as: "div",
  useHook: useRadioGroup,
  useCreateElement: function useCreateElement(type, props, children) {
    (0, _reakitWarning.useWarning)(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.");
    return (0, _reakitSystem.useCreateElement)(type, props, children);
  }
});
exports.RadioGroup = RadioGroup;
//# sourceMappingURL=RadioGroup.js.map