"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fireChange = fireChange;
exports.getChecked = getChecked;
exports.useInitialChecked = useInitialChecked;

var _react = _interopRequireDefault(require("react"));

var _reakitUtils = require("reakit-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function getChecked(options) {
  var checked = options.checked,
      value = options.value,
      state = options.state;
  if (typeof checked !== "undefined") return checked;
  return typeof value !== "undefined" && state === value;
}

function useInitialChecked(options) {
  var _React$useState = _react.default.useState(function () {
    return getChecked(options);
  }),
      _React$useState2 = _slicedToArray(_React$useState, 1),
      initialChecked = _React$useState2[0];

  var id = options.id,
      currentId = options.currentId,
      setCurrentId = options.setCurrentId;

  var _React$useState3 = _react.default.useState(currentId),
      _React$useState4 = _slicedToArray(_React$useState3, 1),
      initialCurrentId = _React$useState4[0];

  _react.default.useEffect(function () {
    if (initialChecked && id && initialCurrentId !== id) {
      setCurrentId === null || setCurrentId === void 0 ? void 0 : setCurrentId(id);
    }
  }, [initialChecked, id, setCurrentId, initialCurrentId]);
}

function fireChange(element, onChange) {
  var event = (0, _reakitUtils.createEvent)(element, "change");
  Object.defineProperties(event, {
    type: {
      value: "change"
    },
    target: {
      value: element
    },
    currentTarget: {
      value: element
    }
  });
  onChange === null || onChange === void 0 ? void 0 : onChange(event);
}
//# sourceMappingURL=helpers.js.map