"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSegment = exports.Segment = void 0;

var React = _interopRequireWildcard(require("react"));

var _reakit = require("reakit");

var _utils = require("@chakra-ui/utils");

var _i18n = require("@react-aria/i18n");

var _spinbutton = require("@react-aria/spinbutton");

var _utils2 = require("@react-aria/utils");

var _system = require("../system");

var _utils3 = require("../utils");

var _keys = require("./__keys");

var _helpers = require("./helpers");

var _excluded = ["segment", "next"],
    _excluded2 = ["onMouseDown", "onKeyDown", "onFocus"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useSegment = (0, _system.createHook)({
  name: "Segment",
  compose: _reakit.useCompositeItem,
  keys: _keys.SEGMENT_KEYS,
  useOptions: function useOptions(options, _) {
    return _objectSpread({
      disabled: options.isDisabled || options.isReadOnly || options.segment.type === "literal"
    }, options);
  },
  useProps: function useProps(_ref, _ref2) {
    var segment = _ref.segment,
        next = _ref.next,
        options = _objectWithoutProperties(_ref, _excluded);

    var htmlOnMouseDown = _ref2.onMouseDown,
        htmlOnKeyDown = _ref2.onKeyDown,
        htmlOnFocus = _ref2.onFocus,
        htmlProps = _objectWithoutProperties(_ref2, _excluded2);

    var _React$useState = React.useState(""),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        enteredKeys = _React$useState2[0],
        setEnteredKeys = _React$useState2[1];

    var textValue = segment.text;
    var monthDateFormatter = (0, _i18n.useDateFormatter)({
      month: "long"
    });
    var hourDateFormatter = (0, _i18n.useDateFormatter)({
      hour: "numeric",
      hour12: options.dateFormatter.resolvedOptions().hour12
    });
    var hourFormattedValue = hourDateFormatter.format(options.fieldValue);

    if (segment.type === "month") {
      textValue = monthDateFormatter.format(options.fieldValue);
    }

    if (segment.type === "hour") {
      textValue = hourFormattedValue.split(" ")[0];
    }

    if (segment.type === "dayPeriod") {
      textValue = hourFormattedValue.split(" ")[1];
    }

    var _useSpinButton = (0, _spinbutton.useSpinButton)({
      value: segment.value,
      textValue: textValue,
      minValue: segment.minValue,
      maxValue: segment.maxValue,
      isDisabled: options.isDisabled,
      isReadOnly: options.isReadOnly,
      isRequired: options.isRequired,
      onIncrement: function onIncrement() {
        return options.increment(segment.type);
      },
      onDecrement: function onDecrement() {
        return options.decrement(segment.type);
      },
      onIncrementPage: function onIncrementPage() {
        return options.incrementPage(segment.type);
      },
      onDecrementPage: function onDecrementPage() {
        return options.decrementPage(segment.type);
      },
      onIncrementToMax: function onIncrementToMax() {
        return options.setSegment(segment.type, segment.maxValue);
      },
      onDecrementToMin: function onDecrementToMin() {
        return options.setSegment(segment.type, segment.minValue);
      }
    }),
        spinButtonProps = _useSpinButton.spinButtonProps;

    var onInput = React.useCallback(function (key) {
      var newValue = enteredKeys + key;

      switch (segment.type) {
        case "dayPeriod":
          if (key === "a") {
            options.setSegment("dayPeriod", 0);
          } else if (key === "p") {
            options.setSegment("dayPeriod", 12);
          }

          next();
          break;

        case "day":
        case "hour":
        case "minute":
        case "second":
        case "month":
        case "year":
          {
            if (!(0, _helpers.isNumeric)(newValue)) {
              return;
            }

            var numberValue = (0, _helpers.parseNumber)(newValue);
            var segmentValue = numberValue;

            if (segment.type === "hour" && options.dateFormatter.resolvedOptions().hour12 && numberValue === 12) {
              segmentValue = 0;
            } else if (numberValue > segment.maxValue) {
              segmentValue = (0, _helpers.parseNumber)(key);
            }

            options.setSegment(segment.type, segmentValue);

            if (Number(numberValue + "0") > segment.maxValue) {
              setEnteredKeys("");
              next();
            } else {
              setEnteredKeys(newValue);
            }

            break;
          }
      }
    }, [enteredKeys, next, options, segment.maxValue, segment.type]);
    var onKeyDown = React.useCallback(function (e) {
      if (e.ctrlKey || e.metaKey || e.shiftKey || e.altKey) {
        return;
      }

      switch (e.key) {
        case "Enter":
          e.preventDefault();

          if (segment.isPlaceholder && !options.isReadOnly) {
            options.confirmPlaceholder(segment.type);
          }

          next();
          break;

        case "Tab":
          break;

        case "Backspace":
          {
            e.preventDefault();

            if ((0, _helpers.isNumeric)(segment.text) && !options.isReadOnly) {
              var newValue = segment.text.slice(0, -1);
              options.setSegment(segment.type, newValue.length === 0 ? segment.minValue : (0, _helpers.parseNumber)(newValue));
              setEnteredKeys(newValue);
            }

            break;
          }

        default:
          e.preventDefault();
          e.stopPropagation();

          if (((0, _helpers.isNumeric)(e.key) || /^[ap]$/.test(e.key)) && !options.isReadOnly) {
            onInput(e.key);
          }

      }
    }, [next, onInput, options, segment.isPlaceholder, segment.minValue, segment.text, segment.type]);
    var onFocus = React.useCallback(function () {
      setEnteredKeys("");
    }, []);
    var onMouseDown = React.useCallback(function (e) {
      return e.stopPropagation();
    }, []);

    switch (segment.type) {
      // A separator, e.g. punctuation
      case "literal":
        return _objectSpread({
          "data-placeholder": (0, _utils3.dataAttr)(false),
          children: segment.text
        }, htmlProps);
      // These segments cannot be directly edited by the user.

      case "weekday":
      case "timeZoneName":
      case "era":
        return _objectSpread({
          "data-placeholder": true,
          children: segment.text
        }, htmlProps);
      // Editable segment

      default:
        return (0, _utils2.mergeProps)(spinButtonProps, _objectSpread({
          "aria-label": segment.type,
          onKeyDown: (0, _utils.callAllHandlers)(htmlOnKeyDown, onKeyDown),
          onFocus: (0, _utils.callAllHandlers)(htmlOnFocus, onFocus),
          onMouseDown: (0, _utils.callAllHandlers)(htmlOnMouseDown, onMouseDown),
          children: segment.text
        }, htmlProps));
    }
  },
  useComposeProps: function useComposeProps(options, htmlProps) {
    var composite = (0, _reakit.useCompositeItem)(options, htmlProps);
    /*
      Haz:
      Ensure tabIndex={0}
      Tab is not the only thing that can move focus in web pages
      For example, on iOS you can move between form elements using
      the arrows above the keyboard
    */

    return _objectSpread(_objectSpread({}, composite), {}, {
      tabIndex: options.disabled ? -1 : 0
    });
  }
});
exports.useSegment = useSegment;
var Segment = (0, _system.createComponent)({
  as: "div",
  memo: true,
  useHook: useSegment
});
exports.Segment = Segment;
//# sourceMappingURL=Segment.js.map