"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getIdFromValue = getIdFromValue;
exports.useSelectBaseState = useSelectBaseState;

var React = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function getIdFromValue(valuesById, selectedValue) {
  if (selectedValue == null) return null;
  var selectedOption = valuesById.find(function (option) {
    return option.value === selectedValue;
  });
  return selectedOption ? selectedOption.id : null;
}

function getValueFromId(valuesById, currentId) {
  if (currentId == null) return;
  var selectedOption = valuesById.find(function (option) {
    return option.id === currentId;
  });
  return selectedOption ? selectedOption.value : undefined;
}

function useSelectBaseState(composite) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$selectedValue = _ref.selectedValue,
      initialSelectedValue = _ref$selectedValue === void 0 ? null : _ref$selectedValue,
      _ref$values = _ref.values,
      initialValues = _ref$values === void 0 ? [] : _ref$values;

  var valuesById = React.useRef([]);
  var valuesRef = React.useRef(initialValues);
  var compositeItems = composite.items,
      compositeRegisterItem = composite.registerItem,
      compositeUnregisterItem = composite.unregisterItem;

  var _React$useState = React.useState(initialSelectedValue),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      selectedValue = _React$useState2[0],
      setSelectedValue = _React$useState2[1];

  var selectedId = React.useMemo(function () {
    return getIdFromValue(valuesById.current, selectedValue);
  }, [valuesById.current, selectedValue]);
  var currentValue = React.useMemo(function () {
    return getValueFromId(valuesById.current, composite.currentId);
  }, [valuesById.current, composite.currentId]);
  var items = React.useMemo(function () {
    compositeItems.forEach(function (item) {
      if (item.id) {
        item.value = valuesById.current[item.id];
      }
    });
    return compositeItems;
  }, [compositeItems]);
  var registerItem = React.useCallback(function (item) {
    compositeRegisterItem(item);

    if (item.id && item.value) {
      valuesById.current = [].concat(_toConsumableArray(valuesById.current), [{
        id: item.id,
        value: item.value
      }]);
      if (!initialValues.length) valuesRef.current = [].concat(_toConsumableArray(valuesRef.current), [item.value]);
    }
  }, [compositeRegisterItem]);
  var unregisterItem = React.useCallback(function (id) {
    compositeUnregisterItem(id);
    delete valuesById.current[id];
  }, [compositeUnregisterItem]);
  return _objectSpread(_objectSpread({}, composite), {}, {
    menuRole: "listbox",
    selectedValue: selectedValue,
    currentValue: currentValue,
    values: valuesRef.current,
    valuesById: valuesById.current,
    selectedId: selectedId,
    items: items,
    setSelectedValue: setSelectedValue,
    registerItem: registerItem,
    unregisterItem: unregisterItem
  });
}
//# sourceMappingURL=SelectBaseState.js.map