"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSelectList = exports.SelectList = void 0;

var _useCreateElement2 = require("reakit-system/useCreateElement");

var _reakit = require("reakit");

var _reakitWarning = require("reakit-warning");

var _system = require("../system");

var _keys = require("./__keys");

var _excluded = ["menuRole"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var useSelectList = (0, _system.createHook)({
  name: "SelectList",
  compose: _reakit.useComposite,
  keys: _keys.SELECT_LIST_KEYS,
  useOptions: function useOptions(_ref) {
    var _ref$menuRole = _ref.menuRole,
        menuRole = _ref$menuRole === void 0 ? "listbox" : _ref$menuRole,
        options = _objectWithoutProperties(_ref, _excluded);

    return _objectSpread({
      menuRole: menuRole
    }, options);
  },
  useProps: function useProps(options, htmlProps) {
    return _objectSpread({
      role: options.menuRole
    }, htmlProps);
  }
});
exports.useSelectList = useSelectList;
var SelectList = (0, _system.createComponent)({
  as: "div",
  useHook: useSelectList,
  useCreateElement: function useCreateElement(type, props, children) {
    (0, _reakitWarning.useWarning)(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.", "See https://www.w3.org/TR/wai-aria-1.1/#listbox");
    return (0, _useCreateElement2.useCreateElement)(type, props, children);
  }
});
exports.SelectList = SelectList;
//# sourceMappingURL=SelectList.js.map