"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSliderGroup = exports.SliderGroup = void 0;

var _reakit = require("reakit");

var _utils = require("@react-aria/utils");

var _system = require("../system");

var _keys = require("./__keys");

var useSliderGroup = (0, _system.createHook)({
  name: "SliderGroup",
  compose: _reakit.useGroup,
  keys: _keys.SLIDER_GROUP_KEYS,
  useOptions: function useOptions(options, htmlProps) {
    return options;
  },
  useProps: function useProps(options, htmlProps) {
    return (0, _utils.mergeProps)(options.groupProps, htmlProps);
  }
});
exports.useSliderGroup = useSliderGroup;
var SliderGroup = (0, _system.createComponent)({
  as: "div",
  memo: true,
  useHook: useSliderGroup
});
exports.SliderGroup = SliderGroup;
//# sourceMappingURL=SliderGroup.js.map