"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSliderLabel = exports.SliderLabel = void 0;

var _reakit = require("reakit");

var _utils = require("@react-aria/utils");

var _system = require("../system");

var _keys = require("./__keys");

var useSliderLabel = (0, _system.createHook)({
  name: "SliderLabel",
  compose: _reakit.useRole,
  keys: _keys.SLIDER_LABEL_KEYS,
  useOptions: function useOptions(options, htmlProps) {
    return options;
  },
  useProps: function useProps(options, htmlProps) {
    var labelProps = options.labelProps;
    return (0, _utils.mergeProps)(labelProps, htmlProps);
  }
});
exports.useSliderLabel = useSliderLabel;
var SliderLabel = (0, _system.createComponent)({
  as: "label",
  memo: true,
  useHook: useSliderLabel
});
exports.SliderLabel = SliderLabel;
//# sourceMappingURL=SliderLabel.js.map