"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSliderOutput = exports.SliderOutput = void 0;

var _reakit = require("reakit");

var _utils = require("@react-aria/utils");

var _system = require("../system");

var _keys = require("./__keys");

var useSliderOutput = (0, _system.createHook)({
  name: "SliderOutput",
  compose: _reakit.useRole,
  keys: _keys.SLIDER_LABEL_KEYS,
  useOptions: function useOptions(options, htmlProps) {
    return options;
  },
  useProps: function useProps(options, htmlProps) {
    return (0, _utils.mergeProps)(options.outputProps, htmlProps);
  }
});
exports.useSliderOutput = useSliderOutput;
var SliderOutput = (0, _system.createComponent)({
  as: "output",
  memo: true,
  useHook: useSliderOutput
});
exports.SliderOutput = SliderOutput;
//# sourceMappingURL=SliderOutput.js.map