"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSliderThumb = exports.SliderThumb = void 0;

var _reakit = require("reakit");

var _utils = require("@react-aria/utils");

var _system = require("../system");

var _keys = require("./__keys");

var useSliderThumb = (0, _system.createHook)({
  name: "SliderThumb",
  compose: _reakit.useRole,
  keys: _keys.SLIDER_THUMB_KEYS,
  useProps: function useProps(options, htmlProps) {
    var thumbProps = options.thumbProps;
    return (0, _utils.mergeProps)(thumbProps, htmlProps);
  }
});
exports.useSliderThumb = useSliderThumb;
var SliderThumb = (0, _system.createComponent)({
  as: "div",
  memo: true,
  useHook: useSliderThumb
});
exports.SliderThumb = SliderThumb;
//# sourceMappingURL=SliderThumb.js.map