"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useTimePickerColumn = exports.TimePickerColumn = void 0;

var _Composite = require("reakit/Composite");

var _system = require("../system");

var _keys = require("./__keys");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useTimePickerColumn = (0, _system.createHook)({
  name: "TimePickerColumn",
  compose: _Composite.useComposite,
  keys: _keys.TIME_PICKER_COLUMN_KEYS,
  useProps: function useProps(_ref, htmlProps) {
    var columnType = _ref.columnType;
    return _objectSpread({
      role: "listbox",
      "aria-label": columnType
    }, htmlProps);
  }
});
exports.useTimePickerColumn = useTimePickerColumn;
var TimePickerColumn = (0, _system.createComponent)({
  as: "div",
  memo: true,
  useHook: useTimePickerColumn
});
exports.TimePickerColumn = TimePickerColumn;
//# sourceMappingURL=TimePickerColumn.js.map