"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useTimePickerColumnValue = exports.TimePickerColumnValue = void 0;

var React = _interopRequireWildcard(require("react"));

var _reakit = require("reakit");

var _reakitUtils = require("reakit-utils");

var _utils = require("@chakra-ui/utils");

var _system = require("../system");

var _keys = require("./__keys");

var _helpers = require("./helpers");

var _excluded = ["ref", "onClick", "onKeyDown"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var useTimePickerColumnValue = (0, _system.createHook)({
  name: "TimePickerColumnValue",
  compose: [_reakit.useButton, _reakit.useCompositeItem],
  keys: _keys.TIME_PICKER_COLUMN_VALUE_KEYS,
  useProps: function useProps(options, _ref) {
    var htmlRef = _ref.ref,
        htmlOnClick = _ref.onClick,
        htmlOnKeyDown = _ref.onKeyDown,
        htmlProps = _objectWithoutProperties(_ref, _excluded);

    var popover = options.popover,
        setCurrentId = options.setCurrentId,
        selected = options.selected,
        value = options.value,
        id = options.id,
        setSelected = options.setSelected,
        visible = options.visible,
        date = options.date,
        updateOldTime = options.updateOldTime,
        restoreOldTime = options.restoreOldTime,
        baseId = options.baseId,
        move = options.move,
        columnType = options.columnType;
    var ref = React.useRef();
    React.useEffect(function () {
      if (selected === value) {
        var _ref$current;

        if (!id) return;
        setCurrentId === null || setCurrentId === void 0 ? void 0 : setCurrentId(id);
        ref === null || ref === void 0 ? void 0 : (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.scrollIntoView();
      } // eslint-disable-next-line react-hooks/exhaustive-deps

    }, [visible]);

    var handleCancellation = function handleCancellation() {
      var _ref$current2;

      var oldTime = restoreOldTime === null || restoreOldTime === void 0 ? void 0 : restoreOldTime();
      if (!oldTime) return;

      if (oldTime.getTime() === date.getTime()) {
        popover === null || popover === void 0 ? void 0 : popover.hide();
      }

      var idx = (0, _helpers.getSelectedValueFromDate)(oldTime, columnType);
      var id = idx + (columnType === "hour" ? 0 : 1);
      ref === null || ref === void 0 ? void 0 : (_ref$current2 = ref.current) === null || _ref$current2 === void 0 ? void 0 : _ref$current2.scrollIntoView();
      move("".concat(baseId, "-").concat(id));
    };

    var handleSubmit = function handleSubmit() {
      setSelected(value, true);
      updateOldTime === null || updateOldTime === void 0 ? void 0 : updateOldTime();
    };

    var onClick = React.useCallback(function () {
      setSelected(value);
    }, [setSelected, value]);
    var onKeyDown = React.useCallback(function (e) {
      e.preventDefault();

      if (e.key === "Escape") {
        handleCancellation();
        return;
      }

      if (e.key === "Enter") {
        handleSubmit();
        return;
      }
    }, // eslint-disable-next-line react-hooks/exhaustive-deps
    [restoreOldTime, updateOldTime, setSelected, value]);
    return _objectSpread({
      role: "option",
      "aria-selected": selected === value,
      ref: (0, _reakitUtils.useForkRef)(ref, htmlRef),
      onClick: (0, _utils.callAllHandlers)(htmlOnClick, onClick),
      onKeyDown: (0, _utils.callAllHandlers)(htmlOnKeyDown, onKeyDown)
    }, htmlProps);
  }
});
exports.useTimePickerColumnValue = useTimePickerColumnValue;
var TimePickerColumnValue = (0, _system.createComponent)({
  as: "div",
  memo: true,
  useHook: useTimePickerColumnValue
});
exports.TimePickerColumnValue = TimePickerColumnValue;
//# sourceMappingURL=TimePickerColumnValue.js.map