"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useTimePickerState = void 0;

var React = _interopRequireWildcard(require("react"));

var _i18n = require("@react-aria/i18n");

var _pickerBase = require("../picker-base");

var _segment = require("../segment");

var _utils = require("../utils");

var _LiveAnnouncer = require("../utils/LiveAnnouncer");

var _helpers = require("./helpers");

var _TimePickerColumnState = require("./TimePickerColumnState");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useTimePickerState = function useTimePickerState() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var initialValue = props.value,
      _props$defaultValue = props.defaultValue,
      defaultValueProp = _props$defaultValue === void 0 ? (0, _helpers.stringifyTime)(new Date()) : _props$defaultValue,
      onChangeProp = props.onChange,
      _props$formatOptions = props.formatOptions,
      formatOptions = _props$formatOptions === void 0 ? {
    timeStyle: "short"
  } : _props$formatOptions,
      placeholderDate = props.placeholderDate,
      autoFocus = props.autoFocus;
  var onChange = React.useCallback(function (date) {
    return onChangeProp === null || onChangeProp === void 0 ? void 0 : onChangeProp((0, _helpers.stringifyTime)(date));
  }, [onChangeProp]);

  var _useControllableState = (0, _utils.useControllableState)({
    value: (0, _helpers.parseTime)(initialValue),
    defaultValue: (0, _helpers.parseTime)(defaultValueProp) || new Date(),
    onChange: onChange
  }),
      _useControllableState2 = _slicedToArray(_useControllableState, 2),
      time = _useControllableState2[0],
      setTime = _useControllableState2[1];

  var _React$useState = React.useState(new Date(time)),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      oldTime = _React$useState2[0],
      setOldTime = _React$useState2[1];

  var updateOldTime = function updateOldTime() {
    setOldTime(new Date(time));
  };

  var restoreOldTime = function restoreOldTime() {
    setTime(new Date(oldTime));
    return new Date(oldTime);
  };

  var segmentState = (0, _segment.useSegmentState)({
    value: time,
    onChange: setTime,
    formatOptions: formatOptions,
    placeholderDate: placeholderDate
  });
  var popover = (0, _pickerBase.usePickerBaseState)(_objectSpread({
    segmentFocus: segmentState.first
  }, props));

  var setTimeProp = function setTimeProp(date) {
    setTime(date);
  };

  var hourState = (0, _TimePickerColumnState.useTimePickerColumnState)({
    columnType: "hour",
    value: time,
    onChange: setTimeProp,
    visible: popover.visible,
    popover: popover,
    updateOldTime: updateOldTime,
    restoreOldTime: restoreOldTime
  });
  var minuteState = (0, _TimePickerColumnState.useTimePickerColumnState)({
    columnType: "minute",
    value: time,
    onChange: setTimeProp,
    visible: popover.visible,
    popover: popover,
    updateOldTime: updateOldTime,
    restoreOldTime: restoreOldTime
  });
  var meridiesState = (0, _TimePickerColumnState.useTimePickerColumnState)({
    columnType: "meridian",
    value: time,
    onChange: setTimeProp,
    visible: popover.visible,
    popover: popover,
    updateOldTime: updateOldTime,
    restoreOldTime: restoreOldTime
  });

  var hours = _toConsumableArray(new Array(13).keys()).slice(1);

  var minutes = _toConsumableArray(new Array(60).keys());

  var meridies = ["AM", "PM"];
  var dateFormatter = (0, _i18n.useDateFormatter)({
    timeStyle: "medium"
  });

  var announceSelectedDate = function announceSelectedDate() {
    (0, _LiveAnnouncer.announce)("Selected Time: ".concat(dateFormatter.format(time)));
  };

  React.useEffect(function () {
    if (autoFocus) {
      segmentState.first();
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [autoFocus, segmentState.first]);
  React.useEffect(function () {
    if (popover.visible === false && oldTime !== new Date(time)) {
      setOldTime(new Date(time));
      announceSelectedDate();
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [popover.visible]);
  return _objectSpread(_objectSpread({
    time: time,
    hours: hours,
    minutes: minutes,
    meridies: meridies,
    hourState: hourState,
    minuteState: minuteState,
    meridiesState: meridiesState
  }, popover), segmentState);
};

exports.useTimePickerState = useTimePickerState;
//# sourceMappingURL=TimePickerState.js.map