"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createToastStore = createToastStore;

var React = _interopRequireWildcard(require("react"));

var _reactUtils = require("@chakra-ui/react-utils");

var _index = require("./index");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function createToastStore(defaultOptions) {
  var _createContext = (0, _reactUtils.createContext)({
    strict: false,
    name: "ToastsState",
    errorMessage: "useToastStore must be used within ToastProvider"
  }),
      _createContext2 = _slicedToArray(_createContext, 2),
      ToastStoreProvider = _createContext2[0],
      useToastStore = _createContext2[1];

  var _createContext3 = (0, _reactUtils.createContext)({
    strict: false,
    name: "CreateToast",
    errorMessage: "useCreateToast must be used within ToastProvider"
  }),
      _createContext4 = _slicedToArray(_createContext3, 2),
      CreateToastProvider = _createContext4[0],
      useCreateToast = _createContext4[1];

  var _createContext5 = (0, _reactUtils.createContext)({
    strict: false,
    name: "ToastHandlers",
    errorMessage: "useToastHandlers must be used within ToastProvider"
  }),
      _createContext6 = _slicedToArray(_createContext5, 2),
      ToastHandlersProvider = _createContext6[0],
      useToastHandlers = _createContext6[1];

  var ToastProvider = function ToastProvider(props) {
    var children = props.children,
        rest = _objectWithoutProperties(props, _excluded);

    var _useToastState = (0, _index.useToastState)(),
        toasts = _useToastState.toasts,
        dispatch = _useToastState.dispatch;

    var context = React.useMemo(function () {
      return {
        toasts: toasts,
        dispatch: dispatch
      };
    }, [toasts, dispatch]);
    var createToast = React.useCallback(function (content, opts) {
      return _objectSpread(_objectSpread(_objectSpread(_objectSpread({
        visible: false,
        reverseOrder: true,
        createdAt: Date.now()
      }, defaultOptions), rest), opts), {}, {
        content: content,
        id: (opts === null || opts === void 0 ? void 0 : opts.id) || (0, _index.genId)()
      });
    }, // Since its only a few object https://twitter.com/dan_abramov/status/1104414272753487872
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [JSON.stringify(rest)]);
    var addToast = React.useCallback(function (content, options) {
      var toast = createToast(content, options);
      dispatch({
        type: _index.ActionType.ADD_TOAST,
        toast: _objectSpread(_objectSpread({}, toast), {}, {
          visible: true
        })
      });
      return toast.id;
    }, [createToast, dispatch]);
    var showToast = React.useCallback(function (content, options) {
      var toast = createToast(content, options);
      dispatch({
        type: _index.ActionType.ADD_TOAST,
        toast: toast
      });
      setTimeout(function () {
        dispatch({
          type: _index.ActionType.UPDATE_TOAST,
          toast: _objectSpread(_objectSpread({}, toast), {}, {
            visible: true
          })
        });
      }, 0);
      return toast.id;
    }, [createToast, dispatch]);
    var updateToast = React.useCallback(function (toastId, toast) {
      dispatch({
        type: _index.ActionType.UPDATE_TOAST,
        toast: _objectSpread(_objectSpread({}, toast), {}, {
          id: toastId
        })
      });
    }, [dispatch]);
    var updateFieldToast = React.useCallback(function (field, fieldValue, toast) {
      dispatch({
        type: _index.ActionType.UPDATE_FIELD_TOAST,
        field: field,
        fieldValue: fieldValue,
        toast: toast
      });
    }, [dispatch]);
    var updateAllToast = React.useCallback(function (toast) {
      dispatch({
        type: _index.ActionType.UPDATE_ALL_TOAST,
        toast: toast
      });
    }, [dispatch]);
    var dismissToast = React.useCallback(function (toastId) {
      var unmountDuration = defaultOptions.animationDuration;
      dispatch({
        type: _index.ActionType.DISMISS_TOAST,
        toastId: toastId
      });
      setTimeout(function () {
        dispatch({
          type: _index.ActionType.REMOVE_TOAST,
          toastId: toastId
        });
      }, unmountDuration);
    }, [dispatch]);
    var removeToast = React.useCallback(function (toastId) {
      dispatch({
        type: _index.ActionType.REMOVE_TOAST,
        toastId: toastId
      });
    }, [dispatch]);
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastStoreProvider, {
      value: context,
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(CreateToastProvider, {
        value: {
          createToast: createToast
        },
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(ToastHandlersProvider, {
          value: {
            addToast: addToast,
            showToast: showToast,
            updateToast: updateToast,
            updateFieldToast: updateFieldToast,
            updateAllToast: updateAllToast,
            dismissToast: dismissToast,
            removeToast: removeToast
          },
          children: children
        })
      })
    });
  };

  ToastProvider.displayName = "ToastStoreProvider";
  return [ToastProvider, useToastStore, useCreateToast, useToastHandlers];
}
//# sourceMappingURL=CreateToastContext.js.map