"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useTooltip = exports.Tooltip = void 0;

var _react = _interopRequireDefault(require("react"));

var _reakit = require("reakit");

var _Popover = require("../popover/Popover");

var _system = require("../system");

var _keys = require("./__keys");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["unstable_portal"],
    _excluded2 = ["style", "wrapElement"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var useTooltip = (0, _system.createHook)({
  name: "Tooltip",
  compose: _Popover.usePopover,
  keys: _keys.TOOLTIP_KEYS,
  useOptions: function useOptions(_ref) {
    var _ref$unstable_portal = _ref.unstable_portal,
        unstable_portal = _ref$unstable_portal === void 0 ? true : _ref$unstable_portal,
        options = _objectWithoutProperties(_ref, _excluded);

    return _objectSpread({
      unstable_portal: unstable_portal
    }, options);
  },
  useProps: function useProps(options, htmlProps) {
    var htmlStyle = htmlProps.style,
        htmlWrapElement = htmlProps.wrapElement,
        restHtmlProps = _objectWithoutProperties(htmlProps, _excluded2);

    var wrapElement = _react.default.useCallback(function (element) {
      if (options.unstable_portal) {
        element = /*#__PURE__*/(0, _jsxRuntime.jsx)(_reakit.Portal, {
          children: element
        });
      }

      if (htmlWrapElement) {
        return htmlWrapElement(element);
      }

      return element;
    }, [options.unstable_portal, htmlWrapElement]);

    return _objectSpread({
      style: _objectSpread({
        pointerEvents: "none"
      }, htmlStyle),
      wrapElement: wrapElement
    }, restHtmlProps);
  }
});
exports.useTooltip = useTooltip;
var Tooltip = (0, _system.createComponent)({
  as: "div",
  memo: true,
  useHook: useTooltip
});
exports.Tooltip = Tooltip;
//# sourceMappingURL=Tooltip.js.map