"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useTooltipAnchor = exports.TooltipAnchor = void 0;

var _popover = require("../popover");

var _system = require("../system");

var _keys = require("./__keys");

var useTooltipAnchor = (0, _system.createHook)({
  name: "TooltipAnchor",
  compose: _popover.usePopoverAnchor,
  keys: _keys.TOOLTIP_ANCHOR_KEYS,
  useOptions: function useOptions(options, htmlProps) {
    return options;
  },
  useProps: function useProps(options, htmlProps) {
    return htmlProps;
  }
});
exports.useTooltipAnchor = useTooltipAnchor;
var TooltipAnchor = (0, _system.createComponent)({
  as: "div",
  memo: true,
  useHook: useTooltipAnchor
});
exports.TooltipAnchor = TooltipAnchor;
//# sourceMappingURL=TooltipAnchor.js.map