function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { useComposite } from "reakit";
import { createComponent, createHook } from "../system";
import { ACCORDION_KEYS } from "./__keys";
export var useAccordion = createHook({
  name: "Accordion",
  compose: useComposite,
  keys: ACCORDION_KEYS,

  useComposeProps(options, htmlProps) {
    var compositeHtmlProp = useComposite(options, htmlProps);
    return _objectSpread(_objectSpread({}, compositeHtmlProp), {}, {
      // When none selected i.e, selectedId={null}
      // as per composite https://github.com/reakit/reakit/blob/master/packages/reakit/src/Composite/Composite.ts#L372
      // it applies tabindex={0} which we need to remove it.
      tabIndex: undefined
    });
  }

});
export var Accordion = createComponent({
  as: "div",
  memo: true,
  useHook: useAccordion
});
//# sourceMappingURL=Accordion.js.map