var _excluded = ["onClick", "onKeyDown", "onFocus"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import * as React from "react";
import { useButton, useCompositeItem } from "reakit";
import { callAllHandlers } from "@chakra-ui/utils";
import { createComponent, createHook } from "../system";
import { ariaAttr } from "../utils";
import { ACCORDION_TRIGGER_KEYS } from "./__keys";
import { isAccordionSelected, useAccordionPanelId } from "./helpers";
export var useAccordionTrigger = createHook({
  name: "Accordion",
  compose: [useButton, useCompositeItem],
  keys: ACCORDION_TRIGGER_KEYS,

  // * Do not add `focusable: true` in useOptions or else the disabled button
  // * will receive the focus & considered as an element in composite navigation
  useProps(options, _ref) {
    var {
      onClick: htmlOnClick,
      onKeyDown: htmlOnKeyDown,
      onFocus: htmlOnFocus
    } = _ref,
        htmlProps = _objectWithoutProperties(_ref, _excluded);

    var {
      manual,
      id,
      allowToggle,
      select,
      first,
      last
    } = options;
    var selected = isAccordionSelected(options);
    var accordionPanelId = useAccordionPanelId(options);
    var onKeyDown = React.useCallback(event => {
      var _first = first && (() => setTimeout(first));

      var _last = last && (() => setTimeout(last));

      var keyMap = {
        Home: _first,
        End: _last
      };
      var action = keyMap[event.key];

      if (action) {
        event.preventDefault();
        event.stopPropagation();
        action();
      }
    }, [first, last]);
    var handleSelection = React.useCallback(() => {
      if (!id) return;
      select === null || select === void 0 ? void 0 : select(id);
    }, [id, select]);
    var onClick = React.useCallback(() => handleSelection(), [handleSelection]);
    var onFocus = React.useCallback(() => {
      if (manual) return;
      handleSelection();
    }, [manual, handleSelection]);
    return _objectSpread({
      "aria-expanded": selected,
      "aria-controls": accordionPanelId,
      "aria-disabled": ariaAttr(!allowToggle && selected),
      onKeyDown: callAllHandlers(htmlOnKeyDown, onKeyDown),
      onClick: callAllHandlers(htmlOnClick, onClick),
      onFocus: callAllHandlers(htmlOnFocus, onFocus)
    }, htmlProps);
  },

  useComposeProps(options, htmlProps) {
    var buttonHtmlProps = useButton(options, htmlProps);
    var compositeHtmlProps = useCompositeItem(options, buttonHtmlProps);
    return _objectSpread(_objectSpread({}, compositeHtmlProps), {}, {
      // *Add the tabIndex = 0 to button to make it tabbable in composite
      tabIndex: 0
    });
  }

});
export var AccordionTrigger = createComponent({
  as: "button",
  memo: true,
  useHook: useAccordionTrigger
});
//# sourceMappingURL=AccordionTrigger.js.map