import { createComponent, createHook, useCreateElement as _useCreateElement } from "reakit-system";
import { useRole } from "reakit";
import { useWarning } from "reakit-warning";
export var useBreadcrumbs = createHook({
  name: "Breadcrumb",
  compose: useRole
});
export var Breadcrumbs = createComponent({
  as: "nav",
  memo: true,
  useHook: useBreadcrumbs,
  useCreateElement: (type, props, children) => {
    useWarning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.", "See https://www.w3.org/TR/wai-aria-practices-1.1/#wai-aria-roles-states-and-properties-2");
    return _useCreateElement(type, props, children);
  }
});
//# sourceMappingURL=Breadcrumbs.js.map