var _excluded = ["onClick"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * All credit goes to [React Spectrum](https://github.com/adobe/react-spectrum)
 * We improved the Calendar from Aria [useCalendarBase](https://github.com/adobe/react-spectrum/blob/main/packages/%40react-aria/calendar/src/useCalendarBase.ts)
 * to work with Reakit System
 */
import { useButton } from "reakit";
import { callAllHandlers } from "@chakra-ui/utils";
import { createComponent, createHook } from "../system";
import { CALENDAR_BUTTON_KEYS } from "./__keys";
export var useCalendarButton = createHook({
  name: "CalendarButton",
  compose: useButton,
  keys: CALENDAR_BUTTON_KEYS,

  useProps(options, _ref) {
    var _HANDLER_TYPES$goto, _HANDLER_TYPES$goto2;

    var {
      onClick: htmlOnClick
    } = _ref,
        htmlProps = _objectWithoutProperties(_ref, _excluded);

    var {
      focusNextMonth,
      focusPreviousMonth,
      focusPreviousYear,
      focusNextYear,
      goto
    } = options;
    var HANDLER_TYPES = {
      nextMonth: {
        handler: focusNextMonth,
        ariaLabel: "Next Month"
      },
      previousMonth: {
        handler: focusPreviousMonth,
        ariaLabel: "Previous Month"
      },
      nextYear: {
        handler: focusNextYear,
        ariaLabel: "Next Year"
      },
      previousYear: {
        handler: focusPreviousYear,
        ariaLabel: "Previous Year"
      }
    };
    return _objectSpread({
      "aria-label": (_HANDLER_TYPES$goto = HANDLER_TYPES[goto]) === null || _HANDLER_TYPES$goto === void 0 ? void 0 : _HANDLER_TYPES$goto.ariaLabel,
      onClick: callAllHandlers(htmlOnClick, (_HANDLER_TYPES$goto2 = HANDLER_TYPES[goto]) === null || _HANDLER_TYPES$goto2 === void 0 ? void 0 : _HANDLER_TYPES$goto2.handler)
    }, htmlProps);
  }

});
export var CalendarButton = createComponent({
  as: "button",
  memo: true,
  useHook: useCalendarButton
});
//# sourceMappingURL=CalendarButton.js.map