var _excluded = ["onMouseEnter"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * All credit goes to [React Spectrum](https://github.com/adobe/react-spectrum)
 * We improved the Calendar from Aria [useCalendarBase](https://github.com/adobe/react-spectrum/blob/main/packages/%40react-aria/calendar/src/useCalendarBase.ts)
 * to work with Reakit System
 */
import { useCallback } from "react";
import { useRole } from "reakit";
import { callAllHandlers } from "@chakra-ui/utils";
import { createComponent, createHook } from "../system";
import { ariaAttr, dataAttr, getDaysInMonth, isSameDay, isWeekend } from "../utils";
import { CALENDAR_CELL_KEYS } from "./__keys";
export var useCalendarCell = createHook({
  name: "CalendarCell",
  compose: useRole,
  keys: CALENDAR_CELL_KEYS,

  useProps(options, _ref) {
    var {
      onMouseEnter: htmlOnMouseEnter
    } = _ref,
        htmlProps = _objectWithoutProperties(_ref, _excluded);

    var {
      isDisabled,
      highlightDate,
      date
    } = options;
    var onMouseEnter = useCallback(() => {
      if (isDisabled) return;
      highlightDate === null || highlightDate === void 0 ? void 0 : highlightDate(date);
    }, [date, highlightDate, isDisabled]);
    return _objectSpread(_objectSpread({
      role: "gridcell",
      "data-weekend": dataAttr(isWeekend(date)),
      onMouseEnter: options.isRangeCalendar ? callAllHandlers(htmlOnMouseEnter, onMouseEnter) : htmlOnMouseEnter
    }, getCalendarCellProps(options)), htmlProps);
  }

});
export var CalendarCell = createComponent({
  as: "div",
  memo: true,
  useHook: useCalendarCell
});

var getCalendarCellProps = options => {
  var {
    date,
    dateValue,
    highlightedRange,
    currentMonth
  } = options;

  if (options.isRangeCalendar) {
    var _isSelected = highlightedRange ? date >= highlightedRange.start && date <= highlightedRange.end : false;

    var isRangeStart = _isSelected && date.getDate() === 1;

    var isRangeEnd = _isSelected && date.getDate() === getDaysInMonth(currentMonth);

    var isSelectionStart = highlightedRange ? isSameDay(date, highlightedRange.start) : false;
    var isSelectionEnd = highlightedRange ? isSameDay(date, highlightedRange.end) : false;
    return {
      "aria-selected": ariaAttr(_isSelected),
      "data-is-range-selection": dataAttr(_isSelected),
      "data-is-range-end": dataAttr(isRangeEnd),
      "data-is-range-start": dataAttr(isRangeStart),
      "data-is-selection-end": dataAttr(isSelectionEnd),
      "data-is-selection-start": dataAttr(isSelectionStart)
    };
  }

  var isSelected = dateValue ? isSameDay(date, dateValue) : false;
  return {
    "aria-selected": ariaAttr(isSelected)
  };
};
//# sourceMappingURL=CalendarCell.js.map