var _excluded = ["ref", "onKeyDown", "onBlur", "onBlur"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * All credit goes to [React Spectrum](https://github.com/adobe/react-spectrum)
 * We improved the Calendar from Stately [useWeekStart](https://github.com/adobe/react-spectrum/blob/main/packages/%40react-stately/calendar/src/useWeekStart.ts)
 * to work with Reakit System
 */
import { useRef } from "react";
import { useRole } from "reakit";
import { createOnKeyDown, useForkRef } from "reakit-utils";
import { callAllHandlers } from "@chakra-ui/utils";
import { chain } from "@react-aria/utils";
import { createComponent, createHook } from "../system";
import { ariaAttr } from "../utils";
import { CALENDAR_GRID_KEYS } from "./__keys";
export var useCalendarGrid = createHook({
  name: "CalendarGrid",
  compose: useRole,
  keys: CALENDAR_GRID_KEYS,

  useProps(options, _ref) {
    var {
      ref: htmlRef,
      onKeyDown: htmlOnKeyDown,
      onBlur: htmlOnFocus,
      onBlur: htmlOnBlur
    } = _ref,
        htmlProps = _objectWithoutProperties(_ref, _excluded);

    var {
      isReadOnly,
      isDisabled,
      setFocused,
      selectFocusedDate,
      focusPreviousYear,
      focusPreviousMonth,
      focusNextYear,
      focusNextMonth,
      focusEndOfMonth,
      focusStartOfMonth,
      focusNextDay,
      focusPreviousDay,
      focusNextWeek,
      focusPreviousWeek,
      calendarId,
      setAnchorDate
    } = options;
    var ref = useRef(null);
    var onKeyDown = createOnKeyDown({
      onKeyDown: htmlOnKeyDown,
      preventDefault: true,
      keyMap: event => {
        var shift = event.shiftKey;
        return {
          " ": selectFocusedDate,
          Enter: selectFocusedDate,
          End: focusEndOfMonth,
          Home: focusStartOfMonth,
          ArrowLeft: focusPreviousDay,
          ArrowUp: focusPreviousWeek,
          ArrowRight: focusNextDay,
          ArrowDown: focusNextWeek,
          PageUp: () => {
            shift ? focusPreviousYear() : focusPreviousMonth();
          },
          PageDown: () => {
            shift ? focusNextYear() : focusNextMonth();
          }
        };
      }
    });
    var rangeCalendarProps = {};

    if (options.isRangeCalendar) {
      var onRangeKeyDown = e => {
        switch (e.key) {
          case "Escape":
            // Cancel the selection.
            setAnchorDate === null || setAnchorDate === void 0 ? void 0 : setAnchorDate(null);
            break;
        }
      };

      rangeCalendarProps = {
        "aria-multiselectable": true,
        onKeyDown: callAllHandlers(htmlOnKeyDown, chain(onKeyDown, onRangeKeyDown))
      };
    }

    return _objectSpread(_objectSpread({
      ref: useForkRef(ref, htmlRef),
      role: "grid",
      "aria-labelledby": calendarId,
      "aria-readonly": ariaAttr(isReadOnly),
      "aria-disabled": ariaAttr(isDisabled),
      onKeyDown: callAllHandlers(htmlOnKeyDown, onKeyDown),
      onFocus: callAllHandlers(htmlOnFocus, () => setFocused(true)),
      onBlur: callAllHandlers(htmlOnBlur, () => setFocused(false))
    }, rangeCalendarProps), htmlProps);
  }

});
export var CalendarGrid = createComponent({
  as: "div",
  memo: true,
  useHook: useCalendarGrid
});
//# sourceMappingURL=CalendarGrid.js.map