function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { useRole } from "reakit";
import { useDateFormatter } from "@react-aria/i18n";
import { createComponent, createHook } from "../system";
import { CALENDAR_HEADER_KEYS } from "./__keys";
export var useCalendarHeader = createHook({
  name: "CalendarHeader",
  compose: useRole,
  keys: CALENDAR_HEADER_KEYS,

  useProps(_ref, htmlProps) {
    var {
      format = {
        month: "long",
        year: "numeric"
      },
      currentMonth,
      calendarId
    } = _ref;
    return _objectSpread({
      id: calendarId,
      children: useDateFormatter(format).format(currentMonth),
      "aria-live": "polite"
    }, htmlProps);
  }

});
export var CalendarHeader = createComponent({
  as: "h2",
  memo: true,
  useHook: useCalendarHeader
});
//# sourceMappingURL=CalendarHeader.js.map