var _excluded = ["value", "defaultValue", "onChange"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * All credit goes to [React Spectrum](https://github.com/adobe/react-spectrum)
 * We improved the Calendar from Stately [useRangeCalendar](https://github.com/adobe/react-spectrum/blob/main/packages/%40react-aria/calendar/src/useRangeCalendar.ts)
 * to work with Reakit System
 */
import * as React from "react";
import { useDateFormatter } from "@react-aria/i18n";
import { addDays, isSameDay, toUTCRangeString, toUTCString, useControllableState } from "../utils";
import { announce } from "../utils/LiveAnnouncer";
import { useCalendarState } from "./CalendarState";
import { makeRange } from "./helpers";
export function useRangeCalendarState() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var {
    value: initialValue,
    defaultValue = {
      start: toUTCString(new Date()),
      end: toUTCString(addDays(new Date(), 1))
    },
    onChange
  } = props,
      calendarProps = _objectWithoutProperties(props, _excluded);

  var [value, setValue] = useControllableState({
    value: initialValue,
    defaultValue,
    onChange
  });
  var dateRange = React.useMemo(() => ({
    start: new Date(value.start),
    end: new Date(value.end)
  }), [value.end, value.start]);
  var [anchorDate, setAnchorDate] = React.useState(null);
  var [lastSelectedDate, setLastSelectedDate] = React.useState(dateRange.end);
  var calendar = useCalendarState(_objectSpread(_objectSpread({}, calendarProps), {}, {
    value: toUTCString(lastSelectedDate)
  }));
  var highlightedRange = anchorDate ? makeRange(anchorDate, calendar.focusedDate) : value && dateRange && makeRange(dateRange.start, dateRange.end);
  var dateFormatter = useDateFormatter({
    dateStyle: "full"
  });
  var announceRange = React.useCallback(() => {
    if (!highlightedRange) return;

    if (isSameDay(highlightedRange.start, highlightedRange.end)) {
      announce("Selected range, from ".concat(dateFormatter.format(highlightedRange.start), " to ").concat(dateFormatter.format(highlightedRange.start)));
    } else {
      announce("Selected range from ".concat(dateFormatter.format(highlightedRange.start), " to ").concat(dateFormatter.format(highlightedRange.start)));
    }
  }, [dateFormatter, highlightedRange]);
  var selectDate = React.useCallback(date => {
    if (props.isReadOnly) return;
    setLastSelectedDate(date);

    if (!anchorDate) {
      setAnchorDate(date);
      announce("Starting range from ".concat(dateFormatter.format(date)));
    } else {
      setValue(toUTCRangeString(makeRange(anchorDate, date)));
      announceRange();
      setAnchorDate(null);
    }
  }, [anchorDate, announceRange, dateFormatter, props.isReadOnly, setValue]);
  var setDateValue = React.useCallback(value => {
    setValue(toUTCRangeString(value));
  }, [setValue]);
  return _objectSpread(_objectSpread({}, calendar), {}, {
    dateRangeValue: dateRange,
    setDateRangeValue: setDateValue,
    anchorDate,
    setAnchorDate,
    highlightedRange,
    selectDate,

    selectFocusedDate() {
      selectDate(calendar.focusedDate);
    },

    highlightDate(date) {
      if (!anchorDate) return;
      calendar.setFocusedDate(date);
    },

    isRangeCalendar: true
  });
}
//# sourceMappingURL=RangeCalendarState.js.map