var _excluded = ["unstable_clickOnEnter"],
    _excluded2 = ["ref", "onChange", "onClick"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import * as React from "react";
import { useClickable } from "reakit";
import { removeIndexFromArray, useForkRef, useLiveRef } from "reakit-utils";
import { warning } from "reakit-warning";
import { createComponent, createHook } from "../system";
import { CHECKBOX_KEYS } from "./__keys";
import { fireChange, getChecked, useIndeterminateState } from "./helpers";
export var useCheckbox = createHook({
  name: "Checkbox",
  compose: useClickable,
  keys: CHECKBOX_KEYS,

  useOptions(options, htmlProps) {
    var {
      unstable_clickOnEnter = false
    } = options,
        restOptions = _objectWithoutProperties(options, _excluded);

    var {
      value,
      checked
    } = htmlProps;
    return _objectSpread({
      unstable_clickOnEnter,
      value,
      checked: getChecked(_objectSpread({
        checked
      }, options))
    }, restOptions);
  },

  useProps(options, htmlProps) {
    var {
      state,
      setState,
      value,
      checked,
      disabled
    } = options;

    var {
      ref: htmlRef,
      onChange: htmlOnChange,
      onClick: htmlOnClick
    } = htmlProps,
        restHtmlProps = _objectWithoutProperties(htmlProps, _excluded2);

    var ref = React.useRef(null);
    var [isNativeCheckbox, setIsNativeCheckbox] = React.useState(true);
    var onChangeRef = useLiveRef(htmlOnChange);
    var onClickRef = useLiveRef(htmlOnClick);
    React.useEffect(() => {
      var element = ref.current;

      if (!element) {
        warning(true, "Can't determine whether the element is a native checkbox because `ref` wasn't passed to the component");
        return;
      }

      if (element.tagName !== "INPUT" || element.type !== "checkbox") {
        setIsNativeCheckbox(false);
      }
    }, []);
    useIndeterminateState(ref, options);
    var onChange = React.useCallback(event => {
      var element = event.currentTarget;

      if (disabled) {
        event.stopPropagation();
        event.preventDefault();
        return;
      }

      if (onChangeRef.current) {
        // If component is NOT rendered as a native input, it will not have
        // the `checked` property. So we assign it for consistency.
        if (!isNativeCheckbox) {
          element.checked = !element.checked;
        }

        onChangeRef.current(event);
      }

      if (!setState) return;

      if (typeof value === "undefined") {
        setState(!checked);
      } else {
        var stateProp = Array.isArray(state) ? state : [];
        var index = stateProp.indexOf(value);

        if (index === -1) {
          setState([...stateProp, value]);
        } else {
          setState(removeIndexFromArray(stateProp, index));
        }
      }
    }, [disabled, onChangeRef, setState, value, isNativeCheckbox, checked, state]);
    var onClick = React.useCallback(event => {
      var _onClickRef$current;

      (_onClickRef$current = onClickRef.current) === null || _onClickRef$current === void 0 ? void 0 : _onClickRef$current.call(onClickRef, event);
      if (event.defaultPrevented) return;
      if (isNativeCheckbox) return;
      fireChange(event.currentTarget, onChange);
    }, [isNativeCheckbox, onChange, onClickRef]);
    return _objectSpread({
      ref: useForkRef(ref, htmlRef),
      role: !isNativeCheckbox ? "checkbox" : undefined,
      type: isNativeCheckbox ? "checkbox" : undefined,
      value: isNativeCheckbox ? value : undefined,
      checked: checked,
      "aria-checked": state === "indeterminate" ? "mixed" : checked,
      onChange,
      onClick
    }, restHtmlProps);
  }

});
export var Checkbox = createComponent({
  as: "input",
  memo: true,
  useHook: useCheckbox
});
//# sourceMappingURL=Checkbox.js.map