function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { usePickerBase } from "../picker-base";
import { createComponent, createHook } from "../system";
import { ariaAttr } from "../utils";
import { DATE_PICKER_KEYS } from "./__keys";
export var useDatePicker = createHook({
  name: "DatePicker",
  compose: usePickerBase,
  keys: DATE_PICKER_KEYS,

  useProps(options, htmlProps) {
    var {
      validationState,
      isRequired
    } = options;
    return _objectSpread({
      "aria-invalid": ariaAttr(validationState === "invalid"),
      "aria-required": ariaAttr(isRequired)
    }, htmlProps);
  }

});
export var DatePicker = createComponent({
  as: "div",
  memo: true,
  useHook: useDatePicker
});
//# sourceMappingURL=DatePicker.js.map