import * as React from "react";
import { Portal } from "reakit";
import { closest } from "reakit-utils/closest";
export function usePortalRef(dialogRef, options) {
  var {
    visible
  } = options;
  var portalRef = React.useRef(null);
  React.useEffect(() => {
    var dialog = dialogRef.current;
    if (!dialog || !visible) return;
    portalRef.current = closest(dialog, Portal.__selector);
  }, [dialogRef, visible]);
  return portalRef;
}
//# sourceMappingURL=usePortalRef.js.map