var _excluded = ["onClick", "aria-controls"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from "react";
import { createComponent } from "reakit-system";
import { useButton as useReakitButton } from "reakit";
import { useLiveRef } from "reakit-utils";
import { createComposableHook } from "../system";
import { DISCLOSURE_KEYS } from "./__keys";
export var disclosureComposableButton = createComposableHook({
  name: "Disclosure",
  compose: useReakitButton,
  keys: DISCLOSURE_KEYS,

  useProps(options, htmlProps) {
    var {
      toggle,
      visible,
      baseId
    } = options;

    var {
      onClick: htmlOnClick,
      "aria-controls": ariaControls
    } = htmlProps,
        restHtmlProps = _objectWithoutProperties(htmlProps, _excluded);

    var controls = ariaControls ? "".concat(ariaControls, " ").concat(baseId) : baseId;
    var onClickRef = useLiveRef(htmlOnClick);
    var onClick = React.useCallback(event => {
      var _onClickRef$current;

      (_onClickRef$current = onClickRef.current) === null || _onClickRef$current === void 0 ? void 0 : _onClickRef$current.call(onClickRef, event);
      if (event.defaultPrevented) return;
      toggle === null || toggle === void 0 ? void 0 : toggle();
    }, [onClickRef, toggle]);
    return _objectSpread({
      "aria-controls": controls,
      "aria-expanded": visible,
      "data-enter": visible ? "" : undefined,
      "data-leave": !visible ? "" : undefined,
      onClick
    }, restHtmlProps);
  }

});
export var useDisclosure = disclosureComposableButton();
export var Disclosure = createComponent({
  as: "button",
  memo: true,
  useHook: useDisclosure
});
//# sourceMappingURL=Disclosure.js.map