var _excluded = ["visible", "animationPresent"],
    _excluded2 = ["style", "onTransitionEnd", "onAnimationEnd"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

// Inspired from Radix UI https://github.com/radix-ui/primitives/tree/main/packages/react/collapsible
import * as React from "react";
import { createComponent } from "reakit-system";
import { useBox } from "reakit";
import { useLiveRef } from "reakit-utils";
import { createComposableHook } from "../system";
import { DISCLOSURE_CONTENT_KEYS } from "./__keys";
import { useAnimation } from "./helpers";
export var disclosureComposableContent = createComposableHook({
  name: "DisclosureContent",
  compose: useBox,
  keys: DISCLOSURE_CONTENT_KEYS,

  useOptions(options, htmlProps) {
    var {
      visible,
      animationPresent = false
    } = options,
        restOptions = _objectWithoutProperties(options, _excluded);

    var {
      state,
      animating,
      onEnd
    } = useAnimation({
      visible
    });
    var isVisible = visible && animating;
    var isHidden = !visible && !animating;
    return _objectSpread(_objectSpread({
      animationPresent,
      visible
    }, restOptions), {}, {
      isVisible,
      isHidden,
      state,
      animating,
      onEnd
    });
  },

  useProps(options, htmlProps) {
    var {
      baseId,
      onEnd,
      isHidden,
      isVisible,
      state,
      animationPresent
    } = options;

    var {
      style: htmlStyle,
      onTransitionEnd: htmlOnTransitionEnd,
      onAnimationEnd: htmlOnAnimationEnd
    } = htmlProps,
        restHtmlProps = _objectWithoutProperties(htmlProps, _excluded2);

    var onTransitionEndRef = useLiveRef(htmlOnTransitionEnd);
    var onAnimationEndRef = useLiveRef(htmlOnAnimationEnd);
    var onTransitionEnd = React.useCallback(event => {
      var _onTransitionEndRef$c;

      (_onTransitionEndRef$c = onTransitionEndRef.current) === null || _onTransitionEndRef$c === void 0 ? void 0 : _onTransitionEndRef$c.call(onTransitionEndRef, event);
      onEnd === null || onEnd === void 0 ? void 0 : onEnd(event);
    }, [onEnd, onTransitionEndRef]);
    var onAnimationEnd = React.useCallback(event => {
      var _onAnimationEndRef$cu;

      (_onAnimationEndRef$cu = onAnimationEndRef.current) === null || _onAnimationEndRef$cu === void 0 ? void 0 : _onAnimationEndRef$cu.call(onAnimationEndRef, event);
      onEnd === null || onEnd === void 0 ? void 0 : onEnd(event);
    }, [onAnimationEndRef, onEnd]);

    var style = _objectSpread({
      display: isHidden ? "none" : undefined
    }, htmlStyle);

    return _objectSpread({
      id: baseId,
      hidden: isHidden,
      "data-enter": animationPresent ? isVisible ? "" : undefined : state === "enter" ? "" : undefined,
      "data-leave": state === "leave" ? "" : undefined,
      onTransitionEnd,
      onAnimationEnd,
      style
    }, restHtmlProps);
  }

});
export var useDisclosureContent = disclosureComposableContent();
export var DisclosureContent = createComponent({
  as: "div",
  memo: true,
  useHook: useDisclosureContent
});
//# sourceMappingURL=DisclosureContent.js.map