function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import * as React from "react";
import { unstable_useIdState } from "reakit";
import { useControllableState } from "../utils";
export var useDisclosureState = function useDisclosureState() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var {
    defaultVisible = false,
    visible: initialVisible,
    onVisibleChange
  } = props;
  var id = unstable_useIdState();
  var [visible, setVisible] = useControllableState({
    defaultValue: defaultVisible,
    value: initialVisible,
    onChange: onVisibleChange
  });
  var show = React.useCallback(() => setVisible(true), [setVisible]);
  var hide = React.useCallback(() => setVisible(false), [setVisible]);
  var toggle = React.useCallback(() => setVisible(e => !e), [setVisible]);
  return _objectSpread(_objectSpread({}, id), {}, {
    visible,
    setVisible,
    show,
    hide,
    toggle
  });
};
//# sourceMappingURL=DisclosureState.js.map