var _excluded = ["ref"];

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import * as React from "react";
import { useClickable } from "reakit";
import { useForkRef } from "reakit-utils";
import { useWarning } from "reakit-warning";
import { createComponent, createHook } from "../system";
import { LINK_KEYS } from "./__keys";
export var useLink = createHook({
  name: "Link",
  compose: useClickable,
  keys: LINK_KEYS,

  useOptions(options) {
    return _objectSpread({
      unstable_clickOnSpace: false
    }, options);
  },

  useProps(_ref, _ref2) {
    var {
      isExternal
    } = _ref;

    var {
      ref: htmlRef
    } = _ref2,
        htmlProps = _objectWithoutProperties(_ref2, _excluded);

    var ref = React.useRef(null);
    var [role, setRole] = React.useState(undefined);
    React.useEffect(() => {
      var element = ref.current;

      if (!element) {
        // eslint-disable-next-line react-hooks/rules-of-hooks
        useWarning(true, "Can't determine whether the element is a native link because `ref` wasn't passed to the component");
        return;
      }

      if (element.tagName !== "A") {
        setRole("link");
      }
    }, []);
    return _objectSpread(_objectSpread({
      ref: useForkRef(ref, htmlRef),
      role
    }, isExternal && {
      target: "_blank",
      rel: "noopener noreferrer"
    }), htmlProps);
  }

});
export var Link = createComponent({
  as: "a",
  memo: true,
  useHook: useLink
});
//# sourceMappingURL=Link.js.map