var _excluded = ["onMouseDown", "onMouseUp", "onMouseLeave", "onTouchStart", "onTouchEnd"];

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import * as React from "react";
import { useButton } from "reakit";
import { callAllHandlers } from "@chakra-ui/utils";
import { createComponent, createHook } from "../system";
import { NUMBER_INPUT_INCREMENT_BUTTON_KEYS } from "./__keys";
export var useNumberInputIncrementButton = createHook({
  name: "NumberInput",
  compose: useButton,
  keys: NUMBER_INPUT_INCREMENT_BUTTON_KEYS,

  useOptions(options) {
    var {
      keepWithinRange,
      isAtMax
    } = options;
    var disabled = options.disabled || keepWithinRange && isAtMax || options.isDisabled;
    return _objectSpread(_objectSpread({}, options), {}, {
      disabled
    });
  },

  useProps(options, _ref) {
    var {
      onMouseDown,
      onMouseUp,
      onMouseLeave,
      onTouchStart,
      onTouchEnd
    } = _ref,
        htmlProps = _objectWithoutProperties(_ref, _excluded);

    var {
      spinUp: spinUpProp,
      spinStop: spinStopProp,
      focusInput
    } = options;
    var spinUp = React.useCallback(event => {
      event.preventDefault();
      spinUpProp();
      focusInput();
    }, [focusInput, spinUpProp]);
    var spinStop = React.useCallback(event => {
      event.preventDefault();
      spinStopProp();
    }, [spinStopProp]);
    React.useEffect(() => {
      // Need to stop the spinner when isAtMax
      if (options.disabled) spinStopProp();
    }, [options.disabled, spinStopProp]);
    return _objectSpread({
      "aria-hidden": true,
      tabIndex: -1,
      onMouseDown: callAllHandlers(onMouseDown, spinUp),
      onTouchStart: callAllHandlers(onTouchStart, spinUp),
      onMouseUp: callAllHandlers(onMouseUp, spinStop),
      onMouseLeave: callAllHandlers(onMouseLeave, spinStop),
      onTouchEnd: callAllHandlers(onTouchEnd, spinStop)
    }, htmlProps);
  }

});
export var NumberInputIncrementButton = createComponent({
  as: "button",
  memo: true,
  useHook: useNumberInputIncrementButton
});
//# sourceMappingURL=NumberInputIncrementButton.js.map