import { createComponent, createHook, useCreateElement as _useCreateElement } from "reakit-system";
import { useRole } from "reakit";
import { useWarning } from "reakit-warning";
import { PAGINATION_KEYS } from "./__keys";
export var usePagination = createHook({
  name: "Pagination",
  compose: useRole,
  keys: PAGINATION_KEYS
});
export var Pagination = createComponent({
  as: "nav",
  memo: true,
  useHook: usePagination,
  useCreateElement: (type, props, children) => {
    useWarning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.", "See https://mzl.la/2VCL8ys");
    return _useCreateElement(type, props, children);
  }
});
//# sourceMappingURL=Pagination.js.map