var _excluded = ["onClick"];

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import * as React from "react";
import { useButton } from "reakit";
import { callAllHandlers, isNumber } from "@chakra-ui/utils";
import { createComponent, createHook } from "../system";
import { PAGINATION_BUTTON_KEYS } from "./__keys";
export var usePaginationButton = createHook({
  name: "PaginationButton",
  compose: useButton,
  keys: PAGINATION_BUTTON_KEYS,

  useOptions(options, _ref) {
    var {
      disabled: htmlDisabled
    } = _ref;
    var {
      goto,
      isAtLastPage,
      isAtFirstPage
    } = options;
    var disabled = false;

    if (goto === "nextPage" || goto === "lastPage") {
      disabled = isAtLastPage;
    }

    if (goto === "prevPage" || goto === "firstPage") {
      disabled = isAtFirstPage;
    }

    return _objectSpread({
      disabled: htmlDisabled || disabled
    }, options);
  },

  useProps(options, _ref2) {
    var {
      onClick: htmlOnClick
    } = _ref2,
        htmlProps = _objectWithoutProperties(_ref2, _excluded);

    var {
      currentPage,
      goto
    } = options;
    var isCurrent = currentPage === goto;
    var onClick = React.useCallback(() => {
      if (options.disabled) return;

      if (isNumber(goto)) {
        var _options$movePage;

        (_options$movePage = options.movePage) === null || _options$movePage === void 0 ? void 0 : _options$movePage.call(options, goto);
        return;
      }

      if (["nextPage", "prevPage", "lastPage", "firstPage"].includes(goto)) {
        var _options$goto;

        (_options$goto = options[goto]) === null || _options$goto === void 0 ? void 0 : _options$goto.call(options);
        return;
      }
    }, [goto, options]);
    var ariaLabel = isCurrent ? "Page ".concat(goto) : "Go to ".concat(goto === "prevPage" ? "previous" : goto, " Page");
    return _objectSpread({
      "aria-label": ariaLabel,
      "aria-current": isCurrent ? true : undefined,
      onClick: callAllHandlers(onClick, htmlOnClick)
    }, htmlProps);
  }

});
export var PaginationButton = createComponent({
  as: "button",
  memo: true,
  useHook: usePaginationButton
});
//# sourceMappingURL=PaginationButton.js.map