var _excluded = ["onKeyDown", "onClick", "onMouseDown"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import * as React from "react";
import { useRole } from "reakit";
import { createOnKeyDown } from "reakit-utils";
import { callAllHandlers } from "@chakra-ui/utils";
import { createComponent, createHook } from "../system";
import { ariaAttr, isTouch } from "../utils";
import { PICKER_BASE_KEYS } from "./__keys";
export var usePickerBase = createHook({
  name: "PickerBase",
  compose: useRole,
  keys: PICKER_BASE_KEYS,

  useProps(options, _ref) {
    var {
      onKeyDown: htmlOnKeyDown,
      onClick: htmlOnClick,
      onMouseDown: htmlOnMouseDown
    } = _ref,
        htmlProps = _objectWithoutProperties(_ref, _excluded);

    var {
      visible,
      isDisabled,
      isReadOnly,
      show,
      pickerId,
      dialogId,
      segmentFocus
    } = options;
    var onClick = React.useCallback(() => {
      if (isTouch()) show();
    }, [show]); // Open the popover on alt + arrow down

    var onKeyDown = createOnKeyDown({
      onKey: htmlOnKeyDown,
      preventDefault: true,
      keyMap: event => {
        var isAlt = event.altKey;
        return {
          ArrowDown: () => {
            isAlt && show();
          }
        };
      }
    });
    var onMouseDown = React.useCallback(e => {
      e.stopPropagation();
      segmentFocus === null || segmentFocus === void 0 ? void 0 : segmentFocus();
    }, [segmentFocus]);
    return _objectSpread({
      id: pickerId,
      role: "button",
      "aria-haspopup": "dialog",
      "aria-expanded": visible,
      "aria-owns": visible ? dialogId : undefined,
      "aria-disabled": ariaAttr(isDisabled),
      "aria-readonly": ariaAttr(isReadOnly),
      onKeyDown: callAllHandlers(htmlOnKeyDown, onKeyDown),
      onClick: callAllHandlers(htmlOnClick, onClick),
      onMouseDown: callAllHandlers(htmlOnMouseDown, onMouseDown)
    }, htmlProps);
  }

});
export var PickerBase = createComponent({
  as: "div",
  memo: true,
  useHook: usePickerBase
});
//# sourceMappingURL=PickerBase.js.map