var _excluded = ["enableCollisionsDetection", "side", "align", "sideOffset", "alignOffset", "arrowOffset", "collisionTolerance", "modal"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import * as React from "react";
import { getPlacementData } from "@radix-ui/popper";
import { useRect } from "@radix-ui/react-use-rect";
import { useSize } from "@radix-ui/react-use-size";
import { useDialogState } from "../dialog";
export var usePopoverState = function usePopoverState() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var {
    enableCollisionsDetection,
    side: initialSide = "bottom",
    align: initialAlign = "center",
    sideOffset: initialSideOffset = 5,
    alignOffset: initialAlignOffset = 0,
    arrowOffset: initialArrowOffset = 20,
    collisionTolerance: initialCollisionTolerance = 0,
    modal = false
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var dialog = useDialogState(_objectSpread({
    modal
  }, restProps));
  var [side, setSide] = React.useState(initialSide);
  var [align, setAlign] = React.useState(initialAlign);
  var [sideOffset, setSideOffset] = React.useState(initialSideOffset);
  var [alignOffset, setAlignOffset] = React.useState(initialAlignOffset);
  var [arrowOffset, setArrowOffset] = React.useState(initialArrowOffset);
  var [collisionTolerance, setCollisionTolerance] = React.useState(initialCollisionTolerance);
  var [anchor, setAnchor] = React.useState(null);
  var anchorRect = useRect(anchor);
  var [popper, setPopper] = React.useState(null);
  var popperSize = useSize(popper);
  var [arrow, setArrow] = React.useState(null);
  var arrowSize = useSize(arrow);
  var windowSize = useWindowSize();
  var collisionBoundariesRect = windowSize ? DOMRect.fromRect(_objectSpread(_objectSpread({}, windowSize), {}, {
    x: 0,
    y: 0
  })) : undefined;
  var placementData = getPlacementData({
    popperSize,
    anchorRect,
    arrowSize,
    arrowOffset,
    side,
    sideOffset,
    align,
    alignOffset,
    shouldAvoidCollisions: enableCollisionsDetection,
    collisionBoundariesRect,
    collisionTolerance
  });
  return _objectSpread(_objectSpread(_objectSpread({}, placementData), dialog), {}, {
    side,
    align,
    sideOffset,
    alignOffset,
    arrowOffset,
    collisionTolerance,
    anchor,
    popper,
    arrow,
    setSide,
    setAlign,
    setSideOffset,
    setAlignOffset,
    setArrowOffset,
    setCollisionTolerance,
    setAnchor,
    setPopper,
    setArrow
  });
};
var WINDOW_RESIZE_DEBOUNCE_WAIT_IN_MS = 100;

function useWindowSize() {
  var [windowSize, setWindowSize] = React.useState(undefined);
  React.useEffect(() => {
    var debounceTimerId;

    function updateWindowSize() {
      setWindowSize({
        width: window.innerWidth,
        height: window.innerHeight
      });
    }

    function handleResize() {
      window.clearTimeout(debounceTimerId);
      debounceTimerId = window.setTimeout(updateWindowSize, WINDOW_RESIZE_DEBOUNCE_WAIT_IN_MS);
    }

    updateWindowSize();
    window.addEventListener("resize", handleResize);
    return () => window.removeEventListener("resize", handleResize);
  }, []);
  return windowSize;
}
//# sourceMappingURL=PopoverState.js.map