function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * All credit goes to [Segun Adebayo](https://github.com/segunadebayo) for
 * creating an Awesome Library [Chakra UI](https://github.com/chakra-ui/chakra-ui/)
 * We improved the Progress Component [Progress](https://github.com/chakra-ui/chakra-ui/tree/develop/packages/progress)
 * to work with Reakit System
 */
import { createComponent, createHook, useCreateElement as _useCreateElement } from "reakit-system";
import { useRole } from "reakit";
import { useWarning } from "reakit-warning";
import { dataAttr, isNull } from "../utils";
import { PROGRESS_KEYS } from "./__keys";
export var useProgress = createHook({
  name: "Progress",
  compose: useRole,
  keys: PROGRESS_KEYS,

  useProps(options, htmlProps) {
    var {
      isIndeterminate,
      value,
      max,
      min
    } = options;
    return _objectSpread({
      role: "progressbar",
      "data-indeterminate": dataAttr(isIndeterminate),
      "aria-valuemax": max,
      "aria-valuemin": min,
      "aria-valuenow": isNull(value) ? undefined : value,
      "aria-valuetext": !(value !== null && value !== void 0 && value.toString()) ? "intermediate" : value.toString()
    }, htmlProps);
  }

});
export var Progress = createComponent({
  as: "div",
  memo: true,
  useHook: useProgress,
  useCreateElement: (type, props, children) => {
    useWarning(!props["aria-label"] && !props["aria-labelledby"], "You should provide either `aria-label` or `aria-labelledby` props.", "See https://www.w3.org/TR/wai-aria-1.2/#progressbar");
    return _useCreateElement(type, props, children);
  }
});
//# sourceMappingURL=Progress.js.map