var _excluded = ["unstable_clickOnEnter", "unstable_checkOnFocus"],
    _excluded2 = ["ref", "onChange", "onClick"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import * as React from "react";
import { useCompositeItem } from "reakit";
import { useForkRef, useLiveRef } from "reakit-utils";
import { warning } from "reakit-warning/warning";
import { createComponent, createHook } from "../system";
import { RADIO_KEYS } from "./__keys";
import { fireChange, getChecked, useInitialChecked } from "./helpers";
export var useRadio = createHook({
  name: "Radio",
  compose: useCompositeItem,
  keys: RADIO_KEYS,

  useOptions(_ref, _ref2) {
    var _options$value;

    var {
      unstable_clickOnEnter = false,
      unstable_checkOnFocus = true
    } = _ref,
        options = _objectWithoutProperties(_ref, _excluded);

    var {
      value,
      checked
    } = _ref2;
    return _objectSpread(_objectSpread({
      checked,
      unstable_clickOnEnter,
      unstable_checkOnFocus
    }, options), {}, {
      value: (_options$value = options.value) !== null && _options$value !== void 0 ? _options$value : value
    });
  },

  useProps(options, _ref3) {
    var {
      ref: htmlRef,
      onChange: htmlOnChange,
      onClick: htmlOnClick
    } = _ref3,
        htmlProps = _objectWithoutProperties(_ref3, _excluded2);

    var {
      currentId,
      id,
      disabled,
      setState,
      value,
      unstable_moves,
      unstable_checkOnFocus,
      baseId
    } = options;
    var ref = React.useRef(null);
    var [isNativeRadio, setIsNativeRadio] = React.useState(true);
    var checked = getChecked(options);
    var isCurrentItemRef = useLiveRef(currentId === id);
    var onChangeRef = useLiveRef(htmlOnChange);
    var onClickRef = useLiveRef(htmlOnClick);
    useInitialChecked(options);
    React.useEffect(() => {
      var element = ref.current;

      if (!element) {
        warning(true, "Can't determine whether the element is a native radio because `ref` wasn't passed to the component");
        return;
      }

      if (element.tagName !== "INPUT" || element.type !== "radio") {
        setIsNativeRadio(false);
      }
    }, []);
    var onChange = React.useCallback(event => {
      var _onChangeRef$current;

      (_onChangeRef$current = onChangeRef.current) === null || _onChangeRef$current === void 0 ? void 0 : _onChangeRef$current.call(onChangeRef, event);
      if (event.defaultPrevented) return;
      if (disabled) return;
      setState === null || setState === void 0 ? void 0 : setState(value);
    }, [disabled, onChangeRef, setState, value]);
    var onClick = React.useCallback(event => {
      var _onClickRef$current;

      (_onClickRef$current = onClickRef.current) === null || _onClickRef$current === void 0 ? void 0 : _onClickRef$current.call(onClickRef, event);
      if (event.defaultPrevented) return;
      if (isNativeRadio) return;
      fireChange(event.currentTarget, onChange);
    }, [onClickRef, isNativeRadio, onChange]);
    React.useEffect(() => {
      var element = ref.current;
      if (!element) return;

      if (unstable_moves && isCurrentItemRef.current && unstable_checkOnFocus) {
        fireChange(element, onChange);
      }
    }, [unstable_moves, unstable_checkOnFocus, onChange, isCurrentItemRef]);
    return _objectSpread({
      ref: useForkRef(ref, htmlRef),
      role: !isNativeRadio ? "radio" : undefined,
      type: isNativeRadio ? "radio" : undefined,
      value: isNativeRadio ? value : undefined,
      name: isNativeRadio ? baseId : undefined,
      "aria-checked": checked,
      checked,
      onChange,
      onClick
    }, htmlProps);
  }

});
export var Radio = createComponent({
  as: "input",
  memo: true,
  useHook: useRadio
});
//# sourceMappingURL=Radio.js.map