import React from "react";
import { closest } from "reakit-utils";
import { useShortcut } from "@chakra-ui/hooks";
import { getNextItemFromSearch } from "@chakra-ui/utils";
import { getIdFromValue } from "../SelectBaseState";
// Reference:
// https://github.com/reakit/reakit/blob/01e73eaff9405ecf8838906684811ef70970b867/packages/reakit/src/Menu/__utils/useShortcuts.ts
export function useTypeaheadShortcut(_ref) {
  var {
    ref,
    options,
    timeout
  } = _ref;
  var onCharacterPress = useShortcut({
    preventDefault: event => event.key !== " ",
    timeout
  });
  React.useEffect(() => {
    var element = ref.current;
    if (!element) return undefined;

    var onKeyDown = event => {
      var _target$getAttribute;

      var target = event.target;
      var role = (_target$getAttribute = target.getAttribute) === null || _target$getAttribute === void 0 ? void 0 : _target$getAttribute.call(target, "role");
      var targetIsDialog = target === element;
      var targetIsOption = role && role.indexOf("option") !== -1 || closest(target, "[role=listbox]") === element;
      if (!targetIsDialog && !targetIsOption) return; // @ts-ignore

      onCharacterPress(handleCharacterPress(options))(event);
    }; // https://github.com/facebook/react/issues/11387#issuecomment-524113945


    element.addEventListener("keydown", onKeyDown);
    return () => element.removeEventListener("keydown", onKeyDown); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [onCharacterPress]);
}

var handleCharacterPress = options => character => {
  var selectedValue = options.values.find(value => {
    var _options$currentValue;

    return (_options$currentValue = options.currentValue) === null || _options$currentValue === void 0 ? void 0 : _options$currentValue.includes(value);
  });
  var nextItem = getNextItemFromSearch(options.values, character, item => item !== null && item !== void 0 ? item : "", selectedValue);

  if (nextItem) {
    var _options$move;

    var nextId = getIdFromValue(options.valuesById, nextItem);
    (_options$move = options.move) === null || _options$move === void 0 ? void 0 : _options$move.call(options, nextId);
  }
};
//# sourceMappingURL=useTypeaheadShortcut.js.map