import { useRole } from "reakit";
import { mergeProps } from "@react-aria/utils";
import { createComponent, createHook } from "../system";
import { SLIDER_LABEL_KEYS } from "./__keys";
export var useSliderLabel = createHook({
  name: "SliderLabel",
  compose: useRole,
  keys: SLIDER_LABEL_KEYS,

  useOptions(options, htmlProps) {
    return options;
  },

  useProps(options, htmlProps) {
    var {
      labelProps
    } = options;
    return mergeProps(labelProps, htmlProps);
  }

});
export var SliderLabel = createComponent({
  as: "label",
  memo: true,
  useHook: useSliderLabel
});
//# sourceMappingURL=SliderLabel.js.map