import { useRole } from "reakit";
import { mergeProps } from "@react-aria/utils";
import { createComponent, createHook } from "../system";
import { SLIDER_LABEL_KEYS } from "./__keys";
export var useSliderOutput = createHook({
  name: "SliderOutput",
  compose: useRole,
  keys: SLIDER_LABEL_KEYS,

  useOptions(options, htmlProps) {
    return options;
  },

  useProps(options, htmlProps) {
    return mergeProps(options.outputProps, htmlProps);
  }

});
export var SliderOutput = createComponent({
  as: "output",
  memo: true,
  useHook: useSliderOutput
});
//# sourceMappingURL=SliderOutput.js.map