import { useRole } from "reakit";
import { mergeProps } from "@react-aria/utils";
import { createComponent, createHook } from "../system";
import { SLIDER_THUMB_KEYS } from "./__keys";
export var useSliderThumb = createHook({
  name: "SliderThumb",
  compose: useRole,
  keys: SLIDER_THUMB_KEYS,

  useProps(options, htmlProps) {
    var {
      thumbProps
    } = options;
    return mergeProps(thumbProps, htmlProps);
  }

});
export var SliderThumb = createComponent({
  as: "div",
  memo: true,
  useHook: useSliderThumb
});
//# sourceMappingURL=SliderThumb.js.map