function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { useComposite } from "reakit/Composite";
import { createComponent, createHook } from "../system";
import { TIME_PICKER_COLUMN_KEYS } from "./__keys";
export var useTimePickerColumn = createHook({
  name: "TimePickerColumn",
  compose: useComposite,
  keys: TIME_PICKER_COLUMN_KEYS,

  useProps(_ref, htmlProps) {
    var {
      columnType
    } = _ref;
    return _objectSpread({
      role: "listbox",
      "aria-label": columnType
    }, htmlProps);
  }

});
export var TimePickerColumn = createComponent({
  as: "div",
  memo: true,
  useHook: useTimePickerColumn
});
//# sourceMappingURL=TimePickerColumn.js.map