var _excluded = ["ref", "onClick", "onKeyDown"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import * as React from "react";
import { useButton, useCompositeItem } from "reakit";
import { useForkRef } from "reakit-utils";
import { callAllHandlers } from "@chakra-ui/utils";
import { createComponent, createHook } from "../system";
import { TIME_PICKER_COLUMN_VALUE_KEYS } from "./__keys";
import { getSelectedValueFromDate } from "./helpers";
export var useTimePickerColumnValue = createHook({
  name: "TimePickerColumnValue",
  compose: [useButton, useCompositeItem],
  keys: TIME_PICKER_COLUMN_VALUE_KEYS,

  useProps(options, _ref) {
    var {
      ref: htmlRef,
      onClick: htmlOnClick,
      onKeyDown: htmlOnKeyDown
    } = _ref,
        htmlProps = _objectWithoutProperties(_ref, _excluded);

    var {
      popover,
      setCurrentId,
      selected,
      value,
      id,
      setSelected,
      visible,
      date,
      updateOldTime,
      restoreOldTime,
      baseId,
      move,
      columnType
    } = options;
    var ref = React.useRef();
    React.useEffect(() => {
      if (selected === value) {
        var _ref$current;

        if (!id) return;
        setCurrentId === null || setCurrentId === void 0 ? void 0 : setCurrentId(id);
        ref === null || ref === void 0 ? void 0 : (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.scrollIntoView();
      } // eslint-disable-next-line react-hooks/exhaustive-deps

    }, [visible]);

    var handleCancellation = () => {
      var _ref$current2;

      var oldTime = restoreOldTime === null || restoreOldTime === void 0 ? void 0 : restoreOldTime();
      if (!oldTime) return;

      if (oldTime.getTime() === date.getTime()) {
        popover === null || popover === void 0 ? void 0 : popover.hide();
      }

      var idx = getSelectedValueFromDate(oldTime, columnType);
      var id = idx + (columnType === "hour" ? 0 : 1);
      ref === null || ref === void 0 ? void 0 : (_ref$current2 = ref.current) === null || _ref$current2 === void 0 ? void 0 : _ref$current2.scrollIntoView();
      move("".concat(baseId, "-").concat(id));
    };

    var handleSubmit = () => {
      setSelected(value, true);
      updateOldTime === null || updateOldTime === void 0 ? void 0 : updateOldTime();
    };

    var onClick = React.useCallback(() => {
      setSelected(value);
    }, [setSelected, value]);
    var onKeyDown = React.useCallback(e => {
      e.preventDefault();

      if (e.key === "Escape") {
        handleCancellation();
        return;
      }

      if (e.key === "Enter") {
        handleSubmit();
        return;
      }
    }, // eslint-disable-next-line react-hooks/exhaustive-deps
    [restoreOldTime, updateOldTime, setSelected, value]);
    return _objectSpread({
      role: "option",
      "aria-selected": selected === value,
      ref: useForkRef(ref, htmlRef),
      onClick: callAllHandlers(htmlOnClick, onClick),
      onKeyDown: callAllHandlers(htmlOnKeyDown, onKeyDown)
    }, htmlProps);
  }

});
export var TimePickerColumnValue = createComponent({
  as: "div",
  memo: true,
  useHook: useTimePickerColumnValue
});
//# sourceMappingURL=TimePickerColumnValue.js.map