var _excluded = ["children"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import * as React from "react";
import { createContext } from "@chakra-ui/react-utils";
import { ActionType, genId, useToastState } from "./index";
import { jsx as _jsx } from "react/jsx-runtime";
export function createToastStore(defaultOptions) {
  var [ToastStoreProvider, useToastStore] = createContext({
    strict: false,
    name: "ToastsState",
    errorMessage: "useToastStore must be used within ToastProvider"
  });
  var [CreateToastProvider, useCreateToast] = createContext({
    strict: false,
    name: "CreateToast",
    errorMessage: "useCreateToast must be used within ToastProvider"
  });
  var [ToastHandlersProvider, useToastHandlers] = createContext({
    strict: false,
    name: "ToastHandlers",
    errorMessage: "useToastHandlers must be used within ToastProvider"
  });

  var ToastProvider = props => {
    var {
      children
    } = props,
        rest = _objectWithoutProperties(props, _excluded);

    var {
      toasts,
      dispatch
    } = useToastState();
    var context = React.useMemo(() => ({
      toasts,
      dispatch
    }), [toasts, dispatch]);
    var createToast = React.useCallback((content, opts) => _objectSpread(_objectSpread(_objectSpread(_objectSpread({
      visible: false,
      reverseOrder: true,
      createdAt: Date.now()
    }, defaultOptions), rest), opts), {}, {
      content,
      id: (opts === null || opts === void 0 ? void 0 : opts.id) || genId()
    }), // Since its only a few object https://twitter.com/dan_abramov/status/1104414272753487872
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [JSON.stringify(rest)]);
    var addToast = React.useCallback((content, options) => {
      var toast = createToast(content, options);
      dispatch({
        type: ActionType.ADD_TOAST,
        toast: _objectSpread(_objectSpread({}, toast), {}, {
          visible: true
        })
      });
      return toast.id;
    }, [createToast, dispatch]);
    var showToast = React.useCallback((content, options) => {
      var toast = createToast(content, options);
      dispatch({
        type: ActionType.ADD_TOAST,
        toast
      });
      setTimeout(() => {
        dispatch({
          type: ActionType.UPDATE_TOAST,
          toast: _objectSpread(_objectSpread({}, toast), {}, {
            visible: true
          })
        });
      }, 0);
      return toast.id;
    }, [createToast, dispatch]);
    var updateToast = React.useCallback((toastId, toast) => {
      dispatch({
        type: ActionType.UPDATE_TOAST,
        toast: _objectSpread(_objectSpread({}, toast), {}, {
          id: toastId
        })
      });
    }, [dispatch]);
    var updateFieldToast = React.useCallback((field, fieldValue, toast) => {
      dispatch({
        type: ActionType.UPDATE_FIELD_TOAST,
        field,
        fieldValue,
        toast
      });
    }, [dispatch]);
    var updateAllToast = React.useCallback(toast => {
      dispatch({
        type: ActionType.UPDATE_ALL_TOAST,
        toast
      });
    }, [dispatch]);
    var dismissToast = React.useCallback(toastId => {
      var unmountDuration = defaultOptions.animationDuration;
      dispatch({
        type: ActionType.DISMISS_TOAST,
        toastId
      });
      setTimeout(() => {
        dispatch({
          type: ActionType.REMOVE_TOAST,
          toastId
        });
      }, unmountDuration);
    }, [dispatch]);
    var removeToast = React.useCallback(toastId => {
      dispatch({
        type: ActionType.REMOVE_TOAST,
        toastId
      });
    }, [dispatch]);
    return /*#__PURE__*/_jsx(ToastStoreProvider, {
      value: context,
      children: /*#__PURE__*/_jsx(CreateToastProvider, {
        value: {
          createToast
        },
        children: /*#__PURE__*/_jsx(ToastHandlersProvider, {
          value: {
            addToast,
            showToast,
            updateToast,
            updateFieldToast,
            updateAllToast,
            dismissToast,
            removeToast
          },
          children: children
        })
      })
    });
  };

  ToastProvider.displayName = "ToastStoreProvider";
  return [ToastProvider, useToastStore, useCreateToast, useToastHandlers];
}
//# sourceMappingURL=CreateToastContext.js.map