function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import * as React from "react";
import { ActionType } from "./ToastTypes";
var TOAST_LIMIT = 20;

var reducer = (state, action) => {
  switch (action.type) {
    case ActionType.ADD_TOAST:
      {
        var maxToasts = action.maxToasts || TOAST_LIMIT;
        return _objectSpread(_objectSpread({}, state), {}, {
          toasts: action.toast.reverseOrder ? [...state.toasts, action.toast].slice(-maxToasts) : [action.toast, ...state.toasts].slice(-maxToasts)
        });
      }

    case ActionType.UPDATE_TOAST:
      return _objectSpread(_objectSpread({}, state), {}, {
        toasts: state.toasts.map(t => t.id === action.toast.id ? _objectSpread(_objectSpread({}, t), action.toast) : t)
      });
    // Update toast by finding field value

    case ActionType.UPDATE_FIELD_TOAST:
      return _objectSpread(_objectSpread({}, state), {}, {
        toasts: state.toasts.map(t => t[action.field] === action.fieldValue ? _objectSpread(_objectSpread({}, t), action.toast) : t)
      });

    case ActionType.UPDATE_ALL_TOAST:
      return _objectSpread(_objectSpread({}, state), {}, {
        toasts: state.toasts.map(t => _objectSpread(_objectSpread({}, t), action.toast))
      });

    case ActionType.UPSERT_TOAST:
      var {
        toast
      } = action;
      return state.toasts.find(t => t.id === toast.id) ? reducer(state, {
        type: ActionType.UPDATE_TOAST,
        toast
      }) : reducer(state, {
        type: ActionType.ADD_TOAST,
        toast
      });

    case ActionType.DISMISS_TOAST:
      return _objectSpread(_objectSpread({}, state), {}, {
        toasts: state.toasts.map(t => t.id === action.toastId || action.toastId === undefined ? _objectSpread(_objectSpread({}, t), {}, {
          visible: false
        }) : t)
      });

    case ActionType.REMOVE_TOAST:
      if (action.toastId === undefined) {
        return _objectSpread(_objectSpread({}, state), {}, {
          toasts: []
        });
      }

      return _objectSpread(_objectSpread({}, state), {}, {
        toasts: state.toasts.filter(t => t.id !== action.toastId)
      });
  }
};

var initialState = {
  toasts: []
};
export var useToastState = () => {
  var [state, dispatch] = React.useReducer(reducer, initialState);
  return {
    toasts: state.toasts,
    dispatch
  };
};
//# sourceMappingURL=ToastState.js.map