var _excluded = ["unstable_portal"],
    _excluded2 = ["style", "wrapElement"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from "react";
import { Portal } from "reakit";
import { usePopover } from "../popover/Popover";
import { createComponent, createHook } from "../system";
import { TOOLTIP_KEYS } from "./__keys";
import { jsx as _jsx } from "react/jsx-runtime";
export var useTooltip = createHook({
  name: "Tooltip",
  compose: usePopover,
  keys: TOOLTIP_KEYS,

  useOptions(_ref) {
    var {
      unstable_portal = true
    } = _ref,
        options = _objectWithoutProperties(_ref, _excluded);

    return _objectSpread({
      unstable_portal
    }, options);
  },

  useProps(options, htmlProps) {
    var {
      style: htmlStyle,
      wrapElement: htmlWrapElement
    } = htmlProps,
        restHtmlProps = _objectWithoutProperties(htmlProps, _excluded2);

    var wrapElement = React.useCallback(element => {
      if (options.unstable_portal) {
        element = /*#__PURE__*/_jsx(Portal, {
          children: element
        });
      }

      if (htmlWrapElement) {
        return htmlWrapElement(element);
      }

      return element;
    }, [options.unstable_portal, htmlWrapElement]);
    return _objectSpread({
      style: _objectSpread({
        pointerEvents: "none"
      }, htmlStyle),
      wrapElement
    }, restHtmlProps);
  }

});
export var Tooltip = createComponent({
  as: "div",
  memo: true,
  useHook: useTooltip
});
//# sourceMappingURL=Tooltip.js.map