var _excluded = ["ref", "style"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import * as React from "react";
import { getDocument, useForkRef } from "reakit-utils";
import { useDisclosureContent } from "../disclosure/DisclosureContent";
import { createComponent, createHook } from "../system";
import globalState from "./__globalState";
import { TOOLTIP_KEYS } from "./__keys";

function globallyHideTooltipContentOnEscape(event) {
  if (event.defaultPrevented) return;

  if (event.key === "Escape") {
    globalState.show(null);
  }
}

export var useTooltipContent = createHook({
  name: "TooltipContent",
  compose: useDisclosureContent,
  keys: TOOLTIP_KEYS,

  useOptions(options) {
    return options;
  },

  useProps(options, _ref) {
    var {
      ref: htmlRef,
      style: htmlStyle
    } = _ref,
        htmlProps = _objectWithoutProperties(_ref, _excluded);

    React.useEffect(() => {
      var document = getDocument(options.popper);
      document.addEventListener("keydown", globallyHideTooltipContentOnEscape);
    }, [options.popper]);
    return _objectSpread({
      ref: useForkRef(options.setPopper, htmlRef),
      role: "tooltip",
      style: _objectSpread({
        pointerEvents: "none"
      }, htmlStyle)
    }, htmlProps);
  }

});
export var TooltipContent = createComponent({
  as: "div",
  memo: true,
  useHook: useTooltipContent
});
//# sourceMappingURL=TooltipContent.js.map