var _excluded = ["unstable_timeout"],
    _excluded2 = ["modal", "setModal"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import * as React from "react";
import { usePopoverState } from "../popover/PopoverState";
import globalState from "./__globalState";
export function useTooltipState() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var {
    unstable_timeout: initialTimeout = 0
  } = props,
      restProps = _objectWithoutProperties(props, _excluded);

  var [timeout, setTimeout] = React.useState(initialTimeout);
  var showTimeout = React.useRef(null);
  var hideTimeout = React.useRef(null);

  var _usePopoverState = usePopoverState(_objectSpread({}, restProps)),
      {
    modal,
    setModal
  } = _usePopoverState,
      popover = _objectWithoutProperties(_usePopoverState, _excluded2);

  var clearTimeouts = React.useCallback(() => {
    if (showTimeout.current !== null) {
      window.clearTimeout(showTimeout.current);
    }

    if (hideTimeout.current !== null) {
      window.clearTimeout(hideTimeout.current);
    }
  }, []);
  var hide = React.useCallback(() => {
    clearTimeouts();
    popover.hide(); // Let's give some time so people can move from a reference to another
    // and still show tooltips immediately

    hideTimeout.current = window.setTimeout(() => {
      globalState.hide(popover.baseId);
    }, timeout); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [clearTimeouts, popover.hide, timeout, popover.baseId]);
  var show = React.useCallback(() => {
    clearTimeouts();

    if (!timeout || globalState.currentTooltipId) {
      // If there's no timeout or a tooltip visible already, we can show this
      // immediately
      globalState.show(popover.baseId);
      popover.show();
    } else {
      // There may be a reference with focus whose tooltip is still not visible
      // In this case, we want to update it before it gets shown.
      globalState.show(null); // Otherwise, wait a little bit to show the tooltip

      showTimeout.current = window.setTimeout(() => {
        globalState.show(popover.baseId);
        popover.show();
      }, timeout);
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [clearTimeouts, timeout, popover.show, popover.baseId]);
  React.useEffect(() => {
    return globalState.subscribe(id => {
      if (id !== popover.baseId) {
        clearTimeouts();

        if (popover.visible) {
          // Make sure there will be only one tooltip visible
          popover.hide();
        }
      }
    }); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [popover.baseId, clearTimeouts, popover.visible, popover.hide]);
  React.useEffect(() => () => {
    clearTimeouts();
    globalState.hide(popover.baseId);
  }, [clearTimeouts, popover.baseId]);
  return _objectSpread(_objectSpread({}, popover), {}, {
    hide,
    show,
    unstable_timeout: timeout,
    unstable_setTimeout: setTimeout
  });
}
//# sourceMappingURL=TooltipState.js.map