var state = {
  currentTooltipId: null,
  listeners: new Set(),

  subscribe(listener) {
    this.listeners.add(listener);
    return () => {
      this.listeners.delete(listener);
    };
  },

  show(id) {
    this.currentTooltipId = id;
    this.listeners.forEach(listener => listener(id));
  },

  hide(id) {
    if (this.currentTooltipId === id) {
      this.currentTooltipId = null;
      this.listeners.forEach(listener => listener(null));
    }
  }

};
export default state;
//# sourceMappingURL=__globalState.js.map