import { CompositeActions, CompositeInitialState, CompositeState } from "reakit";
export declare function useAccordionBaseState(props?: AccordionBaseInitialState): AccordionBaseStateReturn;
export declare type AccordionBaseState = CompositeState & {
    /**
     * Lists all the panels.
     */
    panels: CompositeState["items"];
};
export declare type AccordionBaseActions = CompositeActions & {
    /**
     * Registers a accordion panel.
     */
    registerPanel: CompositeActions["registerItem"];
    /**
     * Unregisters a accordion panel.
     */
    unregisterPanel: CompositeActions["unregisterItem"];
};
export declare type AccordionBaseInitialState = CompositeInitialState;
export declare type AccordionBaseStateReturn = AccordionBaseState & AccordionBaseActions;
