import * as React from "react";
import { DisclosureContentHTMLProps, DisclosureContentOptions, unstable_IdHTMLProps, unstable_IdOptions } from "reakit";
import { AccordionMultiStateReturn } from "./AccordionMultiState";
import { AccordionStateReturn } from "./AccordionState";
export declare const useAccordionPanel: {
    (options?: AccordionPanelOptions | undefined, htmlProps?: AccordionPanelHTMLProps | undefined, unstable_ignoreUseOptions?: boolean | undefined): AccordionPanelHTMLProps;
    unstable_propsAreEqual: (prev: {
        /**
         * Accordion's id
         */
        accordionId?: string | undefined;
    } & import("reakit").RoleOptions & Pick<Partial<import("reakit").DisclosureStateReturn>, "baseId" | "visible" | "animating" | "animated" | "stopAnimation"> & Pick<Partial<import("reakit").unstable_IdStateReturn>, "baseId" | "unstable_idCountRef"> & {
        id?: string | undefined;
    } & Pick<AccordionStateReturn, "items" | "panels" | "registerPanel" | "unregisterPanel" | "allowMultiple" | "selectedId"> & Pick<AccordionMultiStateReturn, "selectedIds"> & React.HTMLAttributes<any> & React.RefAttributes<any> & {
        wrapElement?: ((element: React.ReactNode) => React.ReactNode) | undefined;
    }, next: {
        /**
         * Accordion's id
         */
        accordionId?: string | undefined;
    } & import("reakit").RoleOptions & Pick<Partial<import("reakit").DisclosureStateReturn>, "baseId" | "visible" | "animating" | "animated" | "stopAnimation"> & Pick<Partial<import("reakit").unstable_IdStateReturn>, "baseId" | "unstable_idCountRef"> & {
        id?: string | undefined;
    } & Pick<AccordionStateReturn, "items" | "panels" | "registerPanel" | "unregisterPanel" | "allowMultiple" | "selectedId"> & Pick<AccordionMultiStateReturn, "selectedIds"> & React.HTMLAttributes<any> & React.RefAttributes<any> & {
        wrapElement?: ((element: React.ReactNode) => React.ReactNode) | undefined;
    }) => boolean;
    __keys: readonly any[];
    __useOptions: (options: AccordionPanelOptions, htmlProps: AccordionPanelHTMLProps) => AccordionPanelOptions;
};
export declare const AccordionPanel: import("../system").Component<"div", {
    /**
     * Accordion's id
     */
    accordionId?: string | undefined;
} & import("reakit").RoleOptions & Pick<Partial<import("reakit").DisclosureStateReturn>, "baseId" | "visible" | "animating" | "animated" | "stopAnimation"> & Pick<Partial<import("reakit").unstable_IdStateReturn>, "baseId" | "unstable_idCountRef"> & {
    id?: string | undefined;
} & Pick<AccordionStateReturn, "items" | "panels" | "registerPanel" | "unregisterPanel" | "allowMultiple" | "selectedId"> & Pick<AccordionMultiStateReturn, "selectedIds"> & React.HTMLAttributes<any> & React.RefAttributes<any> & {
    wrapElement?: ((element: React.ReactNode) => React.ReactNode) | undefined;
}>;
export declare type AccordionPanelOptions = {
    /**
     * Accordion's id
     */
    accordionId?: string;
} & DisclosureContentOptions & unstable_IdOptions & Pick<AccordionStateReturn, "items" | "panels" | "selectedId" | "allowMultiple" | "registerPanel" | "unregisterPanel"> & Pick<AccordionMultiStateReturn, "selectedIds">;
export declare type AccordionPanelHTMLProps = DisclosureContentHTMLProps & unstable_IdHTMLProps;
export declare type AccordionPanelProps = AccordionPanelOptions & AccordionPanelHTMLProps;
