import * as React from "react";
import { ButtonHTMLProps, ButtonOptions, CompositeItemHTMLProps, CompositeItemOptions } from "reakit";
import { AccordionMultiStateReturn } from "./AccordionMultiState";
import { AccordionStateReturn } from "./AccordionState";
export declare const useAccordionTrigger: {
    (options?: AccordionTriggerOptions | undefined, htmlProps?: AccordionTriggerHTMLProps | undefined, unstable_ignoreUseOptions?: boolean | undefined): AccordionTriggerHTMLProps;
    unstable_propsAreEqual: (prev: import("reakit").RoleOptions & {
        disabled?: boolean | undefined;
        focusable?: boolean | undefined;
    } & {
        unstable_clickOnEnter?: boolean | undefined;
        unstable_clickOnSpace?: boolean | undefined;
    } & Pick<Partial<import("reakit").unstable_IdStateReturn>, "baseId" | "unstable_idCountRef"> & {
        id?: string | undefined;
    } & Pick<Partial<import("reakit").CompositeStateReturn>, "baseId" | "unstable_virtual" | "orientation" | "unstable_moves" | "unstable_hasActiveWidget"> & Pick<import("reakit").CompositeStateReturn, "currentId" | "items" | "registerItem" | "unregisterItem" | "next" | "previous" | "up" | "down" | "first" | "last" | "setCurrentId"> & Pick<AccordionStateReturn, "panels" | "manual" | "allowToggle" | "allowMultiple" | "select" | "selectedId"> & Pick<AccordionMultiStateReturn, "selectedIds"> & React.HTMLAttributes<any> & React.RefAttributes<any> & {
        wrapElement?: ((element: React.ReactNode) => React.ReactNode) | undefined;
    } & {
        disabled?: boolean | undefined;
    } & React.ButtonHTMLAttributes<any>, next: import("reakit").RoleOptions & {
        disabled?: boolean | undefined;
        focusable?: boolean | undefined;
    } & {
        unstable_clickOnEnter?: boolean | undefined;
        unstable_clickOnSpace?: boolean | undefined;
    } & Pick<Partial<import("reakit").unstable_IdStateReturn>, "baseId" | "unstable_idCountRef"> & {
        id?: string | undefined;
    } & Pick<Partial<import("reakit").CompositeStateReturn>, "baseId" | "unstable_virtual" | "orientation" | "unstable_moves" | "unstable_hasActiveWidget"> & Pick<import("reakit").CompositeStateReturn, "currentId" | "items" | "registerItem" | "unregisterItem" | "next" | "previous" | "up" | "down" | "first" | "last" | "setCurrentId"> & Pick<AccordionStateReturn, "panels" | "manual" | "allowToggle" | "allowMultiple" | "select" | "selectedId"> & Pick<AccordionMultiStateReturn, "selectedIds"> & React.HTMLAttributes<any> & React.RefAttributes<any> & {
        wrapElement?: ((element: React.ReactNode) => React.ReactNode) | undefined;
    } & {
        disabled?: boolean | undefined;
    } & React.ButtonHTMLAttributes<any>) => boolean;
    __keys: readonly any[];
    __useOptions: (options: AccordionTriggerOptions, htmlProps: AccordionTriggerHTMLProps) => AccordionTriggerOptions;
};
export declare const AccordionTrigger: import("../system").Component<"button", import("reakit").RoleOptions & {
    disabled?: boolean | undefined;
    focusable?: boolean | undefined;
} & {
    unstable_clickOnEnter?: boolean | undefined;
    unstable_clickOnSpace?: boolean | undefined;
} & Pick<Partial<import("reakit").unstable_IdStateReturn>, "baseId" | "unstable_idCountRef"> & {
    id?: string | undefined;
} & Pick<Partial<import("reakit").CompositeStateReturn>, "baseId" | "unstable_virtual" | "orientation" | "unstable_moves" | "unstable_hasActiveWidget"> & Pick<import("reakit").CompositeStateReturn, "currentId" | "items" | "registerItem" | "unregisterItem" | "next" | "previous" | "up" | "down" | "first" | "last" | "setCurrentId"> & Pick<AccordionStateReturn, "panels" | "manual" | "allowToggle" | "allowMultiple" | "select" | "selectedId"> & Pick<AccordionMultiStateReturn, "selectedIds"> & React.HTMLAttributes<any> & React.RefAttributes<any> & {
    wrapElement?: ((element: React.ReactNode) => React.ReactNode) | undefined;
} & {
    disabled?: boolean | undefined;
} & React.ButtonHTMLAttributes<any>>;
export declare type AccordionTriggerOptions = ButtonOptions & CompositeItemOptions & Pick<AccordionStateReturn, "panels" | "select" | "manual" | "selectedId" | "allowToggle" | "allowMultiple"> & Pick<AccordionMultiStateReturn, "selectedIds">;
export declare type AccordionTriggerHTMLProps = ButtonHTMLProps & CompositeItemHTMLProps;
export declare type AccordionTriggerProps = AccordionTriggerOptions & AccordionTriggerHTMLProps;
