import { AccordionPanelOptions } from "./AccordionPanel";
import { AccordionTriggerOptions } from "./AccordionTrigger";
export declare type StringOrNull = string | null;
/**
 * When <AccordionPanel> is used without accordionId:
 *
 *  - First render: getAccordionId will return undefined because options.panels
 * doesn't contain the current panel yet (registerPanel wasn't called yet).
 * Thus registerPanel will be called without groupId (accordionId).
 *
 *  - Second render: options.panels already contains the current panel (because
 * registerPanel was called in the previous render). This means that we'll be
 * able to get the related accordionId with the accordion panel index. Basically,
 * we filter out all the accordions and panels that have already matched. In this
 * phase, registerPanel will be called again with the proper groupId (accordionId).
 *
 *  - In the third render, panel.groupId will be already defined, so we just
 * return it. registerPanel is not called.
 */
export declare function getAccordionId(options: AccordionPanelOptions): string | undefined;
export declare function isPanelVisible(options: AccordionPanelOptions): boolean;
export declare function isAccordionSelected(options: AccordionTriggerOptions): boolean | undefined;
export declare function useAccordionPanelId(options: AccordionTriggerOptions): string | undefined;
