import * as React from "react";
import { PopoverHTMLProps, PopoverOptions } from "reakit";
import { SelectListHTMLProps, SelectListOptions } from "./SelectList";
import { SelectStateReturn } from "./SelectState";
export declare const useSelectPopover: {
    (options?: SelectPopoverOptions | undefined, htmlProps?: SelectPopoverHTMLProps | undefined, unstable_ignoreUseOptions?: boolean | undefined): SelectPopoverHTMLProps;
    unstable_propsAreEqual: (prev: import("reakit").RoleOptions & {
        disabled?: boolean | undefined;
        focusable?: boolean | undefined;
    } & Pick<Partial<import("reakit").CompositeStateReturn>, "baseId" | "unstable_virtual" | "orientation" | "currentId" | "wrap" | "groups" | "unstable_moves"> & Pick<import("reakit").CompositeStateReturn, "items" | "move" | "first" | "last" | "setCurrentId"> & Pick<Partial<SelectStateReturn>, "menuRole"> & Pick<SelectStateReturn, "baseId"> & Pick<Partial<import("reakit").DisclosureStateReturn>, "baseId" | "visible" | "animating" | "animated" | "stopAnimation"> & Pick<Partial<import("reakit").DialogStateReturn>, "hide" | "modal" | "unstable_disclosureRef"> & Pick<import("reakit").DialogStateReturn, "baseId"> & {
        hideOnEsc?: boolean | undefined;
        hideOnClickOutside?: boolean | undefined;
        preventBodyScroll?: boolean | undefined;
        unstable_initialFocusRef?: React.RefObject<HTMLElement> | undefined;
        unstable_finalFocusRef?: React.RefObject<HTMLElement> | undefined;
        unstable_orphan?: boolean | undefined;
        unstable_autoFocusOnShow?: boolean | undefined;
        unstable_autoFocusOnHide?: boolean | undefined;
    } & Pick<Partial<import("reakit").PopoverStateReturn>, "unstable_popoverRef" | "unstable_popoverStyles"> & Pick<SelectStateReturn, "values" | "valuesById" | "currentValue"> & React.HTMLAttributes<any> & React.RefAttributes<any> & {
        wrapElement?: ((element: React.ReactNode) => React.ReactNode) | undefined;
    } & {
        disabled?: boolean | undefined;
    }, next: import("reakit").RoleOptions & {
        disabled?: boolean | undefined;
        focusable?: boolean | undefined;
    } & Pick<Partial<import("reakit").CompositeStateReturn>, "baseId" | "unstable_virtual" | "orientation" | "currentId" | "wrap" | "groups" | "unstable_moves"> & Pick<import("reakit").CompositeStateReturn, "items" | "move" | "first" | "last" | "setCurrentId"> & Pick<Partial<SelectStateReturn>, "menuRole"> & Pick<SelectStateReturn, "baseId"> & Pick<Partial<import("reakit").DisclosureStateReturn>, "baseId" | "visible" | "animating" | "animated" | "stopAnimation"> & Pick<Partial<import("reakit").DialogStateReturn>, "hide" | "modal" | "unstable_disclosureRef"> & Pick<import("reakit").DialogStateReturn, "baseId"> & {
        hideOnEsc?: boolean | undefined;
        hideOnClickOutside?: boolean | undefined;
        preventBodyScroll?: boolean | undefined;
        unstable_initialFocusRef?: React.RefObject<HTMLElement> | undefined;
        unstable_finalFocusRef?: React.RefObject<HTMLElement> | undefined;
        unstable_orphan?: boolean | undefined;
        unstable_autoFocusOnShow?: boolean | undefined;
        unstable_autoFocusOnHide?: boolean | undefined;
    } & Pick<Partial<import("reakit").PopoverStateReturn>, "unstable_popoverRef" | "unstable_popoverStyles"> & Pick<SelectStateReturn, "values" | "valuesById" | "currentValue"> & React.HTMLAttributes<any> & React.RefAttributes<any> & {
        wrapElement?: ((element: React.ReactNode) => React.ReactNode) | undefined;
    } & {
        disabled?: boolean | undefined;
    }) => boolean;
    __keys: readonly any[];
    __useOptions: (options: SelectPopoverOptions, htmlProps: SelectPopoverHTMLProps) => SelectPopoverOptions;
};
export declare const SelectPopover: import("../system").Component<"div", import("reakit").RoleOptions & {
    disabled?: boolean | undefined;
    focusable?: boolean | undefined;
} & Pick<Partial<import("reakit").CompositeStateReturn>, "baseId" | "unstable_virtual" | "orientation" | "currentId" | "wrap" | "groups" | "unstable_moves"> & Pick<import("reakit").CompositeStateReturn, "items" | "move" | "first" | "last" | "setCurrentId"> & Pick<Partial<SelectStateReturn>, "menuRole"> & Pick<SelectStateReturn, "baseId"> & Pick<Partial<import("reakit").DisclosureStateReturn>, "baseId" | "visible" | "animating" | "animated" | "stopAnimation"> & Pick<Partial<import("reakit").DialogStateReturn>, "hide" | "modal" | "unstable_disclosureRef"> & Pick<import("reakit").DialogStateReturn, "baseId"> & {
    hideOnEsc?: boolean | undefined;
    hideOnClickOutside?: boolean | undefined;
    preventBodyScroll?: boolean | undefined;
    unstable_initialFocusRef?: React.RefObject<HTMLElement> | undefined;
    unstable_finalFocusRef?: React.RefObject<HTMLElement> | undefined;
    unstable_orphan?: boolean | undefined;
    unstable_autoFocusOnShow?: boolean | undefined;
    unstable_autoFocusOnHide?: boolean | undefined;
} & Pick<Partial<import("reakit").PopoverStateReturn>, "unstable_popoverRef" | "unstable_popoverStyles"> & Pick<SelectStateReturn, "values" | "valuesById" | "currentValue"> & React.HTMLAttributes<any> & React.RefAttributes<any> & {
    wrapElement?: ((element: React.ReactNode) => React.ReactNode) | undefined;
} & {
    disabled?: boolean | undefined;
}>;
export declare type SelectPopoverOptions = SelectListOptions & PopoverOptions & Pick<SelectStateReturn, "values" | "currentValue" | "valuesById">;
export declare type SelectPopoverHTMLProps = PopoverHTMLProps & SelectListHTMLProps;
export declare type SelectPopoverProps = SelectPopoverOptions & SelectPopoverHTMLProps;
