/// <reference types="react" />
import { CompositeHTMLProps, CompositeOptions } from "reakit/Composite";
import { TimePickerColumnStateReturn } from "./TimePickerColumnState";
export declare type TimePickerColumnOptions = CompositeOptions & Pick<TimePickerColumnStateReturn, "columnType">;
export declare type TimePickerColumnHTMLProps = CompositeHTMLProps;
export declare type TimePickerColumnProps = TimePickerColumnOptions & TimePickerColumnHTMLProps;
export declare const useTimePickerColumn: {
    (options?: TimePickerColumnOptions | undefined, htmlProps?: import("reakit/ts").TabbableHTMLProps | undefined, unstable_ignoreUseOptions?: boolean | undefined): import("reakit/ts").TabbableHTMLProps;
    unstable_propsAreEqual: (prev: import("reakit/ts").RoleOptions & {
        disabled?: boolean | undefined;
        focusable?: boolean | undefined;
    } & Pick<Partial<import("reakit/Composite").CompositeStateReturn>, "baseId" | "unstable_virtual" | "orientation" | "currentId" | "wrap" | "groups" | "unstable_moves"> & Pick<import("reakit/Composite").CompositeStateReturn, "items" | "move" | "first" | "last" | "setCurrentId"> & Pick<{
        up: (unstable_allTheWay?: boolean | undefined) => void;
        down: (unstable_allTheWay?: boolean | undefined) => void;
        baseId: string;
        unstable_idCountRef: import("react").MutableRefObject<number>;
        setBaseId: import("react").Dispatch<import("react").SetStateAction<string>>;
        unstable_virtual: boolean;
        rtl: boolean;
        orientation?: import("reakit/ts/Composite/__utils/types").Orientation | undefined;
        items: import("reakit/ts/Composite/__utils/types").Item[];
        groups: import("reakit/ts/Composite/__utils/types").Group[];
        currentId?: string | null | undefined;
        loop: boolean | import("reakit/ts/Composite/__utils/types").Orientation;
        wrap: boolean | import("reakit/ts/Composite/__utils/types").Orientation;
        shift: boolean;
        unstable_moves: number;
        unstable_hasActiveWidget: boolean;
        unstable_includesBaseElement: boolean;
        registerItem: (item: import("reakit/ts/Composite/__utils/types").Item) => void;
        unregisterItem: (id: string) => void;
        registerGroup: (group: import("reakit/ts/Composite/__utils/types").Group) => void;
        unregisterGroup: (id: string) => void;
        move: (id: string | null) => void;
        next: (unstable_allTheWay?: boolean | undefined) => void;
        previous: (unstable_allTheWay?: boolean | undefined) => void;
        first: () => void;
        last: () => void;
        sort: () => void;
        unstable_setVirtual: import("react").Dispatch<import("react").SetStateAction<boolean>>;
        setRTL: import("react").Dispatch<import("react").SetStateAction<boolean>>;
        setOrientation: import("react").Dispatch<import("react").SetStateAction<import("reakit/ts/Composite/__utils/types").Orientation | undefined>>;
        setCurrentId: import("react").Dispatch<import("react").SetStateAction<string | null | undefined>>;
        setLoop: import("react").Dispatch<import("react").SetStateAction<boolean | import("reakit/ts/Composite/__utils/types").Orientation>>;
        setWrap: import("react").Dispatch<import("react").SetStateAction<boolean | import("reakit/ts/Composite/__utils/types").Orientation>>;
        setShift: import("react").Dispatch<import("react").SetStateAction<boolean>>;
        reset: () => void;
        unstable_setIncludesBaseElement: import("react").Dispatch<import("react").SetStateAction<boolean>>;
        unstable_setHasActiveWidget: import("react").Dispatch<import("react").SetStateAction<boolean>>;
        popover: {
            baseId: string;
            unstable_idCountRef: import("react").MutableRefObject<number>;
            visible: boolean;
            animated: number | boolean;
            animating: boolean;
            setBaseId: import("react").Dispatch<import("react").SetStateAction<string>>;
            show: () => void;
            hide: () => void;
            toggle: () => void;
            setVisible: import("react").Dispatch<import("react").SetStateAction<boolean>>;
            setAnimated: import("react").Dispatch<import("react").SetStateAction<number | boolean>>;
            stopAnimation: () => void;
            modal: boolean;
            unstable_disclosureRef: import("react").MutableRefObject<HTMLElement | null>;
            setModal: import("react").Dispatch<import("react").SetStateAction<boolean>>;
            unstable_referenceRef: import("react").RefObject<HTMLElement | null>;
            unstable_popoverRef: import("react").RefObject<HTMLElement | null>;
            unstable_arrowRef: import("react").RefObject<HTMLElement | null>;
            unstable_popoverStyles: import("react").CSSProperties;
            unstable_arrowStyles: import("react").CSSProperties;
            unstable_originalPlacement: "auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start";
            unstable_update: () => boolean;
            placement: "auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start";
            place: import("react").Dispatch<import("react").SetStateAction<"auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start">>;
            pickerId: string | undefined;
            dialogId: string | undefined;
            isDisabled: boolean | undefined;
            isReadOnly: boolean | undefined;
            segmentFocus: (() => void) | undefined;
        } | undefined;
        date: Date;
        selected: number;
        setSelected: (value: number, close?: boolean | undefined) => void;
        visible: boolean | undefined;
        columnType: import("./TimePickerColumnState").ColumnType;
        restoreOldTime: (() => Date) | undefined;
        updateOldTime: (() => void) | undefined;
    }, "columnType"> & import("react").HTMLAttributes<any> & import("react").RefAttributes<any> & {
        wrapElement?: ((element: import("react").ReactNode) => import("react").ReactNode) | undefined;
    } & {
        disabled?: boolean | undefined;
    }, next: import("reakit/ts").RoleOptions & {
        disabled?: boolean | undefined;
        focusable?: boolean | undefined;
    } & Pick<Partial<import("reakit/Composite").CompositeStateReturn>, "baseId" | "unstable_virtual" | "orientation" | "currentId" | "wrap" | "groups" | "unstable_moves"> & Pick<import("reakit/Composite").CompositeStateReturn, "items" | "move" | "first" | "last" | "setCurrentId"> & Pick<{
        up: (unstable_allTheWay?: boolean | undefined) => void;
        down: (unstable_allTheWay?: boolean | undefined) => void;
        baseId: string;
        unstable_idCountRef: import("react").MutableRefObject<number>;
        setBaseId: import("react").Dispatch<import("react").SetStateAction<string>>;
        unstable_virtual: boolean;
        rtl: boolean;
        orientation?: import("reakit/ts/Composite/__utils/types").Orientation | undefined;
        items: import("reakit/ts/Composite/__utils/types").Item[];
        groups: import("reakit/ts/Composite/__utils/types").Group[];
        currentId?: string | null | undefined;
        loop: boolean | import("reakit/ts/Composite/__utils/types").Orientation;
        wrap: boolean | import("reakit/ts/Composite/__utils/types").Orientation;
        shift: boolean;
        unstable_moves: number;
        unstable_hasActiveWidget: boolean;
        unstable_includesBaseElement: boolean;
        registerItem: (item: import("reakit/ts/Composite/__utils/types").Item) => void;
        unregisterItem: (id: string) => void;
        registerGroup: (group: import("reakit/ts/Composite/__utils/types").Group) => void;
        unregisterGroup: (id: string) => void;
        move: (id: string | null) => void;
        next: (unstable_allTheWay?: boolean | undefined) => void;
        previous: (unstable_allTheWay?: boolean | undefined) => void;
        first: () => void;
        last: () => void;
        sort: () => void;
        unstable_setVirtual: import("react").Dispatch<import("react").SetStateAction<boolean>>;
        setRTL: import("react").Dispatch<import("react").SetStateAction<boolean>>;
        setOrientation: import("react").Dispatch<import("react").SetStateAction<import("reakit/ts/Composite/__utils/types").Orientation | undefined>>;
        setCurrentId: import("react").Dispatch<import("react").SetStateAction<string | null | undefined>>;
        setLoop: import("react").Dispatch<import("react").SetStateAction<boolean | import("reakit/ts/Composite/__utils/types").Orientation>>;
        setWrap: import("react").Dispatch<import("react").SetStateAction<boolean | import("reakit/ts/Composite/__utils/types").Orientation>>;
        setShift: import("react").Dispatch<import("react").SetStateAction<boolean>>;
        reset: () => void;
        unstable_setIncludesBaseElement: import("react").Dispatch<import("react").SetStateAction<boolean>>;
        unstable_setHasActiveWidget: import("react").Dispatch<import("react").SetStateAction<boolean>>;
        popover: {
            baseId: string;
            unstable_idCountRef: import("react").MutableRefObject<number>;
            visible: boolean;
            animated: number | boolean;
            animating: boolean;
            setBaseId: import("react").Dispatch<import("react").SetStateAction<string>>;
            show: () => void;
            hide: () => void;
            toggle: () => void;
            setVisible: import("react").Dispatch<import("react").SetStateAction<boolean>>;
            setAnimated: import("react").Dispatch<import("react").SetStateAction<number | boolean>>;
            stopAnimation: () => void;
            modal: boolean;
            unstable_disclosureRef: import("react").MutableRefObject<HTMLElement | null>;
            setModal: import("react").Dispatch<import("react").SetStateAction<boolean>>;
            unstable_referenceRef: import("react").RefObject<HTMLElement | null>;
            unstable_popoverRef: import("react").RefObject<HTMLElement | null>;
            unstable_arrowRef: import("react").RefObject<HTMLElement | null>;
            unstable_popoverStyles: import("react").CSSProperties;
            unstable_arrowStyles: import("react").CSSProperties;
            unstable_originalPlacement: "auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start";
            unstable_update: () => boolean;
            placement: "auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start";
            place: import("react").Dispatch<import("react").SetStateAction<"auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start">>;
            pickerId: string | undefined;
            dialogId: string | undefined;
            isDisabled: boolean | undefined;
            isReadOnly: boolean | undefined;
            segmentFocus: (() => void) | undefined;
        } | undefined;
        date: Date;
        selected: number;
        setSelected: (value: number, close?: boolean | undefined) => void;
        visible: boolean | undefined;
        columnType: import("./TimePickerColumnState").ColumnType;
        restoreOldTime: (() => Date) | undefined;
        updateOldTime: (() => void) | undefined;
    }, "columnType"> & import("react").HTMLAttributes<any> & import("react").RefAttributes<any> & {
        wrapElement?: ((element: import("react").ReactNode) => import("react").ReactNode) | undefined;
    } & {
        disabled?: boolean | undefined;
    }) => boolean;
    __keys: readonly any[];
    __useOptions: (options: TimePickerColumnOptions, htmlProps: import("reakit/ts").TabbableHTMLProps) => TimePickerColumnOptions;
};
export declare const TimePickerColumn: import("../system").Component<"div", import("reakit/ts").RoleOptions & {
    disabled?: boolean | undefined;
    focusable?: boolean | undefined;
} & Pick<Partial<import("reakit/Composite").CompositeStateReturn>, "baseId" | "unstable_virtual" | "orientation" | "currentId" | "wrap" | "groups" | "unstable_moves"> & Pick<import("reakit/Composite").CompositeStateReturn, "items" | "move" | "first" | "last" | "setCurrentId"> & Pick<{
    up: (unstable_allTheWay?: boolean | undefined) => void;
    down: (unstable_allTheWay?: boolean | undefined) => void;
    baseId: string;
    unstable_idCountRef: import("react").MutableRefObject<number>;
    setBaseId: import("react").Dispatch<import("react").SetStateAction<string>>;
    unstable_virtual: boolean;
    rtl: boolean;
    orientation?: import("reakit/ts/Composite/__utils/types").Orientation | undefined;
    items: import("reakit/ts/Composite/__utils/types").Item[];
    groups: import("reakit/ts/Composite/__utils/types").Group[];
    currentId?: string | null | undefined;
    loop: boolean | import("reakit/ts/Composite/__utils/types").Orientation;
    wrap: boolean | import("reakit/ts/Composite/__utils/types").Orientation;
    shift: boolean;
    unstable_moves: number;
    unstable_hasActiveWidget: boolean;
    unstable_includesBaseElement: boolean;
    registerItem: (item: import("reakit/ts/Composite/__utils/types").Item) => void;
    unregisterItem: (id: string) => void;
    registerGroup: (group: import("reakit/ts/Composite/__utils/types").Group) => void;
    unregisterGroup: (id: string) => void;
    move: (id: string | null) => void;
    next: (unstable_allTheWay?: boolean | undefined) => void;
    previous: (unstable_allTheWay?: boolean | undefined) => void;
    first: () => void;
    last: () => void;
    sort: () => void;
    unstable_setVirtual: import("react").Dispatch<import("react").SetStateAction<boolean>>;
    setRTL: import("react").Dispatch<import("react").SetStateAction<boolean>>;
    setOrientation: import("react").Dispatch<import("react").SetStateAction<import("reakit/ts/Composite/__utils/types").Orientation | undefined>>;
    setCurrentId: import("react").Dispatch<import("react").SetStateAction<string | null | undefined>>;
    setLoop: import("react").Dispatch<import("react").SetStateAction<boolean | import("reakit/ts/Composite/__utils/types").Orientation>>;
    setWrap: import("react").Dispatch<import("react").SetStateAction<boolean | import("reakit/ts/Composite/__utils/types").Orientation>>;
    setShift: import("react").Dispatch<import("react").SetStateAction<boolean>>;
    reset: () => void;
    unstable_setIncludesBaseElement: import("react").Dispatch<import("react").SetStateAction<boolean>>;
    unstable_setHasActiveWidget: import("react").Dispatch<import("react").SetStateAction<boolean>>;
    popover: {
        baseId: string;
        unstable_idCountRef: import("react").MutableRefObject<number>;
        visible: boolean;
        animated: number | boolean;
        animating: boolean;
        setBaseId: import("react").Dispatch<import("react").SetStateAction<string>>;
        show: () => void;
        hide: () => void;
        toggle: () => void;
        setVisible: import("react").Dispatch<import("react").SetStateAction<boolean>>;
        setAnimated: import("react").Dispatch<import("react").SetStateAction<number | boolean>>;
        stopAnimation: () => void;
        modal: boolean;
        unstable_disclosureRef: import("react").MutableRefObject<HTMLElement | null>;
        setModal: import("react").Dispatch<import("react").SetStateAction<boolean>>;
        unstable_referenceRef: import("react").RefObject<HTMLElement | null>;
        unstable_popoverRef: import("react").RefObject<HTMLElement | null>;
        unstable_arrowRef: import("react").RefObject<HTMLElement | null>;
        unstable_popoverStyles: import("react").CSSProperties;
        unstable_arrowStyles: import("react").CSSProperties;
        unstable_originalPlacement: "auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start";
        unstable_update: () => boolean;
        placement: "auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start";
        place: import("react").Dispatch<import("react").SetStateAction<"auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start">>;
        pickerId: string | undefined;
        dialogId: string | undefined;
        isDisabled: boolean | undefined;
        isReadOnly: boolean | undefined;
        segmentFocus: (() => void) | undefined;
    } | undefined;
    date: Date;
    selected: number;
    setSelected: (value: number, close?: boolean | undefined) => void;
    visible: boolean | undefined;
    columnType: import("./TimePickerColumnState").ColumnType;
    restoreOldTime: (() => Date) | undefined;
    updateOldTime: (() => void) | undefined;
}, "columnType"> & import("react").HTMLAttributes<any> & import("react").RefAttributes<any> & {
    wrapElement?: ((element: import("react").ReactNode) => import("react").ReactNode) | undefined;
} & {
    disabled?: boolean | undefined;
}>;
