import * as React from "react";
import { PickerBaseContentHTMLProps, PickerBaseContentOptions } from "../picker-base";
export declare type TimePickerContentOptions = PickerBaseContentOptions;
export declare type TimePickerContentHTMLProps = PickerBaseContentHTMLProps;
export declare type TimePickerContentProps = TimePickerContentOptions & TimePickerContentHTMLProps;
export declare const useTimePickerContent: {
    (options?: PickerBaseContentOptions | undefined, htmlProps?: import("reakit/ts").RoleHTMLProps | undefined, unstable_ignoreUseOptions?: boolean | undefined): import("reakit/ts").RoleHTMLProps;
    unstable_propsAreEqual: (prev: import("reakit/ts").RoleOptions & Pick<Partial<import("reakit/ts").DisclosureStateReturn>, "baseId" | "visible" | "animating" | "animated" | "stopAnimation"> & Pick<Partial<import("reakit/ts").DialogStateReturn>, "hide" | "modal" | "unstable_disclosureRef"> & Pick<import("reakit/ts").DialogStateReturn, "baseId"> & {
        hideOnEsc?: boolean | undefined;
        hideOnClickOutside?: boolean | undefined;
        preventBodyScroll?: boolean | undefined;
        unstable_initialFocusRef?: React.RefObject<HTMLElement> | undefined;
        unstable_finalFocusRef?: React.RefObject<HTMLElement> | undefined;
        unstable_orphan?: boolean | undefined;
        unstable_autoFocusOnShow?: boolean | undefined;
        unstable_autoFocusOnHide?: boolean | undefined;
    } & Pick<Partial<import("reakit/ts").PopoverStateReturn>, "unstable_popoverRef" | "unstable_popoverStyles"> & Pick<{
        baseId: string;
        unstable_idCountRef: React.MutableRefObject<number>;
        visible: boolean;
        animated: number | boolean;
        animating: boolean;
        setBaseId: React.Dispatch<React.SetStateAction<string>>;
        show: () => void;
        hide: () => void;
        toggle: () => void;
        setVisible: React.Dispatch<React.SetStateAction<boolean>>;
        setAnimated: React.Dispatch<React.SetStateAction<number | boolean>>;
        stopAnimation: () => void;
        modal: boolean;
        unstable_disclosureRef: React.MutableRefObject<HTMLElement | null>;
        setModal: React.Dispatch<React.SetStateAction<boolean>>;
        unstable_referenceRef: React.RefObject<HTMLElement | null>;
        unstable_popoverRef: React.RefObject<HTMLElement | null>;
        unstable_arrowRef: React.RefObject<HTMLElement | null>;
        unstable_popoverStyles: React.CSSProperties;
        unstable_arrowStyles: React.CSSProperties;
        unstable_originalPlacement: "auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start";
        unstable_update: () => boolean;
        placement: "auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start";
        place: React.Dispatch<React.SetStateAction<"auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start">>;
        pickerId: string | undefined;
        dialogId: string | undefined;
        isDisabled: boolean | undefined;
        isReadOnly: boolean | undefined;
        segmentFocus: (() => void) | undefined;
    }, "dialogId"> & React.HTMLAttributes<any> & React.RefAttributes<any> & {
        wrapElement?: ((element: React.ReactNode) => React.ReactNode) | undefined;
    }, next: import("reakit/ts").RoleOptions & Pick<Partial<import("reakit/ts").DisclosureStateReturn>, "baseId" | "visible" | "animating" | "animated" | "stopAnimation"> & Pick<Partial<import("reakit/ts").DialogStateReturn>, "hide" | "modal" | "unstable_disclosureRef"> & Pick<import("reakit/ts").DialogStateReturn, "baseId"> & {
        hideOnEsc?: boolean | undefined;
        hideOnClickOutside?: boolean | undefined;
        preventBodyScroll?: boolean | undefined;
        unstable_initialFocusRef?: React.RefObject<HTMLElement> | undefined;
        unstable_finalFocusRef?: React.RefObject<HTMLElement> | undefined;
        unstable_orphan?: boolean | undefined;
        unstable_autoFocusOnShow?: boolean | undefined;
        unstable_autoFocusOnHide?: boolean | undefined;
    } & Pick<Partial<import("reakit/ts").PopoverStateReturn>, "unstable_popoverRef" | "unstable_popoverStyles"> & Pick<{
        baseId: string;
        unstable_idCountRef: React.MutableRefObject<number>;
        visible: boolean;
        animated: number | boolean;
        animating: boolean;
        setBaseId: React.Dispatch<React.SetStateAction<string>>;
        show: () => void;
        hide: () => void;
        toggle: () => void;
        setVisible: React.Dispatch<React.SetStateAction<boolean>>;
        setAnimated: React.Dispatch<React.SetStateAction<number | boolean>>;
        stopAnimation: () => void;
        modal: boolean;
        unstable_disclosureRef: React.MutableRefObject<HTMLElement | null>;
        setModal: React.Dispatch<React.SetStateAction<boolean>>;
        unstable_referenceRef: React.RefObject<HTMLElement | null>;
        unstable_popoverRef: React.RefObject<HTMLElement | null>;
        unstable_arrowRef: React.RefObject<HTMLElement | null>;
        unstable_popoverStyles: React.CSSProperties;
        unstable_arrowStyles: React.CSSProperties;
        unstable_originalPlacement: "auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start";
        unstable_update: () => boolean;
        placement: "auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start";
        place: React.Dispatch<React.SetStateAction<"auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start">>;
        pickerId: string | undefined;
        dialogId: string | undefined;
        isDisabled: boolean | undefined;
        isReadOnly: boolean | undefined;
        segmentFocus: (() => void) | undefined;
    }, "dialogId"> & React.HTMLAttributes<any> & React.RefAttributes<any> & {
        wrapElement?: ((element: React.ReactNode) => React.ReactNode) | undefined;
    }) => boolean;
    __keys: readonly any[];
    __useOptions: (options: PickerBaseContentOptions, htmlProps: import("reakit/ts").RoleHTMLProps) => PickerBaseContentOptions;
};
export declare const TimePickerContent: import("../system").Component<"div", import("reakit/ts").RoleOptions & Pick<Partial<import("reakit/ts").DisclosureStateReturn>, "baseId" | "visible" | "animating" | "animated" | "stopAnimation"> & Pick<Partial<import("reakit/ts").DialogStateReturn>, "hide" | "modal" | "unstable_disclosureRef"> & Pick<import("reakit/ts").DialogStateReturn, "baseId"> & {
    hideOnEsc?: boolean | undefined;
    hideOnClickOutside?: boolean | undefined;
    preventBodyScroll?: boolean | undefined;
    unstable_initialFocusRef?: React.RefObject<HTMLElement> | undefined;
    unstable_finalFocusRef?: React.RefObject<HTMLElement> | undefined;
    unstable_orphan?: boolean | undefined;
    unstable_autoFocusOnShow?: boolean | undefined;
    unstable_autoFocusOnHide?: boolean | undefined;
} & Pick<Partial<import("reakit/ts").PopoverStateReturn>, "unstable_popoverRef" | "unstable_popoverStyles"> & Pick<{
    baseId: string;
    unstable_idCountRef: React.MutableRefObject<number>;
    visible: boolean;
    animated: number | boolean;
    animating: boolean;
    setBaseId: React.Dispatch<React.SetStateAction<string>>;
    show: () => void;
    hide: () => void;
    toggle: () => void;
    setVisible: React.Dispatch<React.SetStateAction<boolean>>;
    setAnimated: React.Dispatch<React.SetStateAction<number | boolean>>;
    stopAnimation: () => void;
    modal: boolean;
    unstable_disclosureRef: React.MutableRefObject<HTMLElement | null>;
    setModal: React.Dispatch<React.SetStateAction<boolean>>;
    unstable_referenceRef: React.RefObject<HTMLElement | null>;
    unstable_popoverRef: React.RefObject<HTMLElement | null>;
    unstable_arrowRef: React.RefObject<HTMLElement | null>;
    unstable_popoverStyles: React.CSSProperties;
    unstable_arrowStyles: React.CSSProperties;
    unstable_originalPlacement: "auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start";
    unstable_update: () => boolean;
    placement: "auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start";
    place: React.Dispatch<React.SetStateAction<"auto" | "left" | "right" | "auto-start" | "auto-end" | "top-start" | "top" | "top-end" | "right-start" | "right-end" | "bottom-end" | "bottom" | "bottom-start" | "left-end" | "left-start">>;
    pickerId: string | undefined;
    dialogId: string | undefined;
    isDisabled: boolean | undefined;
    isReadOnly: boolean | undefined;
    segmentFocus: (() => void) | undefined;
}, "dialogId"> & React.HTMLAttributes<any> & React.RefAttributes<any> & {
    wrapElement?: ((element: React.ReactNode) => React.ReactNode) | undefined;
}>;
